<?php 
/*
 ****************************************************************
 Copyright (C) 2008-2009 Soft Ventures, Inc. All rights reserved.
 ****************************************************************
 * @package	Appointment Booking Pro - ABPro
 * @copyright	Copyright (C) 2008-2009 Soft Ventures, Inc. All rights reserved.
 * @license	GNU/GPL, see http://www.gnu.org/licenses/gpl-2.0.html
 *
 * ABPro is distributed WITHOUT ANY WARRANTY, or implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header must not be removed. Additional contributions/changes
 * may be added to this header as long as no information is deleted.
 *
 ************************************************************
 The latest version of ABPro is available to subscribers at:
 http://www.appointmentbookingpro.com/
 ************************************************************
 */



defined( '_JEXEC' ) or die( 'Restricted access' );
	include_once( JPATH_SITE."/administrator/components/com_rsappt_pro14/functions_gl.php" );


function addToCalendar($req_id, $apptpro_config){
	 
	if($apptpro_config->which_calendar != 'None'){

		$database = &JFactory::getDBO();
		// get request info 
		$sql = 'SELECT * FROM #__sv_apptpro_requests where id = '.$req_id;
		$database->setQuery($sql);
		$row = NULL;
		$row = $database -> loadObject();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			logIt($database->getErrorMsg()); 
			return false;
		}
		
		// get resource info
		$database = &JFactory::getDBO();
		$res_data = NULL;
		$sql = "SELECT * FROM #__sv_apptpro_resources WHERE id=".$row->resource;
		//echo $sql;
		//exit;
		$database->setQuery($sql);
		$res_data = $database->loadObject();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			logIt($database->getErrorMsg()); 
			return false;
		}
		
		// remove calendar entry
		// First delete calendar record for this request if one exists
		if($apptpro_config->which_calendar == "JEvents"){
			$sql = "DELETE FROM `#__events` WHERE INSTR(extra_info, '[req id:". $row->id ."]')>0";
		} else if($apptpro_config->which_calendar == "JCalPro"){
			$sql = "DELETE FROM `#__jcalpro_events` WHERE INSTR(description, '[req id:". $row->id ."]')>0";
		} else if($apptpro_config->which_calendar == "JCalPro2"){
			$sql = "DELETE FROM `#__jcalpro2_events` WHERE INSTR(description, '[req id:". $row->id ."]')>0";
		} else if($apptpro_config->which_calendar == "Thyme"){
			$sql = "DELETE FROM `thyme_events` WHERE INSTR(notes, '[req id:". $row->id ."]')>0";
		} else if($apptpro_config->which_calendar == "EventList"){
			$sql = "DELETE FROM `#__eventlist_events` WHERE INSTR(datdescription, '[req id:". $row->id ."]')>0";
		} else if($apptpro_config->which_calendar == "Google" and $row->google_event_id != ""){
			include_once( JPATH_SITE."/components/com_rsappt_pro14/svgcal.php" );
			$gcal = new SVGCal;
			// login
				$result = $gcal->login($res_data->google_user, $res_data->google_password);
			if( $result == "ok"){
				$client = $gcal->getClient();	
				if($row->google_calendar_id == ""){
					$gcal->deleteEventById($gcal->getClient(), $row->google_event_id);
				} else {
					$result = $gcal->deleteEvent($gcal->getClient(), $row->google_event_id, $row->google_calendar_id);
					if($result != "ok"){
						echo $result;
						logIt($result); 
					}
				}		
			} else {
				echo $result;
				logIt($result); 
			}						
		}				
		//echo $sql;
		//exit();
		$database->setQuery($sql);
		if(!$database->query()){
			if ($database -> getErrorNum()) {
				if($database -> getErrorNum() != 1146){
					// ignore 1146 - table not found if component not installed
					echo $database -> stderr();
					logIt($database->getErrorMsg()); 
					return false;
				}
			}
		}

		if ($row->request_status == 'accepted'){
			// need cal category
			$cat_err = "";
			if($res_data->default_calendar_category == "" and $apptpro_config->which_calendar != "Google"){
				// cannot continue as we have no calendar category
				$cat_err = "No default calendar category has been specified, cannot add calendar entry!";
			} else {
				// get category id from name
				if($apptpro_config->which_calendar == "EventList"){
					$sql = "SELECT id as cat_id FROM #__eventlist_categories WHERE catname='".$res_data->default_calendar_category."'";
					$database->setQuery( $sql);
					$cat_id = null;
					$cat_id = $database->loadResult(); 
					if ($database -> getErrorNum()) {
						$cat_err = "calendar category, db errpr: ".$database -> stderr();
					}
					if($cat_id == null){
						$cat_err = "Invalid calendar category has been specified, cannot add calendar entry! <br>".$sql;
					}
				} else if($apptpro_config->which_calendar == "JEvents"){
					$sql = "SELECT id FROM #__categories WHERE title='".$res_data->default_calendar_category."' ".
					"AND section = 'com_events'";
					$database->setQuery( $sql);
					$cat_id = null;
					$cat_id = $database->loadResult(); 
					if ($database -> getErrorNum()) {
						$cat_err = "calendar category, db errpr: ".$database -> stderr();
					}
					if($cat_id == null){
						$cat_err = "Invalid calendar category has been specified, cannot add calendar entry! <br>".$sql;
					}

				} else if($apptpro_config->which_calendar == "Thyme"){
					$sql = "SELECT id FROM thyme_calendars WHERE title='".$res_data->default_calendar_category."' ";
					$database->setQuery( $sql);
					$cat_id = null;
					$cat_id = $database->loadResult(); 
					if ($database -> getErrorNum()) {
						$cat_err = "calendar category, db errpr: ".$database -> stderr();
					}
					if($cat_id == null){
						$cat_err = "Invalid calendar category has been specified, cannot add calendar entry! <br>".$sql;
					}

				} else if($apptpro_config->which_calendar == "JCalPro2"){
					$sql = "SELECT cat_id FROM #__jcalpro2_categories WHERE cat_name='".$res_data->default_calendar_category."'";
					$database->setQuery( $sql);
					$cat_id = null;
					$cat_id = $database->loadResult(); 
					if ($database -> getErrorNum()) {
						$cat_err = "calendar category, db errpr: ".$database -> stderr();
					}
					if($cat_id == null){
						$cat_err = "Invalid calendar category has been specified, cannot add calendar entry! <br>".$sql;
					}

					$sql = "SELECT cal_id FROM #__jcalpro2_calendars WHERE cal_name='".$res_data->default_calendar."'";
					$database->setQuery( $sql);
					$cal_id = null;
					$cal_id = $database->loadResult(); 
					if ($database -> getErrorNum()) {
						$cal_err = "calendar category, db errpr: ".$database -> stderr();
					}
					if($cat_id == null){
						$cal_err = "Invalid calendar category has been specified, cannot add calendar entry! <br>".$sql;
					}

				} else if($apptpro_config->which_calendar == "JCalPro"){
					$sql = "SELECT cat_id FROM #__jcalpro_categories WHERE cat_name='".$res_data->default_calendar_category."'";
					$database->setQuery( $sql);
					$cat_id = null;
					$cat_id = $database->loadResult(); 
					if ($database -> getErrorNum()) {
						$cat_err = "calendar category, db errpr: ".$database -> stderr();
					}
					if($cat_id == null){
						$cat_err = "Invalid calendar category has been specified, cannot add calendar entry! <br>".$sql;
					}
				}
			}

			if($cat_err !="" or $cal_err !=""){
				echo $cat_err." ".$cal_err;
				logIt($cat_err); 
				return false;
			}
								
			switch ($apptpro_config->calendar_title) {
			  case 'resource.name': {
				$title_text = $res_data->name;	
				break;
			  }
			  case 'request.name': {
				$title_text = $row->name;	
				break;
			  }
 			  default: {
			    // must be a udf, get udf_value
				$sql = "SELECT udf_value FROM #__sv_apptpro_udfvalues WHERE request_id = ".$req_id." and udf_id=".$apptpro_config->calendar_title;
				$database->setQuery( $sql);
				$title_text = $database->loadResult(); 		
			  }
			}
			if($apptpro_config->calendar_body2 != "") {
				$body_text = buildMessage($req_id, "calendar_body", "No");
			}
			stripslashes($body_text);
			stripslashes($title_text);
			$body_text = str_replace("'", "`", $body_text);
			$title_text = str_replace("'", "`", $title_text);

	
			if($apptpro_config->which_calendar == "EventList"){
				$sql = "INSERT INTO `#__eventlist_events` (`catsid`,`title`, `dates`, `enddates`,".
				"`times`,`endtimes`, `datdescription`, `published`) VALUES (".
				$cat_id.",".
				"'".$title_text."',".
				"'".$row->startdate. "',".
				"'".$row->enddate."',".
				"'".$row->starttime. "',".
				"'".$row->endtime."',".
				"'".$body_text."<BR />[req id:". $row->id ."]', 1".
				")";
			} else if($apptpro_config->which_calendar == "JEvents"){
				$sql = "INSERT INTO `#__events` (`catid`,`title`,`content`,`useCatColor`,`state`,".
				"`created_by`,`created_by_alias`,`publish_up`,`publish_down`, `extra_info`) VALUES (".
				$cat_id.",".
				"'".$title_text."',".
				"'".$res_detail->name."',".
				"1, 1,".
				"'".$user->id."',".
				"'".$user->name."',".
				"'".$row->startdate. " ".$row->starttime."',".
				"'".$row->enddate. " ".$row->endtime."',".
				"'".$body_text."<BR />[req id:". $row->id ."]'".
				")";
			} else if($apptpro_config->which_calendar == "Thyme"){
				// times stores GMT, need to adjust to local based on Joomla time zone setting
				require_once( JPATH_SITE.DS.'configuration.php' );
				$CONFIG = new JConfig();
				$offset = $CONFIG->offset;
				if($apptpro_config->daylight_savings_time == "Yes" 
				   && (strtotime($row->startdate) >= strtotime($apptpro_config->dst_start_date))
				   && (strtotime($row->startdate) <= strtotime($apptpro_config->dst_end_date))){
					$offset = $offset+1;
				}
				$local_startdatetime = strtotime($row->startdate." ".$row->starttime);
				$local_enddatetime = strtotime($row->enddate." ".$row->endtime);
				$gmt_startdatetime = $local_startdatetime + ($offset*3600);	
				$gmt_enddatetime = $local_enddatetime + ($offset*3600);	
				$duration = $gmt_enddatetime - $gmt_startdatetime;

				//convert to min and sec
				$convert_min = $duration/60;
				$convert_sec = $duration % 60;//seconds
				//convert to hours and min
				$convert_hr = floor($convert_min/60);//hours
				$remainder = floor($convert_min % 60);//minutes

				$sql = "INSERT INTO thyme_events (title, starttime, duration, allday, owner, calendar, added, updated, uid, freq, next, notes) ".
				" VALUES (".
				"'".$database->getEscaped($title_text)."',".
				$gmt_startdatetime.",".
				"'".sprintf( '%02d:%02d:00', $convert_hr, $remainder)."',".
				"0, 1,".
				$cat_id.",".				
				time().",".
				time().",".
				"'".md5(uniqid(rand(), true))."',".
				"0, 0,".
				"'".$body_text."<BR />[req id:". $row->id ."]'".				
				")";
			} else if($apptpro_config->which_calendar == "JCalPro"){
				// latest JCalPro stores all times a GMT (UTC-0) so we need to adjust
				// the time based on server time zone setting
				require_once( JPATH_SITE.DS.'configuration.php' );
				$CONFIG = new JConfig();
				$offset = $CONFIG->offset;
				if($apptpro_config->daylight_savings_time == "Yes" 
				   && (strtotime($row->startdate) >= strtotime($apptpro_config->dst_start_date))
				   && (strtotime($row->startdate) <= strtotime($apptpro_config->dst_end_date))){
					$offset = $offset+1;
				}
				if($offset<0){
					$offset_sign = "+";
				} else {
					$offset_sign = "-";
				}	
				$offset = abs($offset);
				
				$startdate = $row->startdate;
				$day = intval(substr($startdate, 8, 2));
				$month = intval(substr($startdate, 5, 2));
				$year = intval(substr($startdate, 0, 4));
				$sql = "INSERT INTO `#__jcalpro_events` (`title` , `cat` , `day` , `month`, `year`, ".
				"`approved` , `start_date` , `end_date` , `recur_type`, `recur_count`, `published`, `description` ) VALUES (". 
				"'".$title_text."',".
				$cat_id.",".
				$day.",".$month.",".$year.",1,".
				"'".$row->startdate. " ".$row->starttime."' ".$offset_sign." INTERVAL ".$offset." HOUR,".
				"'".$row->enddate. " ".$row->endtime."' ".$offset_sign." INTERVAL ".$offset." HOUR,".
				"'', 1, 1, ".
				"'".$body_text." <BR />[req id:". $row->id ."]'".
				")";
			} else if($apptpro_config->which_calendar == "JCalPro2"){
				// latest JCalPro stores all times a GMT (UTC-0) so we need to adjust
				// the time based on server time zone setting
				require_once( JPATH_SITE.DS.'configuration.php' );
				$CONFIG = new JConfig();
				$offset = $CONFIG->offset;
				if($apptpro_config->daylight_savings_time == "Yes" 
				   && (strtotime($row->startdate) >= strtotime($apptpro_config->dst_start_date))
				   && (strtotime($row->startdate) <= strtotime($apptpro_config->dst_end_date))){
					$offset = $offset+1;
				}
				if($offset<0){
					$offset_sign = "+";
				} else {
					$offset_sign = "-";
				}	
				$offset = abs($offset);
				
				$startdate = $row->startdate;
				$day = intval(substr($startdate, 8, 2));
				$month = intval(substr($startdate, 5, 2));
				$year = intval(substr($startdate, 0, 4));
				$sql = "INSERT INTO `#__jcalpro2_events` (`title` , `cal_id`, `cat` , `day` , `month`, `year`, ".
				"`approved` , `start_date` , `end_date` , `recur_type`, `recur_count`, `published`, `description` ) VALUES (". 
				"'".$title_text."',".
				$cal_id.",".
				$cat_id.",".
				$day.",".$month.",".$year.",1,".
				"'".$row->startdate. " ".$row->starttime."' ".$offset_sign." INTERVAL ".$offset." HOUR,".
				"'".$row->enddate. " ".$row->endtime."' ".$offset_sign." INTERVAL ".$offset." HOUR,".
				"'', 1, 1, ".
				"'".$body_text." <BR />[req id:". $row->id ."]'".
				")";
			} else if($apptpro_config->which_calendar == "Google"){			
				include_once( JPATH_SITE."/components/com_rsappt_pro14/svgcal.php" );
				require_once( JPATH_SITE.DS.'configuration.php' );
				$CONFIG = new JConfig();
				$offset = $CONFIG->offset;
				if($apptpro_config->daylight_savings_time == "Yes" 
				   && (strtotime($row->startdate) >= strtotime($apptpro_config->dst_start_date))
				   && (strtotime($row->startdate) <= strtotime($apptpro_config->dst_end_date))){
					$offset = $offset+1;
				}
				$offset = tz_offset_to_string($offset);
				$gcal = new SVGCal;
				// login
				$result = $gcal->login($res_data->google_user, $res_data->google_password);
				if( $result != "ok"){
					echo $result;
					logIt($result); 
					return false;
				}		
				$gcal->setTZOffset($offset);
				// set calendar
				if($res_data->google_default_calendar_name != ""){
					$gcal->setCalID($res_data->google_default_calendar_name);
				}	
				
				//create event
				$event_id_full = $gcal->createEvent( 
				$title_text,
				$body_text, 
				'',
				trim($row->startdate),
				trim($row->starttime),
				trim($row->enddate),
				trim($row->endtime));
					
				$event_id = substr($event_id_full, strrpos($event_id_full, "/")+1);
				// set event ID back in request
				$database = &JFactory::getDBO();
					$sql = "UPDATE #__sv_apptpro_requests SET google_event_id = '".$event_id."', ".
					"google_calendar_id = '".$res_data->google_default_calendar_name."' where id = ".$req_id;
				$database->setQuery($sql);
				if(!$database->query()){
					echo $database -> stderr();
					logIt($database->getErrorMsg()); 
				}
			}
	
			//echo $sql;exit;
			//logIt($sql); 
	
			$database = &JFactory::getDBO();
			$database->setQuery($sql);
			if(!$database->query()){
				if ($database -> getErrorNum()) {
					//if($database -> getErrorNum() != 1146){
						// ignore 1146 - table not found if component not installed	
						echo $database -> stderr();
						logIt($database->getErrorMsg()); 
						return false;
					//}
				}
			}
		}
	} //end if($apptpro_config->which_calendar != 'None')
	return true;
}

function tz_offset_to_string($tzoffset){
	// converts 
	// "0"	-> "+00:00"
	// "2"	-> "+02:00"
	// "2.5"	-> "+02:30"
	// 10	-> "+10:00"
	// 10.5 -> "+10:30"
	// -2	-> "-02:00"
	// -2.5	-> "-02:30"
	// -10	-> "-10:00"
	// -10.5-> "-10:30"
	
	$valOffset = strval($tzoffset);
	if($valOffset == 0){
		return "+00:00";
	}
	$offset_hr_min = explode(".", $tzoffset);
	if($offset_hr_min[1] == "5"){
		$offset_min = ":30";
	}else{
		$offset_min = ":00";
	}	
	
	if($valOffset > 0){
		// + offset
		if(strval($offset_hr_min[0]) < 10){
			$offset_hour = "+0".$offset_hr_min[0];
		} else {
			$offset_hour = "+".$offset_hr_min[0];
		}
	}
	if($valOffset < 0){	
		// - offset
		if(abs(strval($offset_hr_min[0])) < 10){
			$offset_hour = substr($offset_hr_min[0],0,1)."0".substr($offset_hr_min[0],1);			
		} else {
			$offset_hour = $offset_hr_min[0];
		}
	}	
	return $offset_hour.$offset_min;
}	

function count_values($value_to_count, $array_to_check){
	// counts $value_to_count in $array_to_check
	$count = 0;
	if(in_array($value_to_count, $array_to_check)){
		foreach ($array_to_check as $value) {
		    if($value == $value_to_count){
				$count ++;
			}	
		}
		unset($value);		
	}
	
	return $count;		
}

function validEmail($email){
	/**
	Validate an email address.
	Provide email address (raw input)
	Returns true if the email address has the email 
	address format and the domain exists.
	*/
   $isValid = true;
   $atIndex = strrpos($email, "@");
   if (is_bool($atIndex) && !$atIndex)
   {
      $isValid = false;
   }
   else
   {
      $domain = substr($email, $atIndex+1);
      $local = substr($email, 0, $atIndex);
      $localLen = strlen($local);
      $domainLen = strlen($domain);
      if ($localLen < 1 || $localLen > 64)
      {
         // local part length exceeded
         $isValid = false;
      }
      else if ($domainLen < 1 || $domainLen > 255)
      {
         // domain part length exceeded
         $isValid = false;
      }
      else if ($local[0] == '.' || $local[$localLen-1] == '.')
      {
         // local part starts or ends with '.'
         $isValid = false;
      }
      else if (preg_match('/\\.\\./', $local))
      {
         // local part has two consecutive dots
         $isValid = false;
      }
      else if (!preg_match('/^[A-Za-z0-9\\-\\.]+$/', $domain))
      {
         // character not valid in domain part
         $isValid = false;
      }
      else if (preg_match('/\\.\\./', $domain))
      {
         // domain part has two consecutive dots
         $isValid = false;
      }
      else if(!preg_match('/^(\\\\.|[A-Za-z0-9!#%&`_=\\/$\'*+?^{}|~.-])+$/',
                 str_replace("\\\\","",$local)))
      {
         // character not valid in local part unless 
         // local part is quoted
         if (!preg_match('/^"(\\\\"|[^"])+"$/',
             str_replace("\\\\","",$local)))
         {
            $isValid = false;
         }
      }
   }
   return $isValid;
}

function getMinute($strTimeval){
	// gets the minute of the day
	$hours = intval(substr($strTimeval,0,2));
	$mins = intval(substr($strTimeval,3,2));
	return ($hours*60)+$mins;
}

function showrow($res_detail, $grid_date, $weekday){
	//return false if this date is a bookoff or a non-work day, or limited by dates before/after for this resource
	
	//if $grid_date < now, return false. This can happen id the user uses the '<<-' button to move te grid into the past
	if(strtotime($grid_date." 23:59") < strtotime('now')){
		return false;
	}
	// bookoffs
	$database = &JFactory::getDBO(); 
	$sql = "SELECT count(*) FROM #__sv_apptpro_bookoffs WHERE resource_id=".$res_detail->id." AND off_date='".$grid_date."' ".
		" AND full_day='Yes' AND published=1";
	$database->setQuery( $sql );
	//echo $sql;
	//exit;
	if($database->loadResult()>0){
		return false;
	}
	if ($database -> getErrorNum()) {
		echo "DB Err: ". $database -> stderr();
		logIt($database->getErrorMsg()); 
		exit;
	}
	switch($weekday){
		 case '0': {
			if($res_detail->allowSunday == "No"){ return false;}
			break;
		  }
		 case '1': {
			if($res_detail->allowMonday == "No"){ return false;}
			break;
		  }
		 case '2': {
			if($res_detail->allowTuesday == "No"){ return false;}
			break;
		  }
		 case '3': {
			if($res_detail->allowWednesday == "No"){ return false;}
			break;
		  }
		 case '4': {
			if($res_detail->allowThursday == "No"){ return false;}
			break;
		  }
		 case '5': {
			if($res_detail->allowFriday == "No"){ return false;}
			break;
		  }
		 case '6': {
			if($res_detail->allowSaturday == "No"){ return false;}
			break;
		  }
	}

	if($res_detail->disable_dates_before != "Today" and	$res_detail->disable_dates_before != "Tomorrow"){
		// resource has specific dates set
		if(strtotime($grid_date." 23:59") < strtotime($res_detail->disable_dates_before)){
			return false;
		}	
	} 
	if($res_detail->disable_dates_before == "Tomorrow"){
		if(strtotime($grid_date) <= strtotime("now")){
			return false;
		}	
	}

	if($res_detail->disable_dates_before == "XDays"){
		if(strtotime($grid_date) < strtotime("+ ".strval($res_detail->disable_dates_before_days)." day")){
			return false;
		}	
	}


	if($res_detail->disable_dates_after != "Not Set" and $res_detail->disable_dates_after != "XDays"){
		// resource has specific dates set
		if(strtotime($grid_date) > strtotime($res_detail->disable_dates_after)){
			return false;
		}	
	}

	if($res_detail->disable_dates_after == "XDays"){
		if(strtotime($grid_date) >= strtotime("+ ".strval($res_detail->disable_dates_after_days)." day")){
			return false;
		}	
	}
	
	return true;

}

function fullyBooked($booking, $res_row, $apptpro_config){
	// OLD
	// if prevent dupes = yes 
	// AND # of bookings > maxdupes, return true.
/*	if($res_row->prevent_dupe_bookings == 'Yes' ||
		($res_row->prevent_dupe_bookings == 'Global' AND $apptpro_config->prevent_dupe_bookings == 'Yes')){

		$database = &JFactory::getDBO(); 
		$sql = "SELECT count(*) FROM #__sv_apptpro_requests WHERE resource = ".$res_row->id." AND startdate = '".$booking->startdate."'";
		$sql .=" AND starttime='".$booking->starttime."' AND (request_status='accepted' OR request_status='pending') ORDER BY starttime";
		$database->setQuery( $sql );
		$dupescount = $database->loadResult();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			logIt($database->getErrorMsg()); 
			return false;
		}
		if($dupescount > $res_row->max_dupes){
			return true;
		} else {
			return false;
		}
		
	}
*/
	// NEW
	// max_seats = 0 = no limit
	if($res_row->max_seats == 0){
		return false;
	}	
	// max_seats reached?
	$database = &JFactory::getDBO(); 
	if($booking->booked_seats >= $res_row->max_seats){
		return true;
	}	
	// now check to see if there are other bookings and if so how many total seats are booked.
	$currentcount = getCurrentSeatCount($booking->startdate, $booking->starttime, $booking->enddate, $booking->resource);
	if ($currentcount >= $res_row->max_seats){
		return true;
	}

}

function DateAdd($interval, $number, $date) {

/*
		yyyy year 
		q quarter 
		q quarter 
		m month 
		y day of the year 
		d day 
		w weekday 
		ww week 
		h hour 
		n minute 
		s second 
*/

    $date_time_array = getdate($date);
    $hours = $date_time_array["hours"];
    $minutes = $date_time_array["minutes"];
    $seconds = $date_time_array["seconds"];
    $month = $date_time_array["mon"];
    $day = $date_time_array["mday"];
    $year = $date_time_array["year"];

    switch ($interval) {
    
        case "yyyy":
            $year+=$number;
            break;
        case "q":
            $year+=($number*3);
            break;
        case "m":
            $month+=$number;
            break;
        case "y":
        case "d":
        case "w":
            $day+=$number;
            break;
        case "ww":
            $day+=($number*7);
            break;
        case "h":
            $hours+=$number;
            break;
        case "n":
            $minutes+=$number;
            break;
        case "s":
            $seconds+=$number; 
            break;            
    }
       $timestamp= mktime($hours,$minutes,$seconds,$month,$day,$year);
    return $timestamp;
}

function getBookOffDescription($res_detail, $grid_date){
	$database = &JFactory::getDBO(); 
	$sql = "SELECT description FROM #__sv_apptpro_bookoffs WHERE resource_id=".$res_detail->id." AND off_date='".$grid_date."' AND published=1";
	$database->setQuery( $sql );
	$row = $database -> loadObject();
	//echo $sql;
	//exit;
	return $row;
}

// advadm

function getBookings($user, $filter, $resourceFilter, $startdateFilter, $enddateFilter, $direction, $ordering){

	$database = &JFactory::getDBO();

	$lang =& JFactory::getLanguage();
	if($lang->getTag() != ""){
		$sql = "SET lc_time_names = '".str_replace("-", "_", $lang->getTag())."';";
		$database->setQuery($sql);
		if (!$database->query()) {
			echo $database -> getErrorMsg();						
		}
	}
	$sql = "SELECT #__sv_apptpro_requests.*, #__sv_apptpro_resources.resource_admins, ".
			"#__sv_apptpro_resources.name as resname, #__sv_apptpro_services.name AS ServiceName,  ".
			"CONCAT(#__sv_apptpro_requests.startdate,#__sv_apptpro_requests.starttime) as startdatetime, ".
			"DATE_FORMAT(#__sv_apptpro_requests.startdate, '%a %b %e') as display_startdate, ".
			"DATE_FORMAT(#__sv_apptpro_requests.starttime, '%H:%i') as display_starttime ".
			"FROM ( ".
			'#__sv_apptpro_requests LEFT JOIN '.
			'#__sv_apptpro_resources ON #__sv_apptpro_requests.resource = '.
			'#__sv_apptpro_resources.id LEFT JOIN '.
			'#__sv_apptpro_services ON #__sv_apptpro_requests.service = '.
			'#__sv_apptpro_services.id ) '.
			"WHERE ";
		if($filter != ""){
			$sql = $sql." request_status='".$filter."' AND ";
		}
		if($resourceFilter != ""){
			$sql = $sql." resource='".$resourceFilter."' AND ";
		}
		if($startdateFilter != ""){
			$sql = $sql." startdate>='".$startdateFilter."' AND ";
		}
		if($enddateFilter != ""){
			$sql = $sql." enddate<='".$enddateFilter."' AND ";
		}
		$sql = $sql."#__sv_apptpro_resources.resource_admins LIKE '%|".$user->id."|%' ";

		$sql = $sql.' ORDER BY '.$ordering.' '.$direction;
//		$sql = $sql." ORDER BY startdate;";
	//echo $sql;	
	$database->setQuery($sql);
	$rows = NULL;
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	return $rows;

}

function getResources($id, $direction, $ordering){
	$sql = " SELECT ".
		"`#__sv_apptpro_resources`.*, `#__sv_apptpro_categories`.`name` AS ".
		"`cat_name`, `#__sv_apptpro_categories`.`id` AS `cat_id` ".
		"FROM ".
		"`#__sv_apptpro_resources` LEFT JOIN `#__sv_apptpro_categories` ".
		"ON `#__sv_apptpro_resources`.`category_id` = `#__sv_apptpro_categories`.`id` ".	
		"WHERE resource_admins LIKE '%|".$id."|%' ".
		"ORDER BY ".$ordering.' '.$direction;
	//echo $sql;
	$database = &JFactory::getDBO();
	$database->setQuery($sql, $limitstart, $limit );
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	
	return $rows;
}

function publish_resource($option, $cid, $publish = 1)	{
	$database = &JFactory::getDBO();
	setSessionStuff("resource");

	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_resources '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );

		if (!$database->query()) {
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function unpublish_resource($option, $cid, $publish = 0){
	$database = &JFactory::getDBO();
	setSessionStuff("resource");

	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_resources '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function getServices($resource_id, $direction, $ordering){
	$database = &JFactory::getDBO();
	$sql = "SELECT #__sv_apptpro_services.*, #__sv_apptpro_resources.name AS res_name ".
		" FROM #__sv_apptpro_services LEFT JOIN #__sv_apptpro_resources ".
		" ON #__sv_apptpro_services.resource_id = #__sv_apptpro_resources.id ".
		" WHERE resource_id =".$resource_id.
		" ORDER BY ".$ordering.' '.$direction;
		//echo $sql;
		//exit;
	$database->setQuery($sql, $limitstart, $limit );
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}

	return $rows;

}

function publish_service($option, $cid, $publish = 1)	{
	$database = &JFactory::getDBO();
	setSessionStuff("service");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_services '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );

		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function unpublish_service($option, $cid, $publish = 0){
	$database = &JFactory::getDBO();
	setSessionStuff("service");

	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_services '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );
		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}


function getBookoffs($resource_id, $direction, $ordering){
	$database = &JFactory::getDBO();
	$lang =& JFactory::getLanguage();
	if($lang->getTag() != ""){
		$sql = "SET lc_time_names = '".str_replace("-", "_", $lang->getTag())."';";
		$database->setQuery($sql);
		if (!$database->query()) {	
			echo $database -> getErrorMsg();						
		}
	}
	$sql = "SELECT #__sv_apptpro_bookoffs.*, #__sv_apptpro_bookoffs.published, resource_id, #__sv_apptpro_resources.name, ".
		"DATE_FORMAT(off_date, '%W %M %e, %Y') as off_date_display, off_date, ".
		"#__sv_apptpro_bookoffs.description, CONCAT(DATE_FORMAT(bookoff_starttime, '%H:%i'), '-', DATE_FORMAT(bookoff_endtime, '%H:%i')) as hours ".
		"FROM #__sv_apptpro_bookoffs LEFT JOIN #__sv_apptpro_resources ".
		"ON #__sv_apptpro_bookoffs.resource_id = #__sv_apptpro_resources.id ".
		" WHERE resource_id=".$resource_id;
		$sql = $sql." ORDER BY ".$ordering.' '.$direction;
		//echo $sql;
		//exit;
	$database->setQuery($sql, $limitstart, $limit );
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	
	return $rows;

}

function publish_bookoff($option, $cid, $publish = 1)	{
	$database = &JFactory::getDBO();
	setSessionStuff("bookoff");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_bookoffs '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );

		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}
	$session = &JFactory::getSession();
	$session->set("current_tab", 4);
	$session->set("resource_id_FilterBO", JRequest::getVar( 'resource_id_FilterBO' ));

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function unpublish_bookoff($option, $cid, $publish = 0){
	$database = &JFactory::getDBO();
	setSessionStuff("bookoff");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_bookoffs '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );
		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}
	$session = &JFactory::getSession();
	$session->set("current_tab", 4);
	$session->set("resource_id_FilterBO", JRequest::getVar( 'resource_id_FilterBO' ));


	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function getTimeslots($resource_idFilter, $day_numberFilter, $direction, $ordering){

	$filter = "";
	if($day_numberFilter != "" and $day_numberFilter != "all"){
		$filter = $filter."day_number = '".$day_numberFilter."' ";
	}

	if($resource_idFilter == "0"){
		$filter = ($filter != "" ? $filter." and " : $filter);
		$filter = $filter." resource_id = 9999 ";
	} else {
		$filter = ($filter != "" ? $filter." and " : $filter);
		$filter = $filter."resource_id = ".$resource_idFilter." ";
	}

	$database = &JFactory::getDBO();
	$sql = "SELECT #__sv_apptpro_timeslots.id, day_number, #__sv_apptpro_timeslots.published, resource_id, #__sv_apptpro_resources.name, ".
		"TIME_FORMAT(timeslot_starttime,'%H:%i') as timeslot_starttime, ".
		"TIME_FORMAT(timeslot_endtime,'%H:%i') as timeslot_endtime ".
		"FROM #__sv_apptpro_timeslots LEFT JOIN #__sv_apptpro_resources ".
		"ON #__sv_apptpro_timeslots.resource_id = #__sv_apptpro_resources.id ";
		if($filter != ""){
			$sql = $sql." WHERE ".$filter;
		}
		$sql = $sql." ORDER BY ".$ordering.' '.$direction;
//		$sql = $sql." ORDER BY day_number, timeslot_starttime asc"; 
		//echo $sql;
		//exit;
	$database->setQuery($sql, $limitstart, $limit );
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	return $rows;
}

function publish_timeslot($option, $cid, $publish = 1)	{
	$database = &JFactory::getDBO();
	setSessionStuff("timeslot");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_timeslots '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );

		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}
	$session = &JFactory::getSession();
	$session->set("current_tab", 3);
	$session->set("resource_id_FilterTS", JRequest::getVar( 'resource_id_FilterTS' ));
	$session->set("day_numberFilter", JRequest::getVar( 'day_numberFilter' ));

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function unpublish_timeslot($option, $cid, $publish = 0){
	$database = &JFactory::getDBO();
	setSessionStuff("timeslot");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_timeslots '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );
		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}
	$session = &JFactory::getSession();
	$session->set("current_tab", 3);
	$session->set("resource_id_FilterTS", JRequest::getVar( 'resource_id_FilterTS' ));
	$session->set("day_numberFilter", JRequest::getVar( 'day_numberFilter' ));

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}


function getCoupons($direction, $ordering){
	$database = &JFactory::getDBO();
	$sql = "SELECT *, DATE_FORMAT(expiry_date, '%W %M %e, %Y') as expiry FROM #__sv_apptpro_coupons ";
		$sql .= " WHERE scope != '' ORDER BY ".$ordering.' '.$direction;
		//echo $sql;
		//exit;
	$database->setQuery($sql, $limitstart, $limit );
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	
	return $rows;

}

function publish_coupon($option, $cid, $publish = 1)	{
	$database = &JFactory::getDBO();
	setSessionStuff("coupons");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_coupons '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );

		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}
	$session = &JFactory::getSession();
	$session->set("current_tab", 6);

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}

function unpublish_coupon($option, $cid, $publish = 0){
	$database = &JFactory::getDBO();
	setSessionStuff("coupons");
	if (count( $cid ))
	{
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__sv_apptpro_coupons '
			. ' SET published = ' . intval( $publish )
			. ' WHERE id IN ( '.$cids.' )';

		$database->setQuery( $query );
		if (!$database->query()) {
			logIt($database->getErrorMsg()); 
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
	}
	$session = &JFactory::getSession();
	$session->set("current_tab", 6);

	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option='.$option.'&view=Advanced Admin' );
}



function import_global_timeslots($new_resource_id){
	$session = &JFactory::getSession();
	$session->set("current_tab", 3);
	$session->set("resource_id_FilterTS", JRequest::getVar( 'resource_id_FilterTS' ));
	$session->set("day_numberFilter", JRequest::getVar( 'day_numberFilter' ));

	$database = &JFactory::getDBO();
	if ($new_resource_id != '')
	{
		$query = "SELECT * FROM #__sv_apptpro_timeslots "
			." WHERE ISNULL(resource_id) OR resource_id = ''";
		$database->setQuery( $query );
		$rows = $database -> loadObjectList();
		if (!$database->query()) {
			echo $database -> getErrorMsg();
			logIt($database->getErrorMsg()); 
			return false;
		}
		//echo $query."<br>";
		//exit;
		
		//now do inserts
		foreach($rows as $row) {
			$sql = "INSERT INTO #__sv_apptpro_timeslots (day_number,resource_id,timeslot_starttime,timeslot_endtime,published)".
			" VALUES(".$row->day_number.",".$new_resource_id.",'".$row->timeslot_starttime."','".$row->timeslot_endtime."',".$row->published.")";
			//echo $sql."<br>";
			$database->setQuery( $sql );
			if (!$database->query()) {
				echo $database -> getErrorMsg();
				return false;
			}
		}		
	}
	global $mainframe;
	$mainframe->redirect( JURI::base() . 'index.php?option=com_rsappt_pro14&view=Advanced Admin' );
}

function setSessionStuff($screen){

	$session = &JFactory::getSession();

	switch($screen)	{

		case "request":
			$session->set("current_tab", 0);
			$session->set("req_filter_order", JRequest::getVar('req_filter_order', 'startdate'));
			$session->set("req_filter_order_Dir", JRequest::getVar('req_filter_order_Dir', 'asc'));
			$session->set("status_filter", JRequest::getVar('status_filter', ''));
			$session->set("request_resourceFilter", JRequest::getVar('request_resourceFilter', ''));
			$session->set("startdateFilter", JRequest::getVar('startdateFilter', ''));
			$session->set("enddateFilter", JRequest::getVar('enddateFilter', ''));
			$session->set("categoryFilter", JRequest::getVar('categoryFilter', ''));

			$session->set("filter_order", JRequest::getVar('filter_order', 'startdate'));
			$session->set("filter_order_Dir", JRequest::getVar('filter_order_Dir', 'asc'));
			break;

		case "resource":
			$session->set("current_tab", 1);
			$session->set("res_filter_order", JRequest::getVar('res_filter_order', 'name'));
			$session->set("res_filter_order_Dir", JRequest::getVar('res_filter_order_Dir', 'asc'));
			break;
	
		case "service":
			$session->set("current_tab", 2);
			$session->set("srv_filter_order", JRequest::getVar('srv_filter_order', 'name'));
			$session->set("srv_filter_order_Dir", JRequest::getVar('srv_filter_order_Dir', 'asc'));
			$session->set("resource_id_Filter", JRequest::getVar( 'resource_id_Filter' ));
			break;

		case "timeslot":
			$session->set("current_tab", 3);
			$session->set("ts_filter_order", JRequest::getVar('ts_filter_order', 'name'));
			$session->set("ts_filter_order_Dir", JRequest::getVar('ts_filter_order_Dir', 'asc'));
			$session->set("resource_id_FilterTS", JRequest::getVar( 'resource_id_FilterTS' ));
			$session->set("day_numberFilter", JRequest::getVar( 'day_numberFilter' ));
			break;

		case "bookoff":
			$session->set("current_tab", 4);
			$session->set("bo_filter_order", JRequest::getVar('bo_filter_order', 'name'));
			$session->set("bo_filter_order_Dir", JRequest::getVar('bo_filter_order_Dir', 'asc'));
			$session->set("resource_id_FilterBO", JRequest::getVar( 'resource_id_FilterBO' ));
			break;

		case "paypal":
			$session->set("current_tab", 5);
			$session->set("pp_filter_order", JRequest::getVar('pp_filter_order', 'stamp'));
			$session->set("pp_filter_order_Dir", JRequest::getVar('pp_filter_order_Dir', 'desc'));
			break;

		case "front_desk":
			$session->set("front_desk_view", JRequest::getVar('view'));
			$session->set("front_desk_resource_filter", JRequest::getVar('resource_filter'));
			$session->set("front_desk_status_filter", JRequest::getVar('status_filter'));
			$session->set("front_desk_cur_month", JRequest::getVar('cur_month', ''));
			$session->set("front_desk_cur_year", JRequest::getVar('cur_year', ''));
			$session->set("front_desk_cur_week_offset", JRequest::getVar('cur_week_offset', ''));
			$session->set("front_desk_cur_day", JRequest::getVar('cur_day', ''));
			$session->set("front_desk_user_search", JRequest::getVar('user_search', ''));
			break;

	}		
}

function getPayPalTxns($direction, $ordering, $startdateFilter, $enddateFilter){
	$database = &JFactory::getDBO();
	$sql = "SELECT * FROM #__sv_apptpro_paypal_transactions ";	
		$filter = "WHERE ";	
		if($startdateFilter != ""){
			$filter .= " stamp>='".$startdateFilter."' ";
		}
		if($enddateFilter != ""){
			if($filter != "WHERE "){
				$filter .= " AND ";
			}
			$filter .= " stamp<='".$enddateFilter."' ";
		}
		if($filter != "WHERE "){
			$sql .= $filter;
		}
		$sql = $sql." ORDER BY ".$ordering.' '.$direction;
		//echo $sql;
		//exit;
	$database->setQuery($sql, $limitstart, $limit );
	$rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	
	return $rows;

}

function getDayNamesArray(){
	return array(JText::_('RS1_SUN'),
	JText::_('RS1_MON'),
	JText::_('RS1_TUE'),
	JText::_('RS1_WED'),
	JText::_('RS1_THU'),
	JText::_('RS1_FRI'),
	JText::_('RS1_SAT'),
	);
}

function getLongDayNamesArray($starting = 0){
	if($starting == 0){
		return array(JText::_('RS1_SUNDAY'),
				JText::_('RS1_MONDAY'),
				JText::_('RS1_TUESDAY'),
				JText::_('RS1_WEDNESDAY'),
				JText::_('RS1_THURSDAY'),
				JText::_('RS1_FRIDAY'),
				JText::_('RS1_SATURDAY'),
				);
	} else {
		return array(JText::_('RS1_MONDAY'),
				JText::_('RS1_TUESDAY'),
				JText::_('RS1_WEDNESDAY'),
				JText::_('RS1_THURSDAY'),
				JText::_('RS1_FRIDAY'),
				JText::_('RS1_SATURDAY'),
				JText::_('RS1_SUNDAY'),
				);
	}	

}

function getMonthNamesArray(){
	return array(JText::_('RS1_JANUARY'),
	JText::_('RS1_FEBRUARY'),
	JText::_('RS1_MARCH'),
	JText::_('RS1_APRIL'),
	JText::_('RS1_MAY'),
	JText::_('RS1_JUNE'),
	JText::_('RS1_JULY'),
	JText::_('RS1_AUGUST'),
	JText::_('RS1_SEPTEMBER'),
	JText::_('RS1_OCTOBER'),
	JText::_('RS1_NOVEMBER'),
	JText::_('RS1_DECEMBER'),
	);
}

function translated_status($in){
	switch($in){
		case 'new': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NEW');
			break;
		}
		case 'accepted': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ACCEPTED');
			break;
		}
		case 'pending': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_PENDING');
			break;
		}
		case 'declined': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_DECLINED');
			break;
		}
		case 'canceled': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_CANCELED');
			break;
		}
		case 'no_show': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NO_SHOW');
			break;
		}
		case 'attended': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ATTENDED');
			break;
		}
		case 'deleted': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_DELETED');
			break;
		}
		case 'completed': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_COMPLETED');
			break;
		}
		case 'paid': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_PAID');
			break;
		}
		case 'na': {
			return JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NA');
			break;
		}
		
	}
}

function getCBdata($cb_field_name, $userid){

	if($cb_field_name == ""){
		return;
	}
	
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT ".$cb_field_name." FROM #__comprofiler WHERE user_id = ".$userid );
	$retval = $database->loadResult();
	if ($database -> getErrorNum()) {
		if($database -> getErrorNum() != 1146){
			// ignore 1146 - table not found if component not installed
			echo $database -> stderr();
			return false;
		}
		return false;
	}
	return $retval;
	
}

function getJSdata($js_field_name, $userid){
	if($userid == ""){
		return;
	}
	$jspath = JPATH_ROOT . DS . 'components' . DS . 'com_community';
	include_once($jspath. DS . 'libraries' . DS . 'core.php');

	$JSuser =& CFactory::getUser($userid);
	return $JSuser->getInfo($js_field_name);
}


function blocked_by_bookoff($slot, $part_day_bookoffs){
	// Note: $part_day_bookoffs may be multiple ranges for single day
	// If slot starts during bookoff time return true. No test made to determine if slot ends during bookoff 
	// as bookoff range should be made on timeslot boundaries.
	foreach ($part_day_bookoffs as $part_day_bookoff){ 
		if(strtotime($slot->timeorder)+1 >= strtotime($part_day_bookoff->bookoff_starttime)
		 && strtotime($slot->timeorder)+1 <= strtotime($part_day_bookoff->bookoff_endtime)){
			return true;
		}
	}
	 
	return false;
}

function getCurrentSeatCount($startdate, $starttime, $enddate, $resource, $exclude_request=-1){
	
	$database = &JFactory::getDBO();
	$sql = "SELECT Sum(booked_seats) FROM #__sv_apptpro_requests ".
		" WHERE ".
		" id != ".$exclude_request." AND ".
		" startdate = '".$startdate."' AND ".
		" starttime = '".$starttime."' AND ".
		" enddate = '".$enddate."' AND ".
		" resource = ".$resource." AND ".
		"(request_status = 'accepted' or request_status = 'pending') AND ".
		" booked_seats > 0;";

	$database->setQuery( $sql );
	$currentcount = $database->loadResult();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	//echo $currentcount;
	if($currentcount == null){
		return 0;
	} else {
		return $currentcount;
	}

}

function saveToDB($name,$user_id,$unit_number,$phone,$email,$sms_reminders,$sms_phone,$sms_dial_code,$resource,
		$service_name,$startdate,$starttime,$enddate,$endtime,$request_status,$cancel_code,$grand_total,$ammount_due,
		$coupon_code,$booked_seats,$applied_credit,$comment, $admin_comment=''){
		$lang =& JFactory::getLanguage();
		
		$database = &JFactory::getDBO();
		
		// ABPro uses a session variable to prevent duplicate booking if the user does a refresh on the confimration screen.
		// IF the user sits on thet screen for 20 minutes (or whatever your session timeout period is) then does a browser refresh
		// the session variable will be gone and ABPro cannot tell that the cached data from the browser is not new data.
		// Fortunately it seems very rare.
		// I have tried all the tricks for telling the browser not to cache the form but (from searching the Internet) there seems to be 
		// no solution that works universally.
		// If you encounter problems with people refreshing after session time out there are a couple of options:
		// 1.) Put a messge on the confimration screen, like you often see on web sites, telling the person to refrain from using the 
		//    back button or refreshing as it may cause a duplicate booking.
		// 2.) Uncomment thet code below which does a chcek to see if the booking is a duplicate. The down side of this is tat some sites
		//    allow duplictaes and this will stop them.
		
		// check for dupe caused by refresh after session timeout
//		$sql = "Select count(*) FROM #__sv_apptpro_requests WHERE ".
//		"name = '".$database->getEscaped($name)."' ".
//		"AND resource = '".$resource."' ".
//		"AND startdate = '".$startdate."' ".
//		"AND starttime = '".$starttime."' ".
//		"AND enddate = '".$enddate."' ".
//		"AND endtime = '".$endtime."' ".
//		"AND booked_seats = '".$booked_seats."' ".
//		"AND request_status = '".$request_status."' ";
//		$database->setQuery($sql);
//		$dupe_check = $database->loadResult(); 
//		if (!$database->query()) {
//			$err = $database->getErrorMsg();
//			echo $err;
//			exit;
//		} 
//		if($dupe_check > 0){
//			echo "Duplicate booking not saved";
//			exit;
//		}

		if($ammount_due == 0.00){
			$payment_status = "paid";
		} else {
			$payment_status = "pending";
		}
		
		// save to db
		$sSql = "INSERT INTO #__sv_apptpro_requests(".
		"name, ".
		"user_id, ".
		"unit_number, ".
		"phone, ".
		"email, ".
		"sms_reminders, ".
		"sms_phone, ".
		"sms_dial_code, ".
		"resource, ".
		"service, ".
		"startdate, ".
		"starttime, ".
		"enddate, ".
		"endtime, ".
		"request_status, ".
		"payment_status, ".
		"cancellation_id, ".
		"booking_total, ".
		"booking_due, ".
		"credit_used, ".
		"coupon_code, ".
		"booked_seats, ".
		"admin_comment, ".
		"booking_language, ".
		"comment ";
		$sSql = $sSql.") VALUES(".
		"'".$database->getEscaped($name)."',".
		"'".$user_id."',".
		"'".$unit_number."',".
		"'".$database->getEscaped($phone)."',".
		"'".$database->getEscaped($email)."',".
		"'".$sms_reminders."',".
		"'".$database->getEscaped($sms_phone)."',".
		"'".$sms_dial_code."',".
		"'".$resource."',".
		"'".$database->getEscaped($service_name)."',".
		"'".$startdate."',".
		"'".$starttime."',".
		"'".$enddate."',".
		"'".$endtime."',".
		"'".$request_status."',".
		"'".$payment_status."',".
		"'".md5(uniqid(rand(), true))."',".
		$grand_total.",".
		$ammount_due.",".
		$applied_credit.",".
		"'".$coupon_code."',".
		"'".$booked_seats."',".
		"'".$database->getEscaped($admin_comment)."',".
		"'".$lang->getTag()."',".
		"'".$database->getEscaped($comment)."'";
		$sSql = $sSql.")";
		$database->setQuery($sSql);
	
		if (!$database->query()) {
			$err = $database->getErrorMsg();
			echo $err;
			exit;
		} 

		// need request id to pass through to PayPal (so PP can pass it back with IPN)
	 	$sSql = "SELECT LAST_INSERT_ID() AS last_id";
		$database->setQuery($sSql);
		$last_id = NULL;
		$last_id = $database -> loadObject();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return -1;
		}
		
		// if credit used..
		if(floatval($applied_credit) > 0.00){
			// adjust credit balance is
			$sql = "UPDATE #__sv_apptpro_user_credit SET balance = balance - ".$applied_credit." WHERE user_id = ".$user_id;
			$database->setQuery($sql);
			$database->query();
			if ($database -> getErrorNum()) {
				echo $database -> stderr();
				return -1;
			}			
			
			// add credit audit
			$sql = 'INSERT INTO #__sv_apptpro_user_credit_activity (user_id, request_id, decrease, comment, operator_id, balance) '.
			"VALUES (".$user_id.",".
			$last_id->last_id.",".
			$applied_credit.",".
			"'".JText::_('RS1_ADMIN_CREDIT_ACTIVITY_CREDIT_USED')."',".
			$user_id.",".
			"(SELECT balance from #__sv_apptpro_user_credit WHERE user_id = ".$user_id."))";
			$database->setQuery($sql);
			$database->query();
			if ($database -> getErrorNum()) {
				echo $database -> stderr();
				return -1;
			}
			
			// if paid in full by credit, set paystatus to paid
			if(floatval($ammount_due)==0.00){
				$sql = "UPDATE #__sv_apptpro_requests SET payment_status = 'paid' WHERE id = ".$last_id->last_id;
				$database->setQuery($sql);
				$database->query();
				if ($database -> getErrorNum()) {
					echo $database -> stderr();
					return -1;
				}			
			}
		}
		
		return $last_id;		
}

function GoToPayPal($request_id, $apptpro_config, $grand_total){

		if($apptpro_config->paypal_use_sandbox == "Yes"){
			$paypal_url = $apptpro_config->paypal_sandbox_url; 
		} else {
			$paypal_url = $apptpro_config->paypal_production_url; 
		}
		$paypal_url = $paypal_url.'?cmd=_xclick&currency_code='.$apptpro_config->paypal_currency_code.
		"&business=" .$apptpro_config->paypal_account.
		"&return=".JURI::base().urlencode("index.php?option=com_rsappt_pro14&page=return"). // vs page=pdt
		"&notify_url=".JURI::base().urlencode("index.php?option=com_rsappt_pro14&page=ipn"). 
		"&charset=UTF-8";
		if($apptpro_config->paypal_itemname ==""){
			$paypal_url .= "&item_name=".JText::_($res_detail->description).": ".$startdate." ".$starttime;
		} else {
			$itemname = processTokens($request_id, JText::_($apptpro_config->paypal_itemname));
			$paypal_url .= "&item_name=".$itemname;
		}
		if($apptpro_config->paypal_on0 !="" && $apptpro_config->paypal_os0 !=""){
			$on0 = processTokens($request_id, JText::_($apptpro_config->paypal_on0));
			$os0 = processTokens($request_id, JText::_($apptpro_config->paypal_os0));
			$paypal_url .= "&on0=".$on0.
			"&os0=".$os0;
		}
		if($apptpro_config->paypal_on1 !="" && $apptpro_config->paypal_os1 !=""){
			$on1 = processTokens($request_id, JText::_($apptpro_config->paypal_on1));
			$os1 = processTokens($request_id, JText::_($apptpro_config->paypal_os1));
			$paypal_url .= "&on1=".$on1.
			"&os1=".$os1;
		}
		if($apptpro_config->paypal_on2 !="" && $apptpro_config->paypal_os2 !=""){
			$on2 = processTokens($request_id, JText::_($apptpro_config->paypal_on2));
			$os2 = processTokens($request_id, JText::_($apptpro_config->paypal_os2));
			$paypal_url .= "&on2=".$on2.
			"&os2=".$os2;
		}
		if($apptpro_config->paypal_on3 !="" && $apptpro_config->paypal_os3 !=""){
			$on3 = processTokens($request_id, JText::_($apptpro_config->paypal_on3));
			$os3 = processTokens($request_id, JText::_($apptpro_config->paypal_os3));
			$paypal_url .= "&on3=".$on3.
			"&os3=".$os3;
		}
		$paypal_url .= "&amount=".$grand_total.
		"&custom=".strval($request_id);
		if($apptpro_config->paypal_logo_url != ""){
			$paypal_url .= "&image_url=".$apptpro_config->paypal_logo_url;
		}
		//echo $paypal_url;
		//exit;				
		header("Location: ".$paypal_url);
		exit;	

}

function getDefaultCalInfo($which_calendar, $res_data, &$cat_id, &$cal_id){
	$database = &JFactory::getDBO();

	// get category id from name
	if($which_calendar == "EventList"){
		$sql = "SELECT id as cat_id FROM #__eventlist_categories WHERE catname='".$res_data->default_calendar_category."'";
		$database->setQuery( $sql);
		$cat_id = null;
		$cat_id = $database->loadResult(); 

	} else if($which_calendar == "JEvents"){
		$sql = "SELECT id FROM #__categories WHERE title='".$res_data->default_calendar_category."' ".
		"AND section = 'com_events'";
		$database->setQuery( $sql);
		$cat_id = null;
		$cat_id = $database->loadResult(); 

	} else if($which_calendar == "Thyme"){
		$sql = "SELECT id FROM thyme_calendars WHERE title='".$res_data->default_calendar_category."' ";
		$database->setQuery( $sql);
		$cat_id = null;
		$cat_id = $database->loadResult(); 

	} else if($which_calendar == "JCalPro2"){
		$sql = "SELECT cat_id FROM #__jcalpro2_categories WHERE cat_name='".$res_data->default_calendar_category."'";
		$database->setQuery( $sql);
		$cat_id = null;
		$cat_id = $database->loadResult(); 

		$sql = "SELECT cal_id FROM #__jcalpro2_calendars WHERE cal_name='".$res_data->default_calendar."'";
		$database->setQuery( $sql);
		$cal_id = null;
		$cal_id = $database->loadResult(); 

	} else if($which_calendar == "JCalPro"){
		$sql = "SELECT cat_id FROM #__jcalpro_categories WHERE cat_name='".$res_data->default_calendar_category."'";
		$database->setQuery( $sql);
		$cat_id = null;
		$cat_id = $database->loadResult(); 
	}
	return;
}

?>