<?php
/*
 ****************************************************************
 Copyright (C) 2008-2009 Soft Ventures, Inc. All rights reserved.
 ****************************************************************
 * @package	Appointment Booking Pro - ABPro
 * @copyright	Copyright (C) 2008-2009 Soft Ventures, Inc. All rights reserved.
 * @license	GNU/GPL, see http://www.gnu.org/licenses/gpl-2.0.html
 *
 * ABPro is distributed WITHOUT ANY WARRANTY, or implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header must not be removed. Additional contributions/changes
 * may be added to this header as long as no information is deleted.
 *
 ************************************************************
 The latest version of ABPro is available to subscribers at:
 http://www.appointmentbookingpro.com/
 ************************************************************
 */


 
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class rs1Request extends JTable {
	var $id = null;
	var $user_id = null;
	var $name = null;
	var $unit_number = null;
	var $phone = null;
	var $email = null;
	var $resource = null;
	var $starttime = null;
	var $startdate = null;
	var $enddate = null;
	var $endtime = null;
	var $comment = null;
	var $admin_comment = null;
	var $request_status = null;
	var $payment_status = null;
	var $show_on_calendar = null;
	var $calendar_category = null;
	var $calendar_calendar = null;
	var $calendar_comment = null;
	var $created = null;
	var $user_field1_value = null;
	var $user_field2_value = null;
	var $user_field3_value = null;
	var $user_field4_value = null;
	var $cancellation_id = null;
	var $service = null;
	var $txnid = null;
	var $sms_reminders = null;
	var $sms_phone = null;
	var $sms_dial_code = null;
	var $google_event_id = '';
	var $google_calendar_id = '';
	var $booking_total = 0.00;
  	var $booking_due = 0.00;
	var $coupon_code = null;
	var $booked_seats = 0;
	var $booking_language = 'eb-gb';
	var $credit_used = "0.00";

	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_requests', 'id', $db);
	}
	
	function check(){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_requests WHERE id = ".$this->id;
		$database->setQuery($sql);
		$row = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_requests: ";
		$sql = "show columns from #__sv_apptpro_requests ".
			" where Field IN('name','phone','email','resource','starttime','startdate','enddate','endtime','comment',".
				"'admin_comment','request_status','payment_status','show_on_calendar','calendar_category',".
				"'calendar_calendar','calendar_comment','service','sms_reminders','sms_phone','sms_dial_code',". 
				"'booking_total','booking_due','coupon_code','booked_seats');";
		$database->setQuery($sql);
		$tableColumns = $database -> loadObjectList();
		foreach($tableColumns as $tableColumn){
			$fieldName = $tableColumn->Field;
			if($row[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($row[$fieldName]==""?"<empty>":$row[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_requests:"){
			LogActivity(intval($this->id), $desc);
		}

		return true;
	}
}

class rs1Resource extends JTable {
	var $id = null;
	var $category_id = 0;
	var $name = null;
	var $description = null;
	var $cost = null;
	var $display_order = 1;
	var $resource_email = null;
	var $prevent_dupe_bookings = "Global";
	var $max_dupes = 0;
	var $resource_admins = null;
	var $rate = null;
	var $rate_unit = "Hour";
	var $allowSunday = "Yes";
	var $allowMonday = "Yes";
	var $allowTuesday = "Yes";
	var $allowWednesday = "Yes";
	var $allowThursday = "Yes";
	var $allowFriday = "Yes";
	var $allowSaturday = "Yes";
	var $timeslots = "Global"; // Global or Specific
	var $disable_dates_before = "Tomorrow";
	var $disable_dates_before_days = 0;
	var $min_lead_time = 1;
	var $disable_dates_after = "Not Set";
	var $disable_dates_after_days = 0;
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $published = null;
	var $default_calendar_category = 'General';
	var $default_calendar = 'Default';
	var $sms_phone = null;
	var $google_user = null;
	var $google_password = null;
	var $google_default_calendar_name = null;
	var $access = 'everyone';
	var $enable_coupons = "No";
	var $max_seats = 1;
	var $non_work_day_message = "";
	var $non_work_day_hide = "Yes";
	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_resources', 'id', $db);
	}

	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_resources WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_config: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		
//		$row = $database -> loadAssoc();
//		
//		$desc = "Table #__sv_apptpro_resources: ";
//		$sql = "show columns from #__sv_apptpro_resources ".
//			" where Field IN('category_id','name','description','cost','display_order','resource_email','resource_admins', ".
//			" 'rate','rate_unit','allowSunday','allowMonday','allowTuesday','allowWednesday','allowThursday', ".
//			" 'allowFriday','allowSaturday','timeslots','disable_dates_before','disable_dates_before_days', ".
//			" 'min_lead_time','disable_dates_after','disable_dates_after_days','published', ".
//			" 'default_calendar_category','default_calendar','sms_phone','google_user','google_password', ".
//			" 'google_default_calendar_name','access','enable_coupons','max_seats','non_work_day_message');";
//		$database->setQuery($sql);
//		$tableColumns = $database -> loadObjectList();
//		foreach($tableColumns as $tableColumn){
//			$fieldName = $tableColumn->Field;
//			if($row[$fieldName] != $this->$fieldName){
//				$desc .= $fieldName.": (".($row[$fieldName]==""?"<empty>":$row[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
//			}
//		}
		if(desc != "Table #__sv_apptpro_resources:"){
			LogActivity(intval($this->id), $desc);
		}

		return true;
	}


}

class rs1TimeSlots extends JTable {
	var $id = null;
	var $resource_id = null;
	var $day_number = null;
	var $timeslot_starttime = null;
	var $timeslot_endtime = null;
	var $timeslot_description = null;
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $published = null;
	var $start_publishing = null;
	var $end_publishing = null;
	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_timeslots', 'id', $db);
	}
	
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_timeslots WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_timeslots: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_timeslots:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
	
}

class rs1RequestConf extends JTable {
	var $configid = null;
	var $mailTO = null;
	var $mailFROM = null;
	var $mailSubject = null;
	var $useUnit = null;
	var $requireLogin = null;
	var $headerText = null;
	var $footerText = null;
	var $user_field1_label = null;
	var $user_field2_label = null;
	var $user_field3_label = null;
	var $user_field4_label = null;
	var $user_field1_display = null;
	var $user_field2_display = null;
	var $user_field3_display = null;
	var $user_field4_display = null;
	var $user_field1_help = null;
	var $user_field2_help = null;
	var $user_field3_help = null;
	var $user_field4_help = null;
	var $user_field1_required = null;
	var $user_field2_required = null;
	var $user_field3_required = null;
	var $user_field4_required = null;
	var $which_calendar = null;
	var $calendar_title = null;
	var $calendar_body = null;
	var $calendar_body2 = null;
	var $prevent_dupe_bookings = null;
	var $requirePhone = null;
	var $requireEmail = null;
	var $multiDay = null;
	var $allowSunday = null;
	var $allowMonday = null;
	var $allowTuesday = null;
	var $allowWednesday = null;
	var $allowThursday = null;
	var $allowFriday = null;
	var $allowSaturday = null;
	var $hoursLimit = null;
	var $timeRangeStart = null;
	var $timeRangeEnd = null;
	var $timeIncrement = null;
	var $bookingIncrement = null;
	var $timeFormat = null;
	var $accept_when_paid = null;
	var $enable_paypal = null;
	var $additional_fee = null;
	var $fee_rate = null;
	var $paypal_button_url = null;
	var $paypal_logo_url = null;
	var $paypal_currency_code = null;
	var $paypal_account = null;
	var $paypal_sandbox_url = null;
	var $paypal_use_sandbox = null;
	var $paypal_production_url = null; 
	var $paypal_identity_token = null;
	var $html_email = null;
	var $timeSlotMode = null;
	var $booking_succeeded = null;
	var $booking_succeeded_sms = null;
	var $booking_in_progress = null;
	var $booking_in_progress_sms = null;
	var $booking_cancel = null;
	var $booking_cancel_sms = null;
	var $booking_too_close_to_cancel = null;
	var $booking_reminder = null;
	var $booking_reminder_sms = null;
	var $auto_accept = null;
	var $hide_logo = null;
	var $allow_cancellation = null;
	var $hours_before_cancel = null;
	var $use_div_calendar = null;
	var $def_gad_grid_start =  null;
	var $def_gad_grid_end =  null;
	var $gad_grid_start_day = null;
	var $gad_grid_width = null;
	var $gad_name_width = null;
	var $gad_grid_num_of_days = null;
	var $gad_booked_image = null;
	var $gad_available_image = null;
	var $enable_clickatell = null;
	var $clickatell_user = null;
	var $clickatell_password = null;
	var $clickatell_api_id = null;
	var $clickatell_dialing_code = null;
	var $clickatell_what_to_send = null;
	var $clickatell_show_code = null;
	var $clickatell_enable_unicode = null;
	var $gad_grid_start_day_days = null;
	var $google_user = null;
	var $google_password = null;
	var $google_default_calendar_name = null;
	var $name_cb_mapping = null;
	var $name_read_only = null;
	var $phone_cb_mapping = null;
	var $phone_read_only = null;
	var $email_cb_mapping = null;
	var $email_read_only = null;
	var $daylight_savings_time = null;
	var $popup_week_start_day = null;
	var $enable_coupons = null;
	var $show_available_seats = null;
	var $gad_grid_hide_startend = null;
	var $limit_bookings = null;
	var $activity_logging = null;
	var $phone_js_mapping = null;
	var $paypal_itemname = null;
	var $paypal_on0 = null;
	var $paypal_os0 = null;
	var $paypal_on1 = null;
	var $paypal_os1 = null;
	var $paypal_on2 = null;
	var $paypal_os2 = null;
	var $paypal_on3 = null;
	var $paypal_os3 = null;
	var $allow_user_credit_refunds = null;
	var $use_gad2 = null;
	var $dst_start_date = null;
	var $dst_end_date = null;
	
	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_config', 'configid', $db);
	}

	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_config WHERE configid = 1";
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_config: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_config:"){
			LogActivity(intval($this->id), $desc);
		}

		return true;
	}

}

class rs1PayPalTransactions extends JTable {
	var $id = null;
	var $txnid = null;
	var $custom = null;
	var $firstname = null;
	var $lastname = null;
	var $buyer_email = null;
	var $street = null;
	var $city = null;
	var $state = null;
	var $zipcode = null;
	var $memo = null;
	var $itemname = null;
	var $itemnumber = null;
	var $os0 = null;
	var $on0 = null;
	var $os1 = null;
	var $on1 = null;
	var $quantity = null;
	var $paymentdate = null;
	var $paymenttype = null;
	var $mc_gross = null;
	var $mc_fee = null;
	var $paymentstatus = null;
	var $pendingreason = null;
	var $txntype = null;
	var $tax = null;
	var $mc_currency = null;
	var $reasoncode = null;
	var $country = null;
	var $datecreation = null;
	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_paypal_transactions', 'id', $db);
	}
}

class rs1Errorlog extends JTable {
	var $id = null;
	var $stamp = null;
	var $description = null;
	var $sql_data = null;
	var $err_type = null;
	var $err_severity = null;
	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_errorlog', 'id', $db);
	}
}

class rs1BookOffs extends JTable {
	var $id = null;
	var $resource_id = null;
	var $description = null;
	var $off_date = null;
	var $full_day = "Yes";
	var $bookoff_starttime = null;
	var $bookoff_endtime = null;
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;
	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_bookoffs', 'id', $db);
	}
	
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_bookoffs WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_bookoffs: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_bookoffs:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}

}


class rs1Categories extends JTable {
	var $id = null;
	var $name = null;
	var $description = null;
	var $parent_category = null;
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;

	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_categories', 'id', $db);
	}
	
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_categories WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_categories: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_categories:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
	
}

class rs1Services extends JTable {
	var $id = null;
	var $resource_id = null;
	var $name = null;
	var $description = null;
	var $service_rate = 0.0;
	var $service_rate_unit = "Hour";
	var $service_duration = 0;
	var $service_duration_unit = "Minute";
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;

	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_services', 'id', $db);
	}
	
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_services WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_services: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_services:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
	
}

class rs1Udfs extends JTable {
	var $id = null;
	var $udf_label = null;
	var $udf_type = "Textbox";
	var $udf_size = "40";
	var $udf_rows = "2";
	var $udf_cols = "40";
	var $udf_radio_options = "";
	var $udf_required = "No";
	var $udf_help = "";
	var $udf_tooltip = "";
	var $cb_mapping = '';
	var $read_only = 'No';
	var $js_mapping = '';
	var $js_read_only = 'No';
	var $scope = "";
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;

	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_udfs', 'id', $db);
	}

	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_udfs WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_udfs: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_udfs:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
	
}

class rs1Reminderlog extends JTable {
	var $id = null;
	var $request_id = null;
	var $user_id = null;
	var $name = null;
	var $stamp = null;
	var $description = null;
	var $local_time = null;

	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_reminderlog', 'id', $db);
	}
}


class rs1Coupons extends JTable {
	var $id = null;
	var $description = null;
	var $coupon_code = null;
	var $discount = 10;
	var $discount_unit = 'percent';
	var $max_total_use = 0;
	var $max_user_use = 0;
	var $expiry_date = null;
	var $scope = "";
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;

	
	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_coupons', 'id', $db);
	}
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_coupons WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_coupons: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_coupons:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
}

class rs1SeatTypes extends JTable {
	var $id = null;
  	var $seat_type_label = null;
  	var $seat_type_tooltip = null;
	var $seat_type_cost = '0.00';
	var $default_quantity = 0;
	var $seat_type_help = null;
	var $seat_group = "No";
	var $seat_group_max = 5;
	var $scope = "";
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;

	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_seat_types', 'id', $db);
	}
	
	
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_seat_types WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_seat_types: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_seat_types:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
		
}


class rs1SeatCounts extends JTable {
	var $id = null;
	var $seat_type_id = null;
	var $request_id = null;
	var $seat_type_qty = 0;

	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_seat_counts', 'id', $db);
	}
}


class rs1Extras extends JTable {
	var $id = null;
	var $extras_label = null;
	var $extras_tooltip = null;
	var $extras_cost = '0.00';
	var $cost_unit = "Hour";
	var $default_quantity = 0;
	var $max_quantity = 1;
	var $extras_help = null;
	var $resource_scope = null;
	var $service_scope = null;
	var $checked_out = 0;
	var $checked_out_time = 0;
	var $ordering = 1;
	var $published = 0;

	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_extras', 'id', $db);
	}
	
	
	function check($formColumns){
		// Audit changes
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__sv_apptpro_extras WHERE id = ".$this->id;
		$database->setQuery($sql);
		$oldrow = $database -> loadAssoc();
		
		$desc = "Table #__sv_apptpro_extras: ";
		$arrayColNames = array_keys($formColumns);
		for($i=0; $i<count($arrayColNames);$i++){
			$fieldName = $arrayColNames[$i];
			if($oldrow[$fieldName] != $this->$fieldName){
				$desc .= $fieldName.": (".($oldrow[$fieldName]==""?"<empty>":$oldrow[$fieldName])." to ".($this->$fieldName==""?"<empty>":$this->$fieldName)."), ";
			}
		}
		if(desc != "Table #__sv_apptpro_extras:"){
			LogActivity(intval($this->id), $desc);
		}
		
		return true;
	}
	
	
}


class rs1ExtrasData extends JTable {
	var $id = null;
	var $extras_id = null;
	var $request_id = null;
	var $extras_qty = 0;

	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_extras_data', 'id', $db);
	}
}

class rs1UserCredit extends JTable {
	var $id = null;
	var $user_id = null;
	var $balance = 0.00;

	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_user_credit', 'id', $db);
	}
}


class rs1UserCreditActivity extends JTable {
	var $id = null;
	var $user_id = null;
	var $request_id = null;
	var $increase = null;
	var $decrease = null;
	var $comment = null;
	var $balance = 0.00;
	var $operator_id = null;
	var $stamp = null;

	function __construct(&$db) {
		parent::__construct('#__sv_apptpro_user_credit_activity', 'id', $db);
	}
}



?>
