<?php
/*
 ****************************************************************
 Copyright (C) 2008-2009 Soft Ventures, Inc. All rights reserved.
 ****************************************************************
 * @package		Appointment Booking Pro - ABPro
 * @copyright	Copyright (C) 2008-2009 Soft Ventures, Inc. All rights reserved.
 * @license		GNU/GPL, see http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 *
 * ABPro is distributed WITHOUT ANY WARRANTY, or implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header must not be removed. Additional contributions/changes
 * may be added to this header as long as no information is deleted.
 *
 ************************************************************
 The latest version of ABPro is available to subscribers at:
 http://www.appointmentbookingpro.com/
 ************************************************************
 */

// no direct access
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

include( JPATH_SITE."/plugins/system/legacy/pagination.php" );

include( JPATH_SITE."/administrator/components/com_rsappt_pro14/backup.php" );
include( JPATH_SITE."/administrator/components/com_rsappt_pro14/restore.php" );


class HTML_rs1{

function edit( $option, &$row ) {

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get data for dropdowns
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources ORDER BY display_order" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	$sql = "SELECT #__sv_apptpro_services.* ".
		"FROM #__sv_apptpro_services LEFT JOIN #__sv_apptpro_resources ".
		"ON #__sv_apptpro_services.resource_id = #__sv_apptpro_resources.id ".
		"WHERE #__sv_apptpro_services.published = 1 AND #__sv_apptpro_resources.published = 1 ".
		"AND #__sv_apptpro_services.resource_id = ".$row->resource." ORDER BY name ";	
	$database->setQuery( $sql );
	$srv_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}


	// calendar categories
	if($apptpro_config->which_calendar == "JEvents"){
		$sql = "SELECT id,title FROM #__categories WHERE section = 'com_events' order by title";
	} else if($apptpro_config->which_calendar == "JCalPro"){
		$sql = "SELECT cat_id as id, cat_name as title FROM #__jcalpro_categories order by cat_name";
	} else if($apptpro_config->which_calendar == "JCalPro2"){
		$sql = "SELECT cat_id as id, cat_name as title FROM #__jcalpro2_categories";
	} else if($apptpro_config->which_calendar == "Thyme"){
		$sql = "SELECT id, title FROM thyme_calendars order by title";
	} else if($apptpro_config->which_calendar == "EventList"){
		$sql = "SELECT id, catname as title FROM #__eventlist_categories order by catname";
	}	
	$database->setQuery($sql);
	$cal_cat_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$noCats = "";
	if(count($cal_cat_rows)<1){
		$noCats = JText::_('RS1_ADMIN_SCRN_NO_CAL_CATS');
	}

	// default calendar (JCalPro 2 only)
	if($apptpro_config->which_calendar == "JCalPro2"){
		$sql = "SELECT cal_id as id, cal_name as title FROM #__jcalpro2_calendars";
	}	
	$database->setQuery($sql);
	$cal_cal_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}

	// get udf values
	$database = &JFactory::getDBO(); 
	//$sql = 'SELECT * FROM #__sv_apptpro_udfs WHERE published=1 ORDER BY ordering';
	$sql = "SELECT ".
  	"#__sv_apptpro_udfs.udf_label, #__sv_apptpro_udfs.udf_type, ".
  	"#__sv_apptpro_udfvalues.udf_value, ".
  	"#__sv_apptpro_udfvalues.request_id ".
  	"FROM ".
  	"#__sv_apptpro_udfvalues INNER JOIN ".
  	"#__sv_apptpro_udfs ON #__sv_apptpro_udfvalues.udf_id = ".
  	"#__sv_apptpro_udfs.id ".
  	"WHERE ".
  	"#__sv_apptpro_udfvalues.request_id = ".$row->id. " ".
  	"ORDER BY ordering ";
	$database->setQuery($sql);
	$udf_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo "DB Err: ". $database -> stderr();
		return false;
	}

	// get seat types
	$database = &JFactory::getDBO(); 
	$sql = 'SELECT * FROM #__sv_apptpro_seat_types WHERE published=1 ORDER BY ordering';
	$database->setQuery($sql);
	$seat_type_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo "DB Err: ". $database -> stderr();
		return false;
	}

	
	// get seat values
	$database = &JFactory::getDBO(); 
	$sql = "SELECT seat_type_id, seat_type_label, seat_type_qty FROM ".
	" #__sv_apptpro_seat_counts INNER JOIN #__sv_apptpro_seat_types ".
	"   ON #__sv_apptpro_seat_counts.seat_type_id = #__sv_apptpro_seat_types.id ".
	" WHERE #__sv_apptpro_seat_counts.request_id = ".$row->id. " ".
  	" ORDER BY ordering ";
	$database->setQuery($sql);
	$seat_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo "DB Err: ". $database -> stderr();
		return false;
	}

	// get extras data
	$database = &JFactory::getDBO(); 
	$sql = "SELECT extras_id, extras_label, extras_qty, extras_tooltip, max_quantity FROM ".
	" #__sv_apptpro_extras_data INNER JOIN #__sv_apptpro_extras ".
	"   ON #__sv_apptpro_extras_data.extras_id = #__sv_apptpro_extras.id ".
	" WHERE #__sv_apptpro_extras_data.request_id = ".$row->id. " ".
  	" ORDER BY ordering ";
	//echo $sql;
	$database->setQuery($sql);
	$extras_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo "DB Err: ". $database -> stderr();
		return false;
	}

?>
<style type="text/css">
<!--
.style1 {
	color: #FF0000
}
.adminForm {
	text-align:left;
}
-->
</style>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript" src="../administrator/components/com_rsappt_pro14/scripts2.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<script>
	function setstarttime(){
		document.getElementById("starttime").value = document.getElementById("starttime_hour").value + ":" + document.getElementById("starttime_minute").value + ":00";
	}
	function setendtime(){
		document.getElementById("endtime").value = document.getElementById("endtime_hour").value + ":" + document.getElementById("endtime_minute").value + ":00";
	}

	function calcSeatTotal(){
		if(document.getElementById("seat_type_count") != null && document.getElementById("seat_type_count").value > 0 ){
			var seat_count = 0; 
			rate = 0.00;
			for(i=0; i<parseInt(document.getElementById("seat_type_count").value); i++){
				seat_name_cost = "seat_type_cost_"+i;
				seat_name = "seat_"+i;
				group_seat_name = "seat_group_"+i;
				seat_count += parseInt(document.getElementById(seat_name).value);
			}
			document.getElementById("booked_seats_div").innerHTML = seat_count;
			document.getElementById("booked_seats").value = seat_count;
		}
	}

</script>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="2" cellspacing="0" >
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_REQ_ID_COL_HEAD');?>: </td>
      <td width="40%"><?php echo $row->id; ?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_NAME_COL_HEAD');?>:<span class="style1">*</span> </td>
      <td width="40%"><input type="text" size="50" maxsize="100" name="name" value="<?php echo stripslashes($row->name); ?>" />
      <input type="hidden" name="user_id" value="<?php echo $row->user_id; ?>" /></td>
      <td rowspan="15" valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_DETAIL_HELP');?></td>
    </tr>
<!--    <tr>
      <td width="95">Unit Number: </td>
      <td width="40%"><input type="text" size="5" maxsize="10" name="unit_number" value="<?php echo $row->unit_number; ?>" /></td>
    </tr>-->
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_PHONE_COL_HEAD');?>:</td>
      <td width="40%"><input type="text" size="20" maxsize="20" name="phone" value="<?php echo $row->phone; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_EMAIL_COL_HEAD');?>:<span class="style1">*</span> </td>
      <td width="40%"><input type="text" size="50" maxsize="80" name="email" value="<?php echo $row->email; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_USE_SMS_COL_HEAD');?>:</td>
      <td><select name="sms_reminders" >
          <option value="Yes" <?php if( $row->sms_reminders == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if( $row->sms_reminders == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
    </select>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SMS_PHONE_COL_HEAD');?>:</td>
      <td><input type="text" size="20" maxsize="20" name="sms_phone" value="<?php echo $row->sms_phone; ?>" />&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SMS_DIAL_CODE_COL_HEAD');?>:</td>
      <td><input type="text" size="3" maxsize="20" name="sms_dial_code" value="<?php echo $row->sms_dial_code; ?>" />&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_RESID_COL_HEAD');?>:</td>
      <td width="40%"><select name="resource" id="resource" onchange="changeResource();">
          <?php
	$k = 0;
	for($i=0; $i < count( $res_rows ); $i++) {
	$res_row = $res_rows[$i];
	?>
          <option value="<?php echo $res_row->id; ?>" <?php if($row->resource == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
          <?php $k = 1 - $k; 
	} ?>
        </select> 
      <br /><span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_SCRN_RES_NOTE_COL_HEAD');?></span></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_COL_HEAD');?>:</td>
      <td><select name="service" id="service">
          <?php
			$k = 0;
			for($i=0; $i < count( $srv_rows ); $i++) {
			$srv_row = $srv_rows[$i];
			?>
          <option value="<?php echo $srv_row->id; ?>" <?php if($row->service == $srv_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($srv_row->name); ?></option>
          <?php $k = 1 - $k; 
			} ?>
        </select>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_STARTDATE');?>:<span class="style1">*</span> </td>
      <td width="40%"><input type="text" size="10" maxsize="10" name="startdate" value="<?php echo $row->startdate; ?>" />
        <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].startdate,'anchor1','yyyy-MM-dd'); return false;"
					 name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_STARTTIME');?>:</td>
      <td width="40%"><select name="starttime_hour" id="starttime_hour" onchange="setstarttime();" class="admin_dropdown">
      	<?php 
		for($x=0; $x<24; $x+=1){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->starttime,0,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select> : 
		<select name="starttime_minute" id="starttime_minute" onchange="setstarttime();" class="admin_dropdown" >
		<?php
		for($x=0; $x<59; $x+=1){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->starttime,3,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>        
         <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_HINT');?>
         <input type="hidden" name="starttime" id="starttime" value="<?php echo $row->starttime ?>" />        </td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_ENDDATE');?>:<span class="style1">*</span> </td>
      <td width="40%"><input type="text" size="10" maxsize="10" name="enddate" value="<?php echo $row->enddate; ?>" />
        <a href="#" id="anchor2" onclick="cal.select(document.forms['adminForm'].enddate,'anchor2','yyyy-MM-dd'); return false;"
					 name="anchor2"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_ENDTIME');?>:</td>
      <td width="40%"><select name="endtime_hour" id="endtime_hour" onchange="setendtime();" class="admin_dropdown">
      	<?php 
		for($x=0; $x<24; $x+=1){

			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->endtime,0,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select> : 
		<select name="endtime_minute" id="endtime_minute" onchange="setendtime();" class="admin_dropdown" >
		<?php
		for($x=0; $x<59; $x+=1){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->endtime,3,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>        
         <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_HINT');?>
         <input type="hidden" name="endtime" id="endtime" value="<?php echo $row->endtime ?>" />		</td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKED_SEATS');?>:</td>
      <td width="40%"><div id="booked_seats_div"><?php echo $row->booked_seats; ?></div><input type="hidden" size="2" maxsize="3" name="booked_seats" id="booked_seats" value="<?php echo $row->booked_seats; ?>" /></td>
    </tr>
	<?php 
	$si = 0; 
	if(count($seat_type_rows)>0){ ?>
		<tr >
		  <td width="12%" valign="top" class="admin_detail_row0"></td>
		  <td colspan="2">
                <table border="0" cellpadding="2" cellspacing="1" >
	<?php foreach($seat_type_rows as $seat_type_row){ 
			$thiscount = 0;
	        for($i=0; $i < count( $seat_rows ); $i++) {
    	    	if($seat_type_row->id == $seat_rows[$i]->seat_type_id){
					$thiscount = $seat_rows[$i]->seat_type_qty;
				}
			}  ?>

			<tr>
			  <td><?php echo $seat_type_row->seat_type_label?>:</td>
			  <td colspan="3" valign="top">
			  <select name="seat_<?php echo $si ?>" id="seat_<?php echo $si?>" onChange="calcSeatTotal();"  
				title="<?php echo $seat_type_row->seat_type_tooltip ?>"  />
				<?php for($i=0; $i<=$seat_type_row->seat_group_max; $i++){ ?>
						<option value="<?php echo $i ?>" <?php echo ($i == $thiscount?'selected':'') ?>><?php echo $i ?></option>	        
				<?php } ?>
			   </select> 
				&nbsp;
				<input type="hidden" name="seat_type_cost_<?php echo $si?>" id="seat_type_cost_<?php echo $si?>" value="<?php echo $seat_type_row->seat_type_cost ?>"/>  
				<input type="hidden" name="seat_type_id_<?php echo $si?>" id="seat_type_id_<?php echo $si?>" value="<?php echo $seat_type_row->id ?>"/>  
				<input type="hidden" name="seat_group_<?php echo $si?>" id="seat_group_<?php echo $si?>" value="<?php echo $seat_type_row->seat_group ?>"/>  
				<input type="hidden" name="seat_type_org_qty_<?php echo $si?>" id="seat_type_org_qty_<?php echo $si?>" value="<?php echo $thiscount ?>"/>  
			  </td>
			</tr>
			<?php $si += 1; 
		} ?>
        </table></td></tr>
	<?php } ?>    
	<?php 
	$ei = 0; 
	if(count($extras_rows)>0){ ?>
        <tr class="admin_detail_row1">
          <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS');?>:</td>
          <td width="40%"></td>
        </tr>

		<tr class="admin_detail_row1">
		  <td width="12%" valign="top" ></td>
		  <td colspan="2">
                <table border="0" cellpadding="2" cellspacing="1" >
	<?php foreach($extras_rows as $extras_row){ ?>
			<tr class="admin_detail_row1">
			  <td><?php echo $extras_row->extras_label?>:</td>
			  <td colspan="3" valign="top"><?php echo $extras_row->extras_qty ?>
				&nbsp;
			  </td>
			</tr>
			<?php $ei += 1; 
		} ?>
        </table></td></tr>
	<?php } ?>    
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_COMMENT');?>:</td>
      <td width="40%"><?php echo $row->comment; ?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td colspan="2" valign="top"><u><?php echo JText::_('RS1_ADMIN_SCRN_UDF');?></u></td>
      <td>&nbsp;</td>
    </tr>
    <?php if(count($udf_rows > 0)){?>
		<tr >
		  <td width="12%" valign="top" class="admin_detail_row0"></td>
		  <td colspan="2">
                <table border="0" cellpadding="2" cellspacing="1" >
                  <tr>
                    <td style="font-weight:bold; border-bottom:#999999 solid 1px"><?php echo JText::_('RS1_ADMIN_SCRN_LABEL');?></td>
                    <td style="font-weight:bold; border-bottom:#999999 solid 1px"><?php echo JText::_('RS1_ADMIN_SCRN_VALUE');?></td>
                    <td style="font-weight:bold; border-bottom:#999999 solid 1px"><?php echo JText::_('RS1_ADMIN_SCRN_TYPE');?></td>
                  </tr>
        <?php 
		$k = 0;
        for($i=0; $i < count( $udf_rows ); $i++) {
        	$udf_row = $udf_rows[$i];
        	?>
                  <tr class="admin_detail_row0">
                    <td valign="top"><?php echo stripslashes($udf_row->udf_label)?></td>
                    <td valign="top"><?php echo stripslashes($udf_row->udf_value)?></td>
                    <td valign="top"><?php echo stripslashes($udf_row->udf_type)?></td>
                  </tr>
          <?php $k = 1 - $k; 
		} ?>
                </table>          </td>
        </tr>
    <?php }?>
    
    <tr class="admin_detail_row0">
      <td width="12%" valign="top">&nbsp;</td>
      <td width="40%">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1" >
      <td width="12%" style=" border-top:#999999 solid 1px"><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS');?>: </td>
      <td width="40%" style=" border-top:#999999 solid 1px"><select name="request_status">
          <option value="new" <?php if($row->request_status == "new"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NEW');?></option>
          <option value="accepted" <?php if($row->request_status == "accepted"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ACCEPTED');?></option>
          <option value="pending" <?php if($row->request_status == "pending"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_PENDING');?></option>
          <option value="declined" <?php if($row->request_status == "declined"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_DECLINED');?></option>
          <option value="canceled" <?php if($row->request_status == "canceled"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_CANCELED');?></option>
          <option value="no_show" <?php if($row->request_status == "no_show"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NO_SHOW');?></option>
          <option value="attended" <?php if($row->request_status == "attended"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ATTENDED');?></option>
          <option value="completed" <?php if($row->request_status == "completed"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_COMPLETED');?></option>
          <option value="deleted" <?php if($row->request_status == "deleted"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_DELETED');?></option>
      </select> <input type="hidden" name="old_status" value="<?php echo $row->request_status;?>" /></td>
      <td style=" border-top:#999999 solid 1px"><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_PAY_STATUS');?>:</td>
      <td width="40%"><select name="payment_status">
          <option value="pending" <?php if($row->payment_status == "pending"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_PAY_STATUS_PENDING');?></option>
          <option value="paid" <?php if($row->payment_status == "paid"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_PAY_STATUS_PAID');?></option>
          <option value="na" <?php if($row->payment_status == "na"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_PAY_STATUS_NA');?></option>
        </select>      </td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PAY_STATUS_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_TOTAL');?> :</td>
      <td ><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?>&nbsp;<input type="text" size="5" maxsize="10" name="booking_total" value="<?php echo $row->booking_total; ?>" align="baseline" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_TOTAL_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_DUE');?> :</td>
      <td><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?>&nbsp;<input type="text" size="5" maxsize="10" name="booking_due" value="<?php echo $row->booking_due; ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_DUE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_USED');?> :</td>
      <td ><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?><?php echo $row->credit_used; ?><input type="hidden" name="credit_used" value="<?php echo $row->credit_used; ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_USED_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_CODE');?> :</td>
      <td><?php echo $row->coupon_code; ?></td>
      <td></td>
    </tr>
    <?php if($apptpro_config->which_calendar != "None"){ ?>
    <tr  class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_CURRENT_CALENDAR');?>:</td>
      <td><?php echo $apptpro_config->which_calendar ?></td>
      <td valign="top"><?php //echo JText::_('RS1_ADMIN_SCRN_CURRENT_CALENDAR_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_POST_TO_CALENDAR');?>:</td>
      <td width="40%"><select name="show_on_calendar" >
          <option value="Yes" <?php if( $row->show_on_calendar == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if( $row->show_on_calendar == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
    </select>    </tr>
    <?php if($apptpro_config->which_calendar == "Google"){ ?>
    <tr  class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_GOOGLE_ID');?>:</td>
      <td><?php echo $row->google_event_id ?> <input type="hidden" name="google_event_id" id="google_event_id" value="<?php echo $row->google_event_id ?>" /></td>
      <td rowspan="2" valign="top"></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_GOOGLE_CAL');?>:</td>
      <td><input type="text" size="70" maxsize="254" name="google_calendar_id" value="<?php echo $row->google_calendar_id; ?>" />&nbsp;</td>
    </tr>
    <?php } else { ?>       
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_CALENDAR_CATEGORY');?>:</td>
      <td><select name="calendar_category" >
          <?php
			$k = 0;
			for($i=0; $i < count( $cal_cat_rows ); $i++) {
			$cal_cat_row = $cal_cat_rows[$i];
			?>
          <option value="<?php echo $cal_cat_row->id; ?>"
          <?php if($cal_cat_row->id == $row->calendar_category){ echo "selected";}?>
          ><?php echo $cal_cat_row->title; ?></option>
          <?php $k = 1 - $k; 
		  } ?>
        </select></td>
      <td><span style="color:#FF0000"><?php echo $noCats?></span> </td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_CALENDAR_CALENDAR');?></td>
      <td valign="top"><select name="calendar_calendar" >
          <?php
			$k = 0;
			for($i=0; $i < count( $cal_cal_rows ); $i++) {
			$cal_cal_row = $cal_cal_rows[$i];
			?>
          <option value="<?php echo $cal_cal_row->id; ?>"
          <?php if($cal_cal_row->id == $row->calendar_calendar){ echo "selected";}?>
          ><?php echo $cal_cal_row->title; ?></option>
          <?php $k = 1 - $k; 
	     } ?>
        </select></td>
      <td><span style="color:#FF0000"><?php echo $noCats?></span> </td>
    </tr>
	<?php } ?>
<!--    <tr class="admin_detail_row1">
      <td width="95" valign="top">Calendar Comment:</td>
      <td width="40%" ><textarea  name="calendar_comment" rows="4" cols="40"><?php echo stripslashes($row->calendar_comment); ?></textarea></td>
      <td valign="top">This comment will appear in the calender booking details.<BR />
        Examples: who the resouce is booked to, what for, etc. </td>
    </tr>-->
    <?php } // end of if($apptpro_config->which_calendar != "None") ?>
    <tr class="admin_detail_row1">
      <td width="12%" valign="top" ><?php echo JText::_('RS1_ADMIN_SCRN_ADMINCOMMENT');?>:</td>
      <td width="40%" ><textarea name="admin_comment" id="admin_comment" class="sv_apptpro_requests_text" rows="4" cols="40" ><?php echo stripslashes($row->admin_comment); ?></textarea></td>
      <td valign="top" ><?php echo JText::_('RS1_ADMIN_SCRN_ADMINCOMMENT_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_CANCEL_CODE_COL_HEAD');?>:</td>
      <td><input type="text" size="50" maxsize="80" name="cancellation_id" value="<?php echo $row->cancellation_id; ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CANCEL_CODE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_ID');?>:</td>
      <td><?php echo $row->txnid; ?></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_ID_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_LANGUAGE');?>: </td>
      <td width="40%"><input type="text" size="5" maxsize="5" name="booking_language" value="<?php echo $row->booking_language; ?>" /></td>
      <td></td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="12%"><?php echo JText::_('RS1_ADMIN_SCRN_TIMESTAMP');?>: </td>
      <td width="40%"><?php echo $row->created; ?></td>
      <td></td>
    </tr>
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="seat_type_count" id="seat_type_count" value="<?php echo count($seat_type_rows) ?>"/>  
  <input type="hidden" name="cr_id" value="<?php echo $_POST['id']; ?>" />

  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php }

function listConfiguration($option, &$rows)
{
	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}

	// get cb profile columns
	$database->setQuery("SELECT * FROM #__comprofiler_fields WHERE type='text' or type='predefined' ORDER BY name" );
	$cb_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		if($database -> getErrorNum() != 1146){
			// ignore 1146 - table not found if component not installed
			echo $database -> stderr();
			return false;
		}
	}

	// get js profile columns
	$database->setQuery("SELECT * FROM #__community_fields WHERE type!='group' ORDER BY name" );
	$js_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		if($database -> getErrorNum() != 1146){
			// ignore 1146 - table not found if component not installed
			echo $database -> stderr();
			return false;
		}
	}


	?>
<style type="text/css">
<!--
.icon-48-configure { background-image: url(./components/com_rsappt_pro14/images/configure.jpg); }
-->
}
</style>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<table class="adminheading">
  <tr>
    <th class="config"><?php echo JText::_('RS1_ADMIN_CONFIG');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm" class="adminForm">
  <?php 
  
 	// get data for dropdowns
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_pp_currency ORDER BY description" );
	$currency_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	$sql = 'SELECT * FROM #__sv_apptpro_udfs WHERE (udf_type="Textbox" or udf_type="List" or udf_type="Radio") and published=1 ORDER BY ordering';
	$database->setQuery($sql);
	$udf_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo "DB Err: ". $database -> stderr();
		return false;
	}
  
   // instantiate new tab system
	jimport( 'joomla.html.pane' );
	
	$pane =& JPane::getInstance('Tabs');
	echo $pane->startPane('myPane');
	{
	// start tab pane
	//$tabs->startPane("TabPaneOne");
	echo $pane->startPanel(JText::_('RS1_ADMIN_CONFIG_TAB'), 'panel1');
	?>
  <table cellpadding="4" cellspacing="0" border="0"  >
    <?php
	$row = $rows[0];
	?>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_EMAIL_TO');?>:</td>
      <td><input type="text" size="60" maxsize="80" name="mailTO" value="<?php echo $row->mailTO; ?>" />
        <br>
        <span style="font-size:9px"><?php echo JText::_('RS1_ADMIN_CONFIG_EMAIL_TO_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_EMAIL_FROM');?>: </td>
      <td><input type="text" size="50" maxsize="255" name="mailFROM" value="<?php echo $row->mailFROM; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_EMAIL_SUBJECT');?>: </td>
      <td><input type="text" size="30" maxsize="50" name="mailSubject" value="<?php echo $row->mailSubject; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_HTML_EMAIL');?>: </td>
      <td><select name="html_email">
          <option value="Yes" <?php if($row->html_email == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->html_email == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_HTML_EMAIL_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_HTML_EMAIL');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_LOGIN_REQUIRED');?>:</td>
      <td><select name="requireLogin">
          <option value="Yes" <?php if($row->requireLogin == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->requireLogin == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_LOGIN_REQUIRED_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_LOGIN_REQUIRED');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> &nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_PHONE');?>: </td>
      <td valign="top"><select name="requirePhone">
          <option value="Yes" <?php if($row->requirePhone == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_PHONE_REQUIRED');?></option>
          <option value="No" <?php if($row->requirePhone == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_PHONE_OPTIONAL');?></option>
          <option value="Hide" <?php if($row->requirePhone == "Hide"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_PHONE_HIDE');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_REQUIRED_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_REQUIRED');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />&nbsp;&nbsp;
        <table border="0" align="right">
          <tr>
            <td>        <?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_CB');?>
        <select name="phone_cb_mapping" id="phone_cb_mapping" >
      	<option value=""><?php echo JText::_('RS1_ADMIN_SELECT_CB_VALUE');?></option>
          <?php
		$k = 0;
		for($i=0; $i < count( $cb_rows ); $i++) {
		$cb_row = $cb_rows[$i];
		?>
          <option value="<?php echo $cb_row->name; ?>" <?php if($row->phone_cb_mapping == $cb_row->name){echo " selected='selected' ";} ?>><?php echo stripslashes($cb_row->name); ?></option>
          <?php $k = 1 - $k; 
		} ?>
        </select> <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_CB_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_FROM_CB');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />&nbsp;<?php echo JText::_('RS1_ADMIN_READ_ONLY');?> <select name="phone_read_only">
       	  <option value="Yes" <?php if($row->phone_read_only == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
       	  <option value="No" <?php if($row->phone_read_only == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
      </select> <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_READ_ONLY_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_PHONE_READ_ONLY');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /></td>
          </tr>
          <tr>
            <td>        <?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_JS');?>
        <select name="phone_js_mapping" id="phone_js_mapping" >
      	<option value=""><?php echo JText::_('RS1_ADMIN_SELECT_JS_VALUE');?></option>
          <?php
		$k = 0;
		for($i=0; $i < count( $js_rows ); $i++) {
		$js_row = $js_rows[$i];
		?>
          <option value="<?php echo $js_row->fieldcode; ?>" <?php if($row->phone_js_mapping == $js_row->fieldcode){echo " selected='selected' ";} ?>><?php echo stripslashes($js_row->name); ?></option>
          <?php $k = 1 - $k; 
		} ?>
        </select> <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_JS_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PHONE_FROM_JS');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />&nbsp;</td>
          </tr>
        </table> 
</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EMAIL');?>: </td>
      <td><select name="requireEmail">
          <option value="Yes" <?php if($row->requireEmail == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_EMAIL_REQUIRED');?></option>
          <option value="No" <?php if($row->requireEmail == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_EMAIL_OPTIONAL');?></option>
          <option value="Hide" <?php if($row->requireEmail == "Hide"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_EMAIL_HIDE');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_EMAIL_REQUIRED_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_EMAIL_REQUIRED');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> &nbsp;&nbsp;<!--  [optional] Fetch data from CB profile: 
        <select name="email_cb_mapping" id="email_cb_mapping" >
      	<option value="">Select a CB profile value</option>
          <?php
		$k = 0;
		for($i=0; $i < count( $cb_rows ); $i++) {
		$cb_row = $cb_rows[$i];
		?>
          <option value="<?php echo $cb_row->name; ?>" <?php if($row->email_cb_mapping == $cb_row->name){echo " selected='selected' ";} ?>><?php echo stripslashes($cb_row->name); ?></option>
          <?php $k = 1 - $k; 
		} ?>
        </select>  <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('If you are using Community Builder and wish to populate the ABPro booking screen from a CB profile field, set the field mapping here.');?>', CAPTION, '<?php echo JText::_('EMail From CB');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />&nbsp;Read Only: <select name="email_read_only">
        	<option value="Yes" <?php if($row->email_read_only == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
        	<option value="No" <?php if($row->email_read_only == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
	    </select> <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('Set to Yes if you do not want the visitor to change the value.<br>Note: Changes, if allowed are <b>never</b> written back to CB. Changes are only stored in the ABPro booking.');?>', CAPTION, '<?php echo JText::_('Email Read Only');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> --></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_HIDE_LOGO');?>: </td>
      <td><select name="hide_logo">
          <option value="Yes" <?php if($row->hide_logo == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->hide_logo == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_HIDE_LOGO_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_HIDE_LOGO');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_USE_DIV_CAL');?>: </td>
      <td><select name="use_div_calendar">
          <option value="Yes" <?php if($row->use_div_calendar == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->use_div_calendar == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_USE_DIV_CAL_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_USE_DIV_CAL');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_POPUP_START_DAY');?>: </td>
      <td><select name="popup_week_start_day">
          <option value="0" <?php if($row->popup_week_start_day == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_SUNDAY');?></option>
          <option value="1" <?php if($row->popup_week_start_day == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_MONDAY');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_POPUP_START_DAY_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_POPUP_START_DAY');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> </td>
    </tr>
	<tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_LIMIT_BOOKINGS');?>: </td>
      <td><input type="text" size="3" maxsize="3" name="limit_bookings" value="<?php echo $row->limit_bookings; ?>" />
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_LIMIT_BOOKINGS_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_LIMIT_BOOKINGS');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />    
    </tr>
<!--    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PREVENT_DUPES');?>: </td>
      <td><select name="prevent_dupe_bookings">
          <option value="Yes" <?php if($row->prevent_dupe_bookings == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->prevent_dupe_bookings == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PREVENT_DUPES_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PREVENT_DUPES');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />    </tr>
-->    
	<tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_AUTO_ACCEPT');?>: </td>
      <td><select name="auto_accept">
          <option value="Yes" <?php if($row->auto_accept == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->auto_accept == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_AUTO_ACCEPT_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_AUTO_ACCEPT');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CANCEL');?>: </td>
      <td><select name="allow_cancellation">
          <option value="Yes" <?php if($row->allow_cancellation == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->allow_cancellation == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
          <option value="BEO" <?php if($row->allow_cancellation == "BEO"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_CANCEL_BACK_END_ONLY');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CANCEL_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CANCEL');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /> 
    &nbsp;<?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CANCEL_UPTO');?> <select name="hours_before_cancel">
          <option value="0" <?php if($row->hours_before_cancel == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_0');?></option>
          <option value="1" <?php if($row->hours_before_cancel == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_1');?></option>
          <option value="2" <?php if($row->hours_before_cancel == "2"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_2');?></option>
          <option value="4" <?php if($row->hours_before_cancel == "4"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_4');?></option>
          <option value="6" <?php if($row->hours_before_cancel == "6"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_6');?></option>
          <option value="8" <?php if($row->hours_before_cancel == "8"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_8');?></option>
          <option value="12" <?php if($row->hours_before_cancel == "12"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_12');?></option>
          <option value="24" <?php if($row->hours_before_cancel == "24"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_24');?></option>
          <option value="48" <?php if($row->hours_before_cancel == "48"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_48');?></option>
    </select> <?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CANCEL_HOURS_BEFORE');?></tr>
    <tr class="admin_detail_row1">
      <td height="27" ><?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CREDIT_REFUND');?>:</td>
      <td><select name="allow_user_credit_refunds">
          <option value="Yes" <?php if($row->allow_user_credit_refunds == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->allow_user_credit_refunds == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CREDIT_REFUND_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_ALLOW_CREDIT_REFUND');?>', ABOVE, RIGHT);" 
            onmouseout="return nd();" /> </td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td height="27" ><?php echo JText::_('RS1_ADMIN_CONFIG_TIME_FORMAT');?>:</td>
      <td><select name="timeFormat">
          <option value="12" <?php if($row->timeFormat == "12"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_12_HOUR');?></option>
          <option value="24" <?php if($row->timeFormat == "24"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_24_HOUR');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_TIME_FORMAT_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_TIME_FORMAT');?>', ABOVE, RIGHT);" 
            onmouseout="return nd();" /> </td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td height="27" ><?php echo JText::_('RS1_ADMIN_CONFIG_ACTIVITY_LOGGING');?>:</td>
      <td><select name="activity_logging">
          <option value="Off" <?php if($row->activity_logging == "Off"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_ACTIVITY_LOGGING_OFF');?></option>
          <option value="Min" <?php if($row->activity_logging == "Min"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_ACTIVITY_LOGGING_MIN');?></option>
          <option value="Max" <?php if($row->activity_logging == "Max"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_ACTIVITY_LOGGING_MAX');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
        <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_ACTIVITY_LOGGING_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_ACTIVITY_LOGGING');?>', ABOVE, RIGHT);" 
            onmouseout="return nd();" /> </td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td style="border-top:solid #666666 1px" valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_HEADER_TEXT');?>: </td>
      <td style="border-top:solid #666666 1px"><textarea name="headerText" rows="3" cols="60"><?php echo stripslashes($row->headerText); ?></textarea></td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_FOOTER_TEXT');?>: </td>
      <td><textarea name="footerText" rows="3" cols="60"><?php echo stripslashes($row->footerText); ?></textarea></td>
    </tr>
  </table>
<?php
	echo $pane->endPanel();

	//Second Tab
	//Third Tab
	echo $pane->startPanel(JText::_('RS1_ADMIN_CONFIG_CAL_TAB'), 'panel4');
	?>
  <script language="javascript">
		function cal_pick(){
			if(document.getElementById('NoCal').checked == true){
				document.getElementById('which_calendar_id').value = "None";
				}
			if(document.getElementById('JEvents').checked == true){
				document.getElementById('which_calendar_id').value = "JEvents";
				}
			if(document.getElementById('JCalPro').checked == true){
				document.getElementById('which_calendar_id').value = "JCalPro";
				}
			if(document.getElementById('JCalPro2').checked == true){
				document.getElementById('which_calendar_id').value = "JCalPro2";
				}
			if(document.getElementById('EventList').checked == true){
				document.getElementById('which_calendar_id').value = "EventList";
				}
			if(document.getElementById('Google').checked == true){
				document.getElementById('which_calendar_id').value = "Google";
				}
			if(document.getElementById('Thyme').checked == true){
				document.getElementById('which_calendar_id').value = "Thyme";
				}
			}
	</script>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
    
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist" >
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_INTRO');?>
        <table width="80%" border="0" cellspacing="0" cellpadding="0" align="center">
          <tr>
            <td align="center"><input name="rbcalendar" type="radio" id="NoCal" value="None"  onclick="cal_pick()" 
					<?php if($row->which_calendar == 'None'){ echo 'checked="checked"';} ?>/></td>
            <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_NONE');?></td>
          </tr>
          <tr>
            <td align="center" valign="top"><input type="radio" name="rbcalendar" id="EventList" value="EventList" onclick="cal_pick()" 
    					<?php if($row->which_calendar == 'EventList'){ echo 'checked="checked"';} ?>/>            </td>
            <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_EVENTLIST');?> <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_EVENTLIST_LINK');?>
            <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_EVENTLIST_HELP');?>
            </td>
          </tr>
          <tr>
            <td align="center" valign="top"><input type="radio" name="rbcalendar" id="Google" value="Google" onclick="cal_pick()" 
    					<?php if($row->which_calendar == 'Google'){ echo 'checked="checked"';} ?>/>            </td>
            <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_GOOGLE');?> <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_GOOGLE_LINK');?>
            <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_GOOGLE_HELP');?>
            </td>
          </tr>        
          <tr>
            <td align="center" valign="top"><input type="radio" name="rbcalendar" id="JCalPro" value="JCalPro" onclick="cal_pick()" 
    					<?php if($row->which_calendar == 'JCalPro'){ echo 'checked="checked"';} ?>/>            </td>
            <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JCALPRO');?> <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JCALPRO_LINK');?>
            <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JCALPRO_HELP');?>
            </td>
          </tr>
          <tr>
            <td align="center" valign="top"><input type="radio" name="rbcalendar" id="JCalPro2" value="JCalPro2" onclick="cal_pick()" 
    					<?php if($row->which_calendar == 'JCalPro2'){ echo 'checked="checked"';} ?>/>            </td>
            <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JCALPRO2');?> <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JCALPRO_LINK');?>
            <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JCALPRO2_HELP');?>
            </td>
          </tr>
		  <tr>
            <td width="9%" align="center" valign="top"><input name="rbcalendar" type="radio" id="JEvents" value="JEvents"                  
					<?php if($row->which_calendar == 'JEvents'){ echo 'checked="checked"';} ?> onclick="cal_pick()" /></td>
            <td width="79%"><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JEVENTS');?> <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JEVENTS_LINK');?>
            <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_JEVENTS_HELP');?>
            </td>
          </tr>
          <tr>
            <td align="center" valign="top"><input name="rbcalendar" type="radio" id="Thyme" value="Thyme"                  
					<?php if($row->which_calendar == 'Thyme'){ echo 'checked="checked"';} ?> onclick="cal_pick()" />&nbsp;</td>
            <td><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_THYME');?> <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_THYME_LINK');?>
            <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_THYME_HELP');?>
            </td>
          </tr>
    	  <tr  class="admin_detail_row0" >
		      <td colspan="2"><hr><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_FIELDS');?>: </td>
          </tr>
          <tr>
            <td colspan="2"><table width="100%" border="0">
              <tr>
                <td width="15%" valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_TITLE');?>:</td>
                <td colspan="2"><table border="0">
                    <tr>
                      <td width="173" valign="top"><select name="calendar_title">
                    <option value="resource.name" <?php if($row->calendar_title == "resource.name"){echo " selected='selected' ";} ?>>resource.name</option>
                    <option value="request.name" <?php if($row->calendar_title == "request.name"){echo " selected='selected' ";} ?>>request.name</option>
					  <?php
						$k = 0;
						for($i=0; $i < count( $udf_rows ); $i++) {
						$udf_row = $udf_rows[$i];
						?>
							  <option value="<?php echo $udf_row->id; ?>" <?php if($row->calendar_title == $udf_row->id){echo " selected='selected' ";} ?>><?php echo $udf_row->udf_label?></option>
							  <?php $k = 1 - $k; 
						} ?>
                    </select></td>
                      <td ><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_TITLE_HELP');?></td>
                    </tr>
                </table>              </tr>
              <tr>
                <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_CAL_BODY');?>:</td>
                <td><textarea name="calendar_body2" rows="4" cols="70"><?php echo stripslashes($row->calendar_body2); ?></textarea>
                  &nbsp;<?php echo JText::_('RS1_ADMIN_CONFIG_CAL_BODY_HELP');?>                  </td>
                <td>&nbsp;</td>
              </tr>
              <tr>
                <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_DST');?>:</td>
                <td><table border="0">
                    <tr>
                      <td width="173" valign="top"><select name="daylight_savings_time">
                        <option value="Yes" <?php if($row->daylight_savings_time == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
                        <option value="No" <?php if($row->daylight_savings_time == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
                        </select>&nbsp;</td>
                      <td ><?php echo JText::_('RS1_ADMIN_CONFIG_DST_HELP');?></td>
                    </tr>
                </table>
				</td>
                <td>&nbsp;</td>
              </tr>
            <tr class="admin_detail_row0">
              <td><?php echo JText::_('RS1_ADMIN_SCRN_DST_START_DATE');?></td>
              <td><input type="text" size="12" maxsize="10" readonly="readonly" name="dst_start_date" id="dst_start_date" value="<?php echo $row->dst_start_date; ?>" />
                    <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].dst_start_date,'anchor1','yyyy-MM-dd'); return false;"
                             name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
                    </td>
            </tr>
            <tr class="admin_detail_row0">
              <td><?php echo JText::_('RS1_ADMIN_SCRN_DST_END_DATE');?></td>
              <td><input type="text" size="12" maxsize="10" readonly="readonly" name="dst_end_date" id="dst_end_date" value="<?php echo $row->dst_end_date; ?>" />
                        <a href="#" id="anchor2" onclick="cal.select(document.forms['adminForm'].dst_end_date,'anchor2','yyyy-MM-dd'); return false;"
                             name="anchor2"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
                  &nbsp; </td>
            </tr>
            </table></td>
          </tr>
          <tr>
		      <td colspan="2"><p>&nbsp;</p>	          </td>
          </tr>
          <tr>    
              <td colspan="2">&nbsp;</td>
    </tr>
        </table>
        <p>&nbsp;</p>
        <?php echo JText::_('RS1_ADMIN_CONFIG_CAL_NOTE');?></td>
    </tr>
  </table>
  <input type="hidden" name="which_calendar" id="which_calendar_id" value=<?php echo $row->which_calendar ?> />
  <?php
	echo $pane->endPanel();

	echo $pane->startPanel(JText::_('RS1_ADMIN_CONFIG_GAD_TAB'), 'panel5');
	?>
<script language="javascript">
	function set_gad_grid_start_day_radios(){		
		switch(document.getElementById('gad_grid_start_day').value)
		{
		case "Today":
		  document.getElementById('rb_gad_grid_start_day_today').checked = true;
		  break;    
		case "XDays":
		  document.getElementById('rb_gad_grid_start_day_xdays').checked = true;
		  break;    
		case "Tomorrow":
		  document.getElementById('rb_gad_grid_start_day_tomorrow').checked = true;
		  break;    
		default:
		  document.getElementById('rb_gad_grid_start_day_specific').checked = true;
		  break;    
		}
	}
	
	function setTomorrow(){
		document.getElementById('gad_grid_start_day').value = "Tomorrow";
	}

	function setMonday(){
		document.getElementById('gad_grid_start_day').value = "Monday";
	}

	function setToday(){
		document.getElementById('gad_grid_start_day').value = "Today";
	}

	function setNotSet(){
		document.getElementById('gad_grid_start_day').value = "Not Set";
	}
	
	function setXDays(){
		document.getElementById('gad_grid_start_day').value = "XDays";
	}

	
</script>
    
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="2" cellspacing="0" >
    <tr>
      <td colspan="3">
        <?php echo JText::_('RS1_ADMIN_CONFIG_GAD_INTRO');?> </td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="20%"><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_GAD2');?>:</td>
      <td><select name="use_gad2" class="admin_dropdown">
            <option value="Yes" <?php if($row->use_gad2 == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            <option value="No" <?php if($row->use_gad2 == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            </select>      
      </td>
      <td width="50%"><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_GAD2_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="20%"><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_START_TIME');?>:</td>
      <td><select name="def_gad_grid_start" class="admin_dropdown">
      	<?php 
		for($x=0; $x<24; $x+=1){
			$x.=":00";
			echo "<option value=".$x; if($row->def_gad_grid_start == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?></select>      </td>
      <td width="50%">&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_END_TIME');?>:</td>
      <td><select name="def_gad_grid_end" class="admin_dropdown">
      	<?php 
		for($x=0; $x<=24; $x+=1){
			$x.=":00";
			echo "<option value=".$x; if($row->def_gad_grid_end == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?></select>	  </td>
      <td>&nbsp;</td>
    <tr class="admin_detail_row0">
      <td width="20%"><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_HIDE_STARTSTOP');?>:</td>
      <td><select name="gad_grid_hide_startend">
            <option value="Yes" <?php if($row->gad_grid_hide_startend == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            <option value="No" <?php if($row->gad_grid_hide_startend == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            </select>      </td>
      <td width="50%"><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_HIDE_STARTSTOP_HELP');?>&nbsp;</td>
    </tr>
	<tr class="admin_detail_row1">
	  <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_START_DAY');?>:</td>
	  <td >
		  <input type="radio" name="rb_gad_grid_start_day" id="rb_gad_grid_start_day_today" value="rb_gad_grid_start_day_today"
      	<?php echo ($row->gad_grid_start_day == "Today" ? "checked='checked'" : "");?> onclick="setToday();" />
		  <?php echo JText::_('RS1_ADMIN_CONFIG_GAD_TODAY');?>&nbsp;
		  <br />      
		  <input type="radio" name="rb_gad_grid_start_day" id="rb_gad_grid_start_day_tomorrow" value="rb_gad_grid_start_day_tomorrow"
      	<?php echo ($row->gad_grid_start_day == "Tomorrow" ? "checked='checked'" : "");?> onclick="setTomorrow();" />
	    <?php echo JText::_('RS1_ADMIN_CONFIG_GAD_TOMORROW');?>&nbsp;&nbsp; <Br />
		  <input type="radio" name="rb_gad_grid_start_day" id="rb_gad_grid_start_day_monday" value="rb_gad_grid_start_day_monday"
      	<?php echo ($row->gad_grid_start_day == "Monday" ? "checked='checked'" : "");?> onclick="setMonday();" />
	    <?php echo JText::_('RS1_ADMIN_CONFIG_GAD_MONDAY');?>&nbsp;&nbsp; <Br />
		<input type="radio" name="rb_gad_grid_start_day" id="rb_gad_grid_start_day_xdays" value="rb_gad_grid_start_day_xdays"
      	<?php echo ($row->gad_grid_start_day == "XDays" ? "checked='checked'" : "");?> onclick="setXDays();" />
	    <input type="text" size="2" name="gad_grid_start_day_days" id="gad_grid_start_day_days" value="<?php echo $row->gad_grid_start_day_days?>" /> 
	    <?php echo JText::_('RS1_ADMIN_CONFIG_GAD_DAYS');?>&nbsp;&nbsp; 
        <Br /> <input type="radio" name="rb_gad_grid_start_day" id="rb_gad_grid_start_day_specific" value="rb_gad_grid_start_day_specific" 
        <?php echo (($row->gad_grid_start_day != "Tomorrow" AND $row->gad_grid_start_day != "Today" AND $row->gad_grid_start_day != "Monday" AND $row->gad_grid_start_day != "XDays")? "checked='checked'" : "");?>/>
		  <?php echo JText::_('RS1_ADMIN_CONFIG_GAD_SPECIFIC');?>:
		  <input type="text" name="gad_grid_start_day" id="gad_grid_start_day" size="12" readonly="readonly" value="<?php echo $row->gad_grid_start_day; ?>" 
      	onchange="set_gad_grid_start_day_radios();" />
          <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].gad_grid_start_day,'anchor1','yyyy-MM-dd'); return false;"
					 name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a></td>
	  <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_START_DAY_HELP');?>    </td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_WIDTH');?>:</td>
      <td><input type="text" size="10" maxsize="20" name="gad_grid_width" value="<?php echo $row->gad_grid_width; ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_GRID_WIDTH_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_NAME_WIDTH');?>:</td>
      <td ><input type="text" size="10" maxsize="20" name="gad_name_width" value="<?php echo $row->gad_name_width; ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_NAME_WIDTH_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_AVAILABLE_IMAGE');?>:</td>
      <td><input type="text" size="60" maxsize="80" name="gad_available_image" value="<?php echo $row->gad_available_image; ?>" />
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_AVAILABLE_IMAGE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_BOOKED_IMAGE');?>:</td>
      <td><input type="text" size="60" maxsize="80" name="gad_booked_image" value="<?php echo $row->gad_booked_image; ?>" />
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_BOOKED_IMAGE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_DAYS_TO_SHOW');?>:</td>
      <td><input type="text" size="1" maxsize="2" name="gad_grid_num_of_days" value="<?php echo $row->gad_grid_num_of_days; ?>" /></td>    
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_DAYS_TO_SHOW_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_SHOW_AVAILABLE_SEATS');?>:</td>
      <td><select name="show_available_seats">
            <option value="Yes" <?php if($row->show_available_seats == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            <option value="No" <?php if($row->show_available_seats == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            </select></td>    
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_GAD_SHOW_AVAILABLE_SEATS_HELP');?></td>
    </tr>
  </table>
  <?php    
	echo $pane->endPanel();
	echo $pane->startPanel(JText::_('RS1_ADMIN_CONFIG_MSG_TAB'), 'panel6');
	?>
<table border="0" cellpadding="2" cellspacing="0">
  <tr class="admin_detail_row0">
    <td colspan="3" ><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_INTRO');?></td>
  </tr>
  <tr class="admin_detail_row1">
    <td width="15%" valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_BOOKING_COMPLETE');?>:</td>
    <td valign="top">
      <textarea name="booking_succeeded" rows="8" cols="70"><?php echo stripslashes($row->booking_succeeded); ?></textarea>    </td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_BOOKING_COMPLETE_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row1">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_BOOKING_COMPLETE');?>:</td>
    <td valign="top"><textarea name="booking_succeeded_sms" rows="3" cols="70"><?php echo stripslashes($row->booking_succeeded_sms); ?></textarea></td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_BOOKING_COMPLETE_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row0">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_BOOKING_INPROGRESS');?>:</td>
    <td valign="top">
      <textarea name="booking_in_progress" rows="4" cols="70"><?php echo stripslashes($row->booking_in_progress); ?></textarea>    </td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_BOOKING_INPROGRESS_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row0">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_BOOKING_INPROGRESS');?>:</td>
    <td valign="top"><textarea name="booking_in_progress_sms" rows="3" cols="70"><?php echo stripslashes($row->booking_in_progress_sms); ?></textarea></td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_BOOKING_INPROGRESS_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row1">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_CANCELLATION');?>: </td>
    <td valign="top"><textarea name="booking_cancel" rows="4" cols="70"><?php echo stripslashes($row->booking_cancel); ?></textarea>    </td>

    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_CANCELLATION_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row1">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_CANCELLATION');?>:</td>
    <td valign="top"><textarea name="booking_cancel_sms" rows="3" cols="70"><?php echo stripslashes($row->booking_cancel_sms); ?></textarea></td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_CANCELLATION_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row0">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOO_LATE');?>:</td>
    <td valign="top"><textarea name="booking_too_close_to_cancel" rows="4" cols="70"><?php echo stripslashes($row->booking_too_close_to_cancel); ?></textarea>    </td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOO_LATE_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row1">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_REMINDER');?>:</td>
    <td valign="top"><textarea name="booking_reminder" rows="4" cols="70"><?php echo stripslashes($row->booking_reminder); ?></textarea>    </td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_REMINDER_HELP');?></td>
  </tr>
  <tr  class="admin_detail_row1">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_REMINDER');?>:</td>
    <td valign="top"><textarea name="booking_reminder_sms" rows="3" cols="70"><?php echo stripslashes($row->booking_reminder_sms); ?></textarea></td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_SMS_REMINDER_HELP');?></td>
  </tr>
<tr>
  <td valign="top" colspan="3"><hr /></td>
  </tr>
  <tr  class="admin_detail_row0">
    <td valign="top"><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_INTRO');?></td>
    <td colspan="2"><table  border="0" cellpadding="4">
      <tr>
        <td><strong><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN');?></strong></td>
        <td><strong><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_REPLACE');?></strong></td>
        <td width="5%">&nbsp; </td>
        <td><strong><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN');?></strong></td>
        <td><strong><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_REPLACE');?></strong></td>
      </tr>
      <tr>
        <td>[resource]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_1');?></td>
        <td>&nbsp;</td>
        <td>[resource_category]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_2');?></td>
      </tr>
      <tr>
        <td>[requester name]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_3');?></td>
        <td>&nbsp;</td>
        <td>[resource_service]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_4');?></td>
      </tr>
      <tr>
        <td>[startdate]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_5');?></td>
        <td>&nbsp;</td>
        <td>[phone]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_6');?></td>
      </tr>
      <tr>
        <td>[starttime]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_7');?></td>
        <td>&nbsp;</td>
        <td>[email]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_8');?></td>
      </tr>
      <tr>
        <td>[enddate]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_9');?></td>
        <td>&nbsp;</td>
        <td>[cancellation_id]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_10');?></td>
      </tr>
      <tr>
        <td>[endtime]</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_11');?></td>
        <td>&nbsp;</td>
        <td>[booking_total]</td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>[booking_due]</td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>[coupon]</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>[booking_id]</td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td colspan="5"><hr /></td>
        </tr>
      <tr>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_UDF_1');?></td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_UDF_2');?></td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_UDF_3');?></td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_UDF_4');?> </td>
        <td>&nbsp;</td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_UDF_5');?></td>
        <td><?php echo JText::_('RS1_ADMIN_CONFIG_MSG_TOKEN_UDF_6');?></td>
      </tr>

    </table>      
    <p>&nbsp;</p>      </td>
  </tr>
</table>
  <?php    
	echo $pane->endPanel();
	echo $pane->startPanel(JText::_('RS1_ADMIN_CONFIG_PAYPAL_TAB'), 'panel7');
	?>
  <table cellpadding="4" cellspacing="0" border="0"  >
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ENABLE');?>: </td>
      <td><select name="enable_paypal">
          <option value="Yes" <?php if($row->enable_paypal == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->enable_paypal == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
          <option value="Opt" <?php if($row->enable_paypal == "Opt"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ENABLE_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ENABLE');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ACCEPT_PAID');?>: </td>
      <td><select name="accept_when_paid">
          <option value="Yes" <?php if($row->accept_when_paid == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->accept_when_paid == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ACCEPT_PAID_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ACCEPT_PAID');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_FEE');?>: </td>
      <td><input type="text" id="additional_fee" name="additional_fee" size="4" maxsize="5" value="<?php echo $row->additional_fee ?>" />        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_FEE_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_FEE');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />&nbsp;&nbsp;
        <select name="fee_rate">
          <option value="Fixed" <?php if($row->fee_rate == "Fixed"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_FEE_FIXED');?></option>
          <option value="Percent" <?php if($row->fee_rate == "Percent"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_FEE_PERCENT');?></option>
        </select>      </td>       
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_COUPON_ENABLE');?>: </td>
      <td><select name="enable_coupons">
          <option value="Yes" <?php if($row->enable_coupons == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->enable_coupons == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_COUPON_ENABLE_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_COUPON_ENABLE');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_BUTTON');?>:</td>
      <td><input type="text" size="70" maxsize="255" name="paypal_button_url" value="<?php echo $row->paypal_button_url; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_BUTTON_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_BUTTON');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_CUR_CODE');?>:</td>
      <td><select name="paypal_currency_code"> 
          <?php
			$k = 0;
			for($i=0; $i < count( $currency_rows ); $i++) {
			$currency_row = $currency_rows[$i];
			?>
				  <option value="<?php echo $currency_row->code; ?>" <?php if($row->paypal_currency_code == $currency_row->code){echo " selected='selected' ";} ?>><?php echo $currency_row->code." - ".$currency_row->description; ?></option>
				  <?php $k = 1 - $k; 
			} ?>
        </select>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ACCOUNT');?>:</td>
      <td><input type="text" size="70" maxsize="255" name="paypal_account" value="<?php echo $row->paypal_account; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ACCOUNT_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ACCOUNT');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_SANDBOX');?>:</td>
      <td><input type="text" size="70" maxsize="255" name="paypal_sandbox_url" value="<?php echo $row->paypal_sandbox_url; ?>" />
      &nbsp;&nbsp;<script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_SANDBOX_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_SANDBOX');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />       </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_PROD');?>:</td>
      <td><input type="text" size="70" maxsize="255" name="paypal_production_url" value="<?php echo $row->paypal_production_url; ?>" />&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_USE_SAND');?>: </td>
      <td><select name="paypal_use_sandbox">
          <option value="Yes" <?php if($row->paypal_use_sandbox == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->paypal_use_sandbox == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;
        <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
   	   <img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_USE_SAND_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_USE_SAND');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" /><td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_YOUR_LOGO');?>:</td>
      <td><input type="text" size="70" maxsize="255" name="paypal_logo_url" value="<?php echo $row->paypal_logo_url; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_YOUR_LOGO_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_YOUR_LOGO');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ITEM_NAME');?>:</td>
      <td><input type="text" size="70" maxsize="126" name="paypal_itemname" value="<?php echo $row->paypal_itemname; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ITEM_NAME_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_ITEM_NAME');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?> 0:</td>
      <td><input type="text" size="70" maxsize="67" name="paypal_on0" value="<?php echo $row->paypal_on0; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_VALUE');?> 0:</td>
      <td><input type="text" size="70" maxsize="200" name="paypal_os0" value="<?php echo $row->paypal_os0; ?>" />
      &nbsp;&nbsp;
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?> 1:</td>
      <td><input type="text" size="70" maxsize="67" name="paypal_on1" value="<?php echo $row->paypal_on1; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_VALUE');?> 1:</td>
      <td><input type="text" size="70" maxsize="200" name="paypal_os1" value="<?php echo $row->paypal_os1; ?>" />
      &nbsp;&nbsp;
      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?> 2:</td>
      <td><input type="text" size="70" maxsize="67" name="paypal_on2" value="<?php echo $row->paypal_on2; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_VALUE');?> 2:</td>
      <td><input type="text" size="70" maxsize="200" name="paypal_os2" value="<?php echo $row->paypal_os2; ?>" />
      &nbsp;&nbsp;
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?> 3:</td>
      <td><input type="text" size="70" maxsize="67" name="paypal_on3" value="<?php echo $row->paypal_on3; ?>" />
      &nbsp;&nbsp;
      <script type="text/javascript" src="../includes/js/overlib_mini.js"></script>
    	<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_NAME');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_PAYPAL_OPTIONAL_VALUE');?> 3:</td>
      <td><input type="text" size="70" maxsize="200" name="paypal_os3" value="<?php echo $row->paypal_os3; ?>" />
      &nbsp;&nbsp;
      </td>
    </tr>
 
  </table>

  <?php    
	echo $pane->endPanel();
	echo $pane->startPanel(JText::_('RS1_ADMIN_CONFIG_CLICKATELL_TAB'), 'panel8');
	
	// get dialing codes
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_dialing_codes ORDER BY country" );
	$dial_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	
	
	?>
  <table cellpadding="4" cellspacing="0" border="0"  >
    <tr class="admin_detail_row0">
      <td colspan="3"><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_INTRO');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_ENABLE');?>: </td>
      <td><select name="enable_clickatell">
          <option value="Yes" <?php if($row->enable_clickatell == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->enable_clickatell == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
        &nbsp;&nbsp;      
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_ENABLE_HELP');?></td>   
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_USER');?>: </td>
      <td><input type="text" size="20" maxsize="50" name="clickatell_user" value="<?php echo $row->clickatell_user; ?>" /></td>    
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_USER_HELP');?></td>   
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_PWD');?>: </td>
      <td><input type="password" size="20" maxsize="50" name="clickatell_password" value="<?php echo $row->clickatell_password; ?>" /></td>    
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_PWD_HELP');?></td>   
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_API_ID');?>: </td>
      <td><input type="text" size="15" maxsize="50" name="clickatell_api_id" value="<?php echo $row->clickatell_api_id; ?>" /></td>    
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_API_ID_HELP');?></td>   
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_DIAL_CODE');?>:</td>
      <td><select name="clickatell_dialing_code" >
              <?php
				$k = 0;
				for($i=0; $i < count( $dial_rows ); $i++) {
				$dial_row = $dial_rows[$i];
				?>
          <option value="<?php echo $dial_row->dial_code; ?>"  <?php if($row->clickatell_dialing_code == $dial_row->dial_code){echo " selected='selected' ";} ?>><?php echo $dial_row->country." - ".$dial_row->dial_code ?></option>
              <?php $k = 1 - $k; 
				} ?>
      </select>&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_DIAL_CODE_HELP');?></td>   
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_SHOW_CODE');?>:</td>
      <td><select name="clickatell_show_code">
          <option value="Yes" <?php if($row->clickatell_show_code == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->clickatell_show_code == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
      &nbsp;&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_SHOW_CODE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_ENABLE_UNICODE');?>:</td>
      <td><select name="clickatell_enable_inicode">
          <option value="Yes" <?php if($row->clickatell_enable_inicode == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->clickatell_enable_inicode == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
      &nbsp;&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_ENABLE_UNICODE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3"><hr /><?php echo JText::_('RS1_ADMIN_CONFIG_CLICKATELL_FOOTER');?></td>
    </tr>
  </table>
  <?php    
	echo $pane->endPanel();
	}
	// end tab pane
	echo $pane->endPane();

?>
  <p>
    <input type="hidden" name="option" value="<?php echo $option; ?>" />
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="configid" value=<?php echo $row->configid ?> />
    <input type="hidden" name="act" value="configure" />
	<input type="hidden" name="hidemainmenu" value="0" />
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span> </p>
</form>
<?php
}

function listRequests( $option, &$rows, $showWhat, $direction, $ordering, $pageNav, $request_statusFilter, $request_resourceFilter, $startdateFilter, $enddateFilter, $categoryFilter, $user_search_filter ) {

	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_categories WHERE published=1 ORDER BY name" );
	$cat_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	//echo $categoryFilter;
	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$sql = "SELECT * FROM #__sv_apptpro_resources WHERE published=1 ";
	if($categoryFilter > 0){
		$sql .= " AND category_id = ".$categoryFilter. " ";
	}
	$sql .= " ORDER BY name";
	$database->setQuery($sql);
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}

?>

<style type="text/css">
<!--
.icon-48-bookings { background-image: url(./components/com_rsappt_pro14/images/bookings.png); }
-->
}
</style>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript" src="../administrator/components/com_rsappt_pro14/scripts2.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<script>
	function setTxnID(id){
		document.getElementById("xid").value = id;
		submitbutton('edit_direct_transaction');
		return false;
	}
	function cleardate(){
		document.getElementById("startdateFilter").value="";
		document.getElementById("enddateFilter").value="";
		submitbutton('');
		return false;		
	}
</script>
<form action="index2.php" method="post" name="adminForm">
<table class="adminheading" width="100%">
	<tr>        <th align="left" ><?php echo JText::_('RS1_ADMIN_APPT_LIST');?></th>

    </tr>
    <tr>
    	<th>
           
       <table class="adminheading" align="right" cellspadding="2" border="0">
        <tr>
        <td align="left"><input type="text" id="user_search" name="user_search" size="20" title="<?php echo JText::_('RS1_ADMIN_APPT_LIST_SEARCH_HELP');?>" 
        value="<?php echo $user_search_filter ?>" />&nbsp;<input type="button" onclick="this.form.submit();" value="<?php echo JText::_('RS1_ADMIN_APPT_LIST_SEARCH');?>" />&nbsp;&nbsp;
		</td>
        <td>
            <?php echo JText::_('RS1_ADMIN_APPT_LIST_DATE_RANGE');?>
        </td>
        <td><input type="text" size="12" maxsize="12" name="startdateFilter" id="startdateFilter" readonly="readonly" style="background-color:#FFFFCC"
        value="<?php echo $startdateFilter; ?>" onchange="this.form.submit();"/>
        <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].startdateFilter,'anchor1','yyyy-MM-dd'); return false;"
					 name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
        <input type="text" size="12" maxsize="12" name="enddateFilter" id="enddateFilter" readonly="readonly" style="background-color:#FFFFCC"
        	value="<?php echo $enddateFilter; ?>" onchange="this.form.submit();"/>
        <a href="#" id="anchor2" onclick="cal.select(document.forms['adminForm'].enddateFilter,'anchor2','yyyy-MM-dd'); return false;"
					 name="anchor2"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>        
        <a href="#" onclick="cleardate();"><?php echo JText::_('RS1_ADMIN_APPT_LIST_CLEAR_DATES');?></a>&nbsp;&nbsp;
        </td>
        <td><select name="categoryFilter" id="categoryFilter" onchange="this.form.submit();" style="background-color:#FFFFCC" >
              <option value="0" <?php if($categoryFilter == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_APPT_LIST_SELECT_CAT');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $cat_rows ); $i++) {
				$cat_row = $cat_rows[$i];
				?>
              <option value="<?php echo $cat_row->id; ?>" <?php if($categoryFilter == $cat_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($cat_row->name); ?></option>
              <?php $k = 1 - $k; 
				} ?>
            </select>&nbsp;&nbsp;
        </td>
        <td><select name="request_resourceFilter" id="request_resourceFilter" onchange="this.form.submit();" style="background-color:#FFFFCC" >
              <option value="0" <?php if($request_resourceFilter == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_APPT_LIST_SELECT_RES');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
              <option value="<?php echo $res_row->id; ?>" <?php if($request_resourceFilter == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->name); ?></option>
              <?php $k = 1 - $k; 
				} ?>
            </select>&nbsp;&nbsp;
        </td>
        <td>
            <?php echo JText::_('RS1_ADMIN_APPT_LIST_STATUS');?>
        </td>
        <td>
            <select name="request_status" onchange="this.form.submit();" style="background-color:#FFFFCC" >
              <option value="all" <?php if($request_statusFilter == "all"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ALL');?></option>
              <option value="new"<?php if($request_statusFilter == "new"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NEW');?></option>
              <option value="pending"<?php if($request_statusFilter == "pending"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_PENDING');?></option>
              <option value="accepted"<?php if($request_statusFilter == "accepted"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ACCEPTED');?></option>
              <option value="declined"<?php if($request_statusFilter == "declined"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_DECLINED');?></option>
              <option value="canceled"<?php if($request_statusFilter == "canceled"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_CANCELED');?></option>
              <option value="no_show"<?php if($request_statusFilter == "no_show"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_NO_SHOW');?></option>
              <option value="attended"<?php if($request_statusFilter == "attended"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_ATTENDED');?></option>
              <option value="completed" <?php if($request_statusFilter == "completed"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_COMPLETED');?></option>
              <option value="deleted"<?php if($request_statusFilter == "deleted"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_REQUEST_STATUS_DELETED');?></option>
            </select>&nbsp;&nbsp;
        </td>
		</tr>
       </table>
       </th> 
    </tr>
  </table>
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_NAME_COL_HEAD'), 'name', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_EMAIL_COL_HEAD'), 'email', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_CATEGORY_COL_HEAD'), 'CategoryName', $direction, $ordering ); ?><br /></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_RESOURCE_COL_HEAD'), 'ResourceName', $direction, $ordering ); ?><br /></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_SERVICE_COL_HEAD'), 'ServiceName', $direction, $ordering ); ?><br /></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DATETIME_COL_HEAD'), 'startdatetime', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_SEATS_COL_HEAD'), 'booked_seats', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PAYPALTXN_COL_HEAD'), 'txnid', $direction, $ordering ); ?></th>
      <th align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PAYMENT_COL_HEAD'), 'payment_status',  $direction, $ordering );?></th>
      <th align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_STATUS_COL_HEAD'), 'request_status',  $direction, $ordering );?></th>
    </tr>
    </thead>
	<?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><a href="#edit" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit')"><?php echo stripslashes($row->name); ?></a></td>
      <td align="left"><a href="mailto:<?php echo $row->email; ?>"><?php echo $row->email; ?></a>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->CategoryName); ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->ResourceName); ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->ServiceName); ?>&nbsp;</td>
      <td align="left"><?php echo $row->display_startdate;?>&nbsp;<?php echo $row->display_starttime; ?></td>
      <td align="center"><?php echo $row->booked_seats; ?></td>
      <td align="center"><a href="#edit" onclick="setTxnID('<?php echo $row->id_transaction; ?>');"><?php echo $row->txnid; ?></a>&nbsp;</td>
      <td align="center"><?php echo $row->payment_status; ?></td>
      <td align="center"><?php echo $row->request_status; ?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="12"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <?php if($showWhat == "(New Requests)"){ ?>
	<input type="hidden" name="act" value="new" />
  <?php } else { ?>
  	<input type="hidden" name="act" value="all" />
  <?php } ?>
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="xid" id="xid" value="" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listResources( $option, &$rows, $direction, $ordering, $pageNav) {
?>
<style type="text/css">
<!--
.icon-48-resources { background-image: url(./components/com_rsappt_pro14/images/resources.png); }
-->
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_RES_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_NAME_COL_HEAD'), 'name', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), 'description', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JText::_('RS1_ADMIN_SCRN_DAYS_COL_HEAD') ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_TIMESLOTS_COL_HEAD'), 'timeslots', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_CATEGORY_COL_HEAD'), 'category_id', $direction, $ordering ); ?></th>
      <th width="5%" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ORDER_COL_HEAD'), 'display_order', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><a href="#edit_resource" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_resource')"><?php echo  stripslashes($row->name); ?></a></td>
      <td align="left"><?php echo stripslashes($row->description); ?>&nbsp;</td>
      <td align="center">  
   	  <?php 
		echo ($row->allowSunday=="Yes" ? JText::_('RS1_SUN').' ' : '');
		echo ($row->allowMonday=="Yes" ? JText::_('RS1_MON').' ' : '');
		echo ($row->allowTuesday=="Yes" ? JText::_('RS1_TUE').' ' : '');
		echo ($row->allowWednesday=="Yes" ? JText::_('RS1_WED').' ' : '');
		echo ($row->allowThursday=="Yes" ? JText::_('RS1_THU').' ' : '');
		echo ($row->allowFriday=="Yes" ? JText::_('RS1_FRI').' ' : '');
		echo ($row->allowSaturday=="Yes" ? JText::_('RS1_SAT').' ' : '');
		 ?></td>
      <td align="center"><?php echo $row->timeslots; ?>&nbsp;</td>
      <td align="center"><?php echo $row->cat_name; ?>&nbsp;</td>
      <td align="center"><?php echo $row->display_order; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="resources" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listCategories( $option, &$rows, $direction, $ordering, $pageNav) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-categories { background-image: url(./components/com_rsappt_pro14/images/pad.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_CAT_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
<?php echo JText::_('RS1_ADMIN_CAT_LIST_INTRO');?>
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th width="25%" class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_NAME_COL_HEAD'), 'name', $direction, $ordering ); ?></th>
      <th width="25%" class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), 'description', $direction, $ordering ); ?></th>
      <th width="25%" class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_CAT_PARENT_COL_HEAD'), 'parent_category_name', $direction, $ordering ); ?></th>
      <th width="5%" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ORDER_COL_HEAD'), 'ordering', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><a href="#edit_resource" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_category')"><?php echo  stripslashes($row->name); ?></a></td>
      <td align="left"><?php echo stripslashes($row->description); ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->parent_category_name); ?>&nbsp;</td>
      <td align="center"><?php echo $row->ordering; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="7"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="categories" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listServices( $option, &$rows, $direction, $ordering, $pageNav, $resource_idFilter) {

	
	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}


?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-services { background-image: url(./components/com_rsappt_pro14/images/pad.png); }
-->
}
</style>
<form action="index2.php" method="post" name="adminForm">
<table class="adminheading" width="100%">
        <tr>
          <th align="left" ><?php echo JText::_('RS1_ADMIN_SRV_LIST');?> <br /></th>
            <th>
            <table class="adminheading" align="right" cellspadding="2">
            <tr>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_RESID_COL_HEAD');?>:</td>
            <td><select name="resource_id" onchange="this.form.submit();" style="background-color:#FFFFCC" >
              <option value="0" <?php if($resource_id_Filter == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SRV_LIST_SELECT_RES');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
              <option value="<?php echo $res_row->id; ?>" <?php if($resource_idFilter == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
              <?php $k = 1 - $k; 
				} ?>
            </select>&nbsp;&nbsp;&nbsp;&nbsp;</td>
            </tr>
           </table>
         </th> 
      </tr>
  </table>
    <?php echo JText::_('RS1_ADMIN_SRV_LIST_INTRO');?>
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_SRV_NAME_COL_HEAD'), 'name', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), 'description', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_RESOURCE_COL_HEAD'), 'resource_id', $direction, $ordering ); ?></th>
      <th width="5%" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ORDER_COL_HEAD'), 'ordering', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><a href="#edit_resource" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_service')"><?php echo  stripslashes($row->name); ?></a></td>
      <td align="left"><?php echo stripslashes($row->description); ?>&nbsp;</td>
      <td align="center"><?php echo $row->res_name; ?>&nbsp;</td>
      <td align="center"><?php echo $row->ordering; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="7"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="services" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listPayPalTransactions( $option, &$rows, $direction, $ordering, $pageNav ) {
?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-paypal { background-image: url(./components/com_rsappt_pro14/images/pay.png); }
-->
}
</style>
<script>
	function setReqID(id){
		document.getElementById("xid").value = id;
		submitbutton('edit_direct');
		return false;
	}
</script>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_PAYPAL_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_PP_TXN_COL_HEAD'), 'txnid', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_REQ_ID_COL_HEAD'), 'custom', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_BUYER_COL_HEAD'), 'lastname', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_EMAIL_COL_HEAD'), 'buyer_email', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_PAY_DATE_COL_HEAD'), 'paymentdate', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort',  JText::_('RS1_ADMIN_PAYPAL_PAY_STATUS_COL_HEAD'), 'paymentstatus', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_GROSS_COL_HEAD'), 'mc_gross', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_FEE_COL_HEAD'), 'mc_fee', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_TAX_COL_HEAD'), 'tax', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_TIMESTAMP_COL_HEAD'), 'stamp', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><a href="#edit_transaction" onclick="return listItemTask('cb<?php echo $i;?>','edit_transaction')"><?php echo $row->txnid; ?></a></td>
      <td align="center"><a href="#edit" onclick="setReqID('<?php echo $row->custom; ?>');"><?php echo $row->custom; ?></a>&nbsp;</td>
      <td align="left"><?php echo $row->lastname; ?>, <?php echo $row->firstname; ?>&nbsp;</td>
      <td align="left"><?php echo $row->buyer_email; ?>&nbsp;</td>
      <td align="center"><?php echo $row->paymentdate; ?>&nbsp;</td>
      <td align="center"><?php echo $row->paymentstatus; ?>&nbsp;</td>
      <td align="right"><?php echo $row->mc_gross; ?>&nbsp;</td>
      <td align="right"><?php echo $row->mc_fee; ?>&nbsp;</td>
      <td align="right"><?php echo $row->tax; ?>&nbsp;</td>
      <td><?php echo $row->stamp; ?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

	?>
	<tfoot>
   	<td colspan="11"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="transactions" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="xid" id="xid" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listErrors( $option, &$rows, $direction, $ordering, $pageNav ) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-log { background-image: url(./components/com_rsappt_pro14/images/log.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_ERRLOG_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th width="15%" class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_TIMESTAMP_COL_HEAD'), 'stamp', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', 'Description', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><?php echo $row->stamp; ?></td>
      <td align="left"><?php echo $row->description; ?>&nbsp;</td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="4"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  

  
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="errorlog" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listReminders( $option, &$rows, $direction, $ordering, $pageNav ) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-log { background-image: url(./components/com_rsappt_pro14/images/log.png); }
-->
}
</style>
<script>
	function setReqID(id){
		document.getElementById("xid").value = id;
		submitbutton('edit_direct_from_reminders');
		return false;
	}
</script>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_REMLOG_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_REQ_ID_COL_HEAD'), 'request_id', $direction, $ordering ); ?></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_USER_ID_COL_HEAD'), 'user_id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_NAME_COL_HEAD'), 'name', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), 'description', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_PAYPAL_TIMESTAMP_COL_HEAD'), 'stamp', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><a href="#edit" onclick="setReqID('<?php echo $row->request_id; ?>');"><?php echo $row->request_id; ?></a>&nbsp;</td>
      <td align="center"><?php echo $row->user_id; ?>&nbsp;</td>
      <td><?php echo $row->name; ?>&nbsp;</td>
      <td align="left"><?php echo $row->description; ?>&nbsp;</td>
      <td align="center"><?php echo $row->local_time; ?>&nbsp;</td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="7"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  

  
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="reminderlog" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="xid" id="xid" value="" />
  <br />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listActivity( $option, &$rows, $direction, $ordering, $pageNav ) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-log { background-image: url(./components/com_rsappt_pro14/images/log.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_ACTIVITYLOG_LIST');?></th>
  </tr>
</table>
<?php echo JText::_('RS1_ADMIN_ACTIVITY_LOG_INTRO');?>
<form action="index2.php" method="post" name="adminForm">
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_ACTIVITY_TIMESTAMP_COL_HEAD'), 'stamp', $direction, $ordering ); ?></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_ACTIVITY_ITEM_COL_HEAD'), 'item_id', $direction, $ordering ); ?></th>
      <th width="5%" class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_ACTIVITY_USERID_COL_HEAD'), 'user_id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_ACTIVITY_NAME_COL_HEAD'), 'name', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', 'Description', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><?php echo $row->stamp; ?></td>
      <td align="center"><?php echo $row->item_id; ?>&nbsp;</td>
      <td align="center"><?php echo $row->user_id; ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->name); ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->description); ?>&nbsp;</td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="7"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="activitylog" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listTimeSlots( $option, &$rows, $direction, $ordering, $pageNav, $day_numberFilter, $resource_idFilter) {

	$daynames = array(0=>JText::_('RS1_SUNDAY'), 1=>JText::_('RS1_MONDAY'), 2=>JText::_('RS1_TUESDAY'), 3=>JText::_('RS1_WEDNESDAY'), 4=>JText::_('RS1_THURSDAY'), 5=>JText::_('RS1_FRIDAY'), 6=>JText::_('RS1_SATURDAY'));
	
	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources WHERE timeslots != 'Global' ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	
?>
<style type="text/css">
<!--
.icon-48-timeslots { background-image: url(./components/com_rsappt_pro14/images/timeslots.jpg); }
-->
}
</style>
<form action="index2.php" method="post" name="adminForm">
    <table class="adminheading" width="100%">
        <tr>
          <th align="left" ><?php echo JText::_('RS1_ADMIN_TIMESLOT_LIST');?> <br /></th>
            <th>
            <table class="adminheading" align="right" cellspadding="2">
            <tr>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_RESOURCE_COL_HEAD');?>*:</td>
            <td><select name="resource_id" onchange="this.form.submit();" style="background-color:#FFFFCC" >
              <option value="0" <?php if($resource_id_Filter == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_GLOBAL');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
              <option value="<?php echo $res_row->id; ?>" <?php if($resource_idFilter == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
              <?php $k = 1 - $k; 
				} ?>
            </select>&nbsp;&nbsp;&nbsp;&nbsp;</td>
            <td>
                <?php echo JText::_('RS1_ADMIN_SCRN_DAY_COL_HEAD');?>:            </td>
            <td>
                <select name="day_number" onchange="this.form.submit();" style="background-color:#FFFFCC" >
                  <option value="all" <?php if($day_numberFilter == "all"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_SHOW_ALL')?></option>
                  <option value="0"<?php if($day_numberFilter == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_SUNDAY')?></option>
                  <option value="1"<?php if($day_numberFilter == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_MONDAY')?></option>
                  <option value="2"<?php if($day_numberFilter == "2"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_TUESDAY')?></option>
                  <option value="3"<?php if($day_numberFilter == "3"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_WEDNESDAY')?></option>
                  <option value="4"<?php if($day_numberFilter == "4"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_THURSDAY')?></option>
                  <option value="5"<?php if($day_numberFilter == "5"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_FRIDAY')?></option>
                  <option value="6"<?php if($day_numberFilter == "6"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_SATURDAY')?></option>
                </select>&nbsp;&nbsp;            </td>
            </tr>
           </table>
         </th> 
      </tr>
    </table>
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
   <thead>
    <tr>
      <th width="5%" align="center"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_RESID_COL_HEAD'), 'resource_id', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DAY_COL_HEAD'), 'day_number', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_START_COL_HEAD'), 'timeslot_starttime', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_END_COL_HEAD'), 'timeslot_endtime', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PUB_START_COL_HEAD'), 'start_publishing', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PUB_END_COL_HEAD'), 'end_publishing', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
  </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td width="5%" align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td width="5%" align="center"><a href="#edit_timeslot" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_timeslot')"><?php echo $row->id; ?></a></td>
      <td width="15%" align="center"><?php echo ($row->name == ""?"Global": stripslashes($row->name)); ?>&nbsp;</td>
      <td width="15%" align="center"><?php echo $daynames[$row->day_number]; ?>&nbsp;</td>
      <td width="15%" align="center"><?php echo $row->timeslot_starttime; ?>&nbsp;</td>
      <td width="15%" align="center"><?php echo $row->timeslot_endtime; ?>&nbsp;</td>
      <td align="center"><?php echo $row->start_publishing; ?>&nbsp;</td>
      <td align="center"><?php echo $row->end_publishing; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>	<tfoot>
    	<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
<?php echo JText::_('RS1_ADMIN_TIMESLOT_LIST_FOOTER');?>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="ts_setup" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listBookOffs( $option, &$rows, $direction, $ordering, $pageNav, $resource_idFilter) {

	
	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	
?>
<style type="text/css">
<!--
.icon-48-bookoffs { background-image: url(./components/com_rsappt_pro14/images/bookoffs.jpg); }
-->
}
</style>
<form action="index2.php" method="post" name="adminForm">
    <table class="adminheading" width="100%">
        <tr>
          <th align="left" ><?php echo JText::_('RS1_ADMIN_BOOKOFFS_LIST');?> <br /></th>
            <th>
            <table class="adminheading" align="right" cellspadding="2">
            <tr>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_RESID_COL_HEAD');?>:</td>
            <td><select name="resource_id" onchange="this.form.submit();" style="background-color:#FFFFCC" >
              <option value="0" <?php if($resource_id_Filter == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SRV_LIST_SELECT_RES');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
              <option value="<?php echo $res_row->id; ?>" <?php if($resource_idFilter == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
              <?php $k = 1 - $k; 
				} ?>
            </select>&nbsp;&nbsp;&nbsp;&nbsp;</td>
            </tr>
           </table>
         </th> 
      </tr>
    </table>
    <?php echo JText::_('RS1_ADMIN_BOOKOFFS_LIST_INTRO');?>
    <table cellpadding="4" cellspacing="0" border="0" class="adminlist" width="100%">
   <thead>
    <tr>
      <th width="5%" align="center"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_RESID_COL_HEAD'), 'resource_id', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DATEOFF_COL_HEAD'), 'off_date', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_BOOKOFF_FULDAY_COL_HEAD'), 'full_day', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_BOOKOFF_RANGE_COL_HEAD'), 'hours', $direction, $ordering ); ?></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_DESCRIPTION_COL_HEAD'), 'description', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
 	  <th width="40%" nowrap="nowrap">&nbsp;</th>
    </tr>
  </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td width="5%" align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td width="5%" align="center"><a href="#edit_timeslot" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_bookoff')"><?php echo $row->id; ?></a></td>
      <td width="20%" align="center"><?php echo ($row->name == ""?"Global": stripslashes($row->name)); ?>&nbsp;</td>
      <td width="20%" align="center"><?php echo $row->off_date_display; ?>&nbsp;</td>
      <td width="10%" align="center"><?php echo $row->full_day; ?>&nbsp;</td>
      <td width="10%" align="center"><?php echo $row->hours; ?>&nbsp;</td>
      <td width="20%" align="center"><?php echo stripslashes($row->description); ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <td align="left">&nbsp;</td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>	<tfoot>
    	<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
<br />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="bookoffs" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 

function listUdfs( $option, &$rows, $direction, $ordering, $pageNav) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-udf { background-image: url(./components/com_rsappt_pro14/images/udf.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_UDF_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_UDF_SCREEN_LABEL'), 'udf_label', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_UDF_TYPE'), 'udf_type', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_UDF_REQUIRED'), 'udf_required', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_UDF_USERHELP'), 'udf_help', $direction, $ordering ); ?></th>
      <th width="5%" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ORDER_COL_HEAD'), 'ordering', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td><a href="#edit_udf" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_udf')"><?php echo  stripslashes($row->udf_label); ?></a></td>
      <td align="center"><?php echo $row->udf_type; ?>&nbsp;</td>
      <td align="center"><?php echo ($row->udf_type == "Textbox" || $row->udf_type == "Textarea" || $row->udf_type == "Checkbox" ? $row->udf_required : "--"); ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($row->udf_help); ?>&nbsp;</td>
      <td align="center"><?php echo $row->ordering; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="8"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="udfs" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 


function listCoupons( $option, &$rows, $direction, $ordering, $pageNav) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-coupon { background-image: url(./components/com_rsappt_pro14/images/coupon.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_COUPON_LIST');?></th>
  </tr>
</table>
<form action="index2.php" method="post" name="adminForm">
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_COUPON_DESC'), 'description', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_COUPON_CODE'), 'coupon_code', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_COUPON_VALUE'), 'discount', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_COUPON_TYPE'), 'discount_unit', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_COUPON_MAX_USER_USE_COL'), 'max_user_use', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_COUPON_MAX_TOTAL_USE_COL'), 'max_total_use', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_COUPON_CUR_TOTAL_USE_COUNT'), 'current_count', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_COUPON_EXPIRY'), 'expiry_date', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><a href="#edit_coupon" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_coupon')"><?php echo  $row->id; ?></a></td>
      <td align="left"><?php echo stripslashes($row->description); ?>&nbsp;</td>
      <td align="center"><?php echo $row->coupon_code; ?>&nbsp;</td>
      <td align="center"><?php echo $row->discount; ?>&nbsp;</td>
      <td align="center"><?php echo $row->discount_unit; ?>&nbsp;</td>
      <td align="center"><?php echo $row->max_user_use; ?>&nbsp;</td>
      <td align="center"><?php echo $row->max_total_use; ?>&nbsp;</td>
      <td align="center"><?php echo $row->current_count; ?>&nbsp;</td>
      <td align="center"><?php echo $row->expiry; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="11"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="coupons" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 


function listSeatTypes( $option, &$rows, $direction, $ordering, $pageNav) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-seats { background-image: url(./components/com_rsappt_pro14/images/seats.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_SEAT_TYPE_LIST');?></th>
  </tr>
</table>
<p><?php echo JText::_('RS1_ADMIN_SEAT_TYPE_INTRO');?><br />&nbsp;</p>
<form action="index2.php" method="post" name="adminForm">
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SEAT_TYPE_LABEL'), 'seat_type_label', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SEAT_TYPE_COST'), 'seat_type_cost', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_GROUP_SEAT'), 'seat_group', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SEAT_ORDERING'), 'ordering', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td align="center"><a href="#edit_seat" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_seat')"><?php echo  $row->seat_type_label; ?></a></td>
      <td align="center"><?php echo $row->seat_type_cost; ?>&nbsp;</td>
      <td align="center"><?php echo $row->seat_group; ?>&nbsp;</td>
      <td align="center"><?php echo $row->ordering; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="8"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="seats" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 


function listExtras( $option, &$rows, $direction, $ordering, $pageNav) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-extras { background-image: url(./components/com_rsappt_pro14/images/extras.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_EXTRAS_LIST');?></th>
  </tr>
</table>
<p><?php echo JText::_('RS1_ADMIN_EXTRAS_INTRO');?><br />&nbsp;</p>
<form action="index2.php" method="post" name="adminForm">
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_EXTRAS_LABEL'), 'extras_label', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_EXTRAS_COST'), 'extras_cost', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_EXTRAS_UNITS'), 'cost_unit', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_EXTRAS_ORDERING'), 'ordering', $direction, $ordering ); ?></th>
 	  <th width="5%" nowrap="nowrap"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_PUBLISHED_COL_HEAD'), 'published', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td align="center"><a href="#edit_seat" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_extra')"><?php echo  $row->extras_label; ?></a></td>
      <td align="center"><?php echo $row->extras_cost; ?>&nbsp;</td>
      <td align="center"><?php echo $row->cost_unit; ?>&nbsp;</td>
      <td align="center"><?php echo $row->ordering; ?>&nbsp;</td>
	  <td align="center"><?php echo $published;?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="8"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="extras" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 


function listUserCredit( $option, &$rows, $direction, $ordering, $pageNav) {

?>
<?php echo $row->id; ?>
<style type="text/css">
<!--
.icon-48-vault { background-image: url(./components/com_rsappt_pro14/images/vault.png); }
-->
}
</style>
<table class="adminheading">
  <tr>
    <th><?php echo JText::_('RS1_ADMIN_USER_CREDIT_LIST');?></th>
  </tr>
</table>
<p><?php echo JText::_('RS1_ADMIN_USER_CREDIT_INTRO');?><br />&nbsp;</p>
<form action="index2.php" method="post" name="adminForm">
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="3%"><input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" /></th>
      <th class="title" align="center"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'), 'id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_USER_CREDIT_ID'), 'user_id', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_USER_CREDIT_NAME'), 'name', $direction, $ordering ); ?></th>
      <th class="title" align="left"><?php echo JHTML::_( 'grid.sort', JText::_('RS1_ADMIN_USER_CREDIT_BALANCE'), 'balance', $direction, $ordering ); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $rows ); $i++) {
	$row = $rows[$i];
	$published 	= JHTML::_('grid.published', $row, $i );
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" /></td>
      <td align="center"><?php echo $row->id; ?>&nbsp;</td>
      <td align="center"><a href="#edit_credit" onclick="hideMainMenu(); return listItemTask('cb<?php echo $i;?>','edit_credit')"><?php echo  $row->user_id; ?></a></td>
      <td align="center"><?php echo $row->name; ?>&nbsp;</td>
      <td align="center"><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?>&nbsp;<?php echo $row->balance; ?>&nbsp;</td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 

?>
	<tfoot>
   	<td colspan="8"><?php echo $pageNav->getListFooter(); ?></td>
    </tfoot>
  </table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="act" value="credit" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $ordering ?>" />
  <input type="hidden" name="filter_order_Dir" value ="<?php echo $direction ?>" />
  <input type="hidden" name="hidemainmenu" value="0" />  
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php } 


function editResource( $option, &$row ) {

	// get data for dropdowns
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__users ORDER BY name" );
	$user_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_categories ORDER BY name" );
	$cat_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	
	// get resource admins
	if (strlen($row->resource_admins) > 0 ){
		$admins = str_replace("||", ",", $row->resource_admins);
		$admins = str_replace("|", "", $admins);
		//echo $admins;
		//exit;
		$sql = "SELECT id as userid, name as username FROM #__users WHERE ".
  			"id IN (".$admins.")";
		$database->setQuery($sql);
		$admins_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}	

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}
	
	$admin_users = "";
	
?>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript">
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<script language="javascript">
	function doAddUser(){
		var userid = document.getElementById("users").value;
		var admin_users = document.getElementById("resource_admins_id").value;
		var x = document.getElementById("admins");
		for (i=0;i<x.length;i++){
			if(x[i].value == userid) {
				alert("Already selected");
				return false;
			}			
		}
	
		var opt = document.createElement("option");
        // Add an Option object to Drop Down/List Box
        document.getElementById("admins").options.add(opt); 
        opt.text = document.getElementById("users").options[document.getElementById("users").selectedIndex].text;
        opt.value = document.getElementById("users").options[document.getElementById("users").selectedIndex].value;
		admin_users = admin_users + "|" + userid + "|";
		document.getElementById("resource_admins_id").value = admin_users;
	}

	function doRemoveUser(){
		if(document.getElementById("admins").selectedIndex == -1){
			alert("No Administrator selected for Removal");
			return false;
		}
		var user_to_go = document.getElementById("admins").options[document.getElementById("admins").selectedIndex].value;
		document.getElementById("admins").remove(document.getElementById("admins").selectedIndex);
		
		var admin_users = document.getElementById("resource_admins_id").value;

		admin_users = admin_users.replace("|" + user_to_go + "|", "");
		document.getElementById("resource_admins_id").value = admin_users;
	}

	function setHidden(which_day){
		if(document.getElementById('chk'+which_day).checked==true){
			document.getElementById('allow'+which_day).value = "Yes";
		} else {
			document.getElementById('allow'+which_day).value = "No";
		}
		// ensure at least one day is checked
		if(document.getElementById('chkSunday').checked==false 
			&& document.getElementById('chkMonday').checked==false
			&& document.getElementById('chkTuesday').checked==false
			&& document.getElementById('chkWednesday').checked==false
			&& document.getElementById('chkThursday').checked==false
			&& document.getElementById('chkFriday').checked==false
			&& document.getElementById('chkSaturday').checked==false){
			alert("You cannot un-check ALL days, you must allow bookings on at least one day.");
			document.getElementById('chk'+which_day).checked=true
		}			
		return true;
	}
 
	function set_disable_before_radios(){
		if(document.getElementById('disable_dates_before').value == "Tomorrow"){
			document.getElementById('disable_dates_before_tomorrow').checked = true;
		} else {
			document.getElementById('disable_dates_before_specific').checked = true;
		}
	}
	
	function set_disable_after_radios(){
		if(document.getElementById('disable_dates_after').value == "Not Set"){
			document.getElementById('disable_dates_after_notset').checked = true;
		} else {
			document.getElementById('disable_dates_after_specific').checked = true;
		}
	}

	function setTomorrow(){
		document.getElementById('disable_dates_before').value = "Tomorrow";
	}

	function setToday(){
		document.getElementById('disable_dates_before').value = "Today";
	}

	function setNotSet(){
		document.getElementById('disable_dates_after').value = "Not Set";
	}
	
	function setAfterXDays(){
		document.getElementById('disable_dates_after').value = "XDays";
	}

	function setBeforeXDays(){
		document.getElementById('disable_dates_before').value = "XDays";
	}

</script>
<script language="javascript">
function submitbutton(pressbutton) {
   	if (pressbutton == 'save_resource'){
		if(document.getElementById("name").value == ""){
			alert("Name is required");
		} else {
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}
</script>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<?php echo JText::_('RS1_ADMIN_SCRN_RES_INTRO');?><hr />
<table border="0" cellpadding="4" cellspacing="0">
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_ID');?></td>
      <td colspan="2"><?php echo $row->id; ?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_NAME');?></td>
      <td><input type="text" size="40" maxsize="50" name="name" id="name" value="<?php echo stripslashes($row->name); ?>" /></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DESC');?> </td>
      <td><input type="text" size="60" maxsize="80" name="description" value="<?php echo stripslashes($row->description); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DESC_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_ACCESS');?></td>
      <td><select name="access" >
          <option value="everyone" <?php if($row->access == "" or $row->access == "everyone"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_ACCESS_EVERYONE');?></option>
          <option value="registered_only" <?php if($row->access == "registered_only"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_ACCESS_REGISTERED');?></option>
          <option value="public_only" <?php if($row->access == "public_only"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_ACCESS_PUBLIC');?></option>
	      </select>&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_ACCESS_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_CATEGORY');?></td>
      <td><select name="category_id" >
          <option value="0" ><?php echo JText::_('RS1_ADMIN_SCRN_RES_CATEGORY_SEL');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $cat_rows ); $i++) {
				$cat_row = $cat_rows[$i];
				?>
          <option value="<?php echo $cat_row->id; ?>"  <?php if($row->category_id == $cat_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($cat_row->name); ?></option>
              <?php $k = 1 - $k; 
				} ?>
      </select>&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_CATEGORY_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_COST');?></td>
      <td><input type="text" size="20" maxsize="20" name="cost" value="<?php echo $row->cost; ?>" />&nbsp;&nbsp;</td>
      <td width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_RES_COST_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_RES_RATE');?></td>
      <td ><input type="text" size="8" maxsize="10" name="rate" value="<?php echo $row->rate; ?>" />
        &nbsp;&nbsp;&nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_RES_RATE_UNIT');?> <select name="rate_unit">
          <option value="Hour" <?php if($row->rate_unit == "Hour"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_RATE_HOUR');?></option>
          <option value="Flat" <?php if($row->rate_unit == "Flat"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_RATE_BOOKING');?></option>
        </select>        </td>
      <td width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_RES_RATE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_EMAILTO');?></td>
      <td valign="top"><input type="text" size="60" maxsize="200" name="resource_email" value="<?php echo $row->resource_email; ?>" />
        <br /></td>
      <td width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_RES_EMAILTO_HELP');?></td>
    </tr>
<!--    <tr  class="admin_detail_row0" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_SEND_ICS');?> </td>
      <td><select name="send_ics">
          <option value="Yes" <?php if($row->send_ics == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->send_ics == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_SEND_ICS_HELP');?></td>
    </tr>    
-->    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_SMS_PHONE');?></td>
      <td valign="top"><input type="text" size="60" maxsize="200" name="sms_phone" value="<?php echo $row->sms_phone; ?>"/></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_SMS_PHONE_HELP');?></td>
    </tr>
<!--    <tr  class="admin_detail_row1" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DUPES');?> </td>
      <td><select name="prevent_dupe_bookings">
          <option value="Global" <?php if($row->prevent_dupe_bookings == "Global"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_DUPES_GLOBAL');?></option>
          <option value="Yes" <?php if($row->prevent_dupe_bookings == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
          <option value="No" <?php if($row->prevent_dupe_bookings == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
        </select>
      &nbsp;&nbsp; <?php echo JText::_('RS1_ADMIN_SCRN_RES_MAX_DUPES');?> 
      <input type="text" name="max_dupes" id="max_dupes" size="2" maxlength="4" align="right" value="<?php echo $row->max_dupes; ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DUPES_HELP');?></td>
    </tr>    
-->
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_MAX_SEATS');?></td>
      <td valign="top"><input type="text" size="2" maxsize="3" name="max_seats" value="<?php echo $row->max_seats; ?>"/></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_MAX_SEATS_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DEF_CAL_CAT');?> </td>
      <td><input type="text" size="25" maxsize="25" name="default_calendar_category" value="<?php echo $row->default_calendar_category; ?>" />
        &nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_RES_DEF_CAL_CAT_HINT');?></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DEF_CAL_CAT_HELP');?></td>  
    </tr>
    <tr class="admin_detail_row0" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DEF_CAL_CAL');?>  </td>
      <td><input type="text" size="25" maxsize="25" name="default_calendar" value="<?php echo $row->default_calendar; ?>" />
        &nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_RES_DEF_CAL_CAL_HINT');?></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DEF_CAL_CAL_HELP');?></td>  
    </tr>
    <tr class="admin_detail_row0" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_USER');?>  </td>
      <td><input type="text" size="35" maxsize="255" name="google_user" value="<?php echo $row->google_user; ?>" />
        &nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_USER_HINT');?></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_USER_HELP');?></td>  
    </tr>
    <tr class="admin_detail_row0" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_PASSWORD');?>  </td>
      <td><input type="password" size="35" maxsize="255" name="google_password" value="<?php echo $row->google_password; ?>" />
       &nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_USER_HINT');?></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_PASSWORD_HELP');?></td>  
    </tr>
    <tr class="admin_detail_row0" >
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_CAL_ID');?>  </td>
      <td><input type="text" size="50" maxsize="255" name="google_default_calendar_name" value="<?php echo $row->google_default_calendar_name; ?>" />
        &nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_CAL_ID_HINT');?></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_GOOGLE_CAL_ID_HELP');?></td>  
    </tr>

    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_ADMINS');?></td>
      <td>
      <table width="95%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="33%"><select name="users" id="users">
            <?php
			$k = 0;
			for($i=0; $i < count( $user_rows ); $i++) {
			$user_row = $user_rows[$i];
			?>
                <option value="<?php echo $user_row->id; ?>"><?php echo $user_row->name; ?></option>
                <?php $k = 1 - $k; 
			} ?>
              </select></td>
            <td width="34%" valign="top" align="center"><input type="button" name="btnAddUser" id="btnAddUser" size="10" value="<?php echo JText::_('RS1_ADMIN_SCRN_RES_ADMINS_ADD');?>" onclick="doAddUser()" />
              <br />
              &nbsp;<br />
              <input type="button" name="btnRemoveUser" id="btnRemoveUser" size="10"  onclick="doRemoveUser()" value="<?php echo JText::_('RS1_ADMIN_SCRN_RES_ADMINS_REMOVE');?>" /></td>
            <td width="33%">
            <select name="admins" id="admins" size="4" >
             <?php
			$k = 0;
			for($i=0; $i < count( $admins_rows ); $i++) {
			$admins_row = $admins_rows[$i];
			?>
                <option value="<?php echo $admins_row->userid; ?>"><?php echo $admins_row->username; ?></option>
                <?php 
				$admin_users = $admin_users."|".$admins_row->userid."|";
				$k = 1 - $k; 
			} ?>
              </select>            </td>
          </tr>
        </table></td>
    <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_ADMINS_HELP');?></td>
    </tr>
	<tr class="admin_detail_row0">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_TIMESLOTS');?></td>
	  <td ><select name="timeslots">
        <option value="Global" <?php if($row->timeslots == "Global"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_USEGLOBAL');?></option>
        <option value="Specific" <?php if($row->timeslots == "Specific"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_RES_SPEC');?></option>
      </select></td>
	  <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_TIMESLOTS_HELP');?></td>
    </tr>
	<tr class="admin_detail_row1">
      <td width="17%"><?php echo JText::_('RS1_ADMIN_SCRN_RES_BOOKING_DAYS');?></td>
      <td width="38%" valign="bottom"><table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr align="center">
            <td><?php echo JText::_('RS1_ADMIN_SCRN_SUN');?></td>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_MON');?></td>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_TUE');?></td>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_WED');?></td>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_THU');?></td>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_FRI');?></td>
            <td><?php echo JText::_('RS1_ADMIN_SCRN_SAT');?></td>
            <td>&nbsp;</td>
          </tr>
          <tr align="center">
            <td><input type="checkbox" name="chkSunday" id="chkSunday" onclick="setHidden('Sunday');"  <?php if($row->allowSunday == "Yes"){echo "checked";} ?>/></td>
            <td><input type="checkbox" name="chkMonday" id="chkMonday" onclick="setHidden('Monday');" <?php if($row->allowMonday == "Yes"){echo "checked";} ?>/></td>
            <td><input type="checkbox" name="chkTuesday" id="chkTuesday" onclick="setHidden('Tuesday');" <?php if($row->allowTuesday == "Yes"){echo "checked";} ?>/></td>
            <td><input type="checkbox" name="chkWednesday" id="chkWednesday" onclick="setHidden('Wednesday');" <?php if($row->allowWednesday == "Yes"){echo "checked";} ?>/></td>
            <td><input type="checkbox" name="chkThursday" id="chkThursday" onclick="setHidden('Thursday');" <?php if($row->allowThursday == "Yes"){echo "checked";} ?>/></td>
            <td><input type="checkbox" name="chkFriday" id="chkFriday" onclick="setHidden('Friday');" <?php if($row->allowFriday == "Yes"){echo "checked";} ?>/></td>
            <td><input type="checkbox" name="chkSaturday" id="chkSaturday" onclick="setHidden('Saturday');" <?php if($row->allowSaturday == "Yes"){echo "checked";} ?>/></td>
            <td></td>
          </tr>
        </table>
        <input type="hidden" name="allowSunday" id="allowSunday" value="<?php echo $row->allowSunday?>" />
        <input type="hidden" name="allowMonday" id="allowMonday" value="<?php echo $row->allowMonday?>" />
        <input type="hidden" name="allowTuesday" id="allowTuesday" value="<?php echo $row->allowTuesday?>" />
        <input type="hidden" name="allowWednesday" id="allowWednesday" value="<?php echo $row->allowWednesday?>" />
        <input type="hidden" name="allowThursday" id="allowThursday" value="<?php echo $row->allowThursday?>" />
        <input type="hidden" name="allowFriday" id="allowFriday" value="<?php echo $row->allowFriday?>" />
        <input type="hidden" name="allowSaturday" id="allowSaturday" value="<?php echo $row->allowSaturday?>" />      </td>
      <td width="50%" valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_BOOKING_DAYS_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_RES_NON_WORK_HIDE');?></td>
        <td >
            <select name="non_work_day_hide">
            <option value="No" <?php if($row->non_work_day_hide == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="Yes" <?php if($row->non_work_day_hide == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>
        </td>
         <td width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_RES_NON_WORK_HIDE_HELP');?></td>
    </tr>  
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_NON_WORK_MESSAGE');?></td>
      <td valign="top"><input type="text" size="60" maxsize="255" name="non_work_day_message" value="<?php echo $row->non_work_day_message; ?>" />
        <br /></td>
      <td width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_RES_NON_WORK_MESSAGE_HELP');?></td>
    </tr>
	<tr class="admin_detail_row0">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_MIN_LEAD');?></td>
	  <td ><input type="text" size="2" maxlength="2" name="min_lead_time" id="min_lead_time" class="sv_apptpro_request_text" 
      value="<?php echo $row->min_lead_time; ?>"/>&nbsp;  <?php echo JText::_('RS1_ADMIN_SCRN_RES_MIN_LEAD_UNITS');?></td>
	  <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_MIN_LEAD_HELP');?></td>
    </tr>
	<tr class="admin_detail_row1">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DISABLE_BEFORE');?></td>
	  <td >
		<p>
		  <input type="radio" name="rdo_disable_dates_before" id="disable_dates_before_today" value="disable_dates_before_today"
      	<?php echo ($row->disable_dates_before == "Today" ? "checked='checked'" : "");?> onclick="setToday();" />
		  <?php echo JText::_('RS1_ADMIN_SCRN_RES_TODAY');?>&nbsp;
		  <br />      
		  <input type="radio" name="rdo_disable_dates_before" id="disable_dates_before_tomorrow" value="disable_dates_before_tomorrow"
      	<?php echo ($row->disable_dates_before == "Tomorrow" ? "checked='checked'" : "");?> onclick="setTomorrow();" />
	    <?php echo JText::_('RS1_ADMIN_SCRN_RES_TOMORROW');?>&nbsp;&nbsp; <Br />
		<input type="radio" name="rdo_disable_dates_before" id="disable_dates_before_xdays" value="disable_dates_before_xdays"
      	<?php echo ($row->disable_dates_before == "XDays" ? "checked='checked'" : "");?> onclick="setBeforeXDays();" />
	    <input type="text" size="2" name="disable_dates_before_days" id="disable_dates_before_days" value="<?php echo $row->disable_dates_before_days?>" /> 
	    <?php echo JText::_('RS1_ADMIN_SCRN_RES_DAYS_FROM_NOW');?>&nbsp;&nbsp; 
        <Br />		  <input type="radio" name="rdo_disable_dates_before" id="disable_dates_before_specific" value="disable_dates_before_specific" 
        <?php echo (($row->disable_dates_before != "Tomorrow" AND $row->disable_dates_before != "Today" AND $row->disable_dates_before != "XDays")? "checked='checked'" : "");?>/>
		  <?php echo JText::_('RS1_ADMIN_SCRN_RES_SPEC_DATE');?>
		  <input type="text" name="disable_dates_before" id="disable_dates_before" size="10" readonly="readonly" value="<?php echo $row->disable_dates_before; ?>" 
      	onchange="set_disable_before_radios();" />
          <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].disable_dates_before,'anchor1','yyyy-MM-dd'); return false;"
					 name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a></p></td>
	  <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_DISABLE_BEFORE_HELP');?></td>
    </tr>
	<tr class="admin_detail_row0">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_RES_DISABLE_AFTER');?></td>
	  <td ><input type="radio" name="rdo_disable_dates_after" id="disable_dates_after_notset" value="disable_dates_after_notset" 
      <?php echo ($row->disable_dates_after == "Not Set" ? "checked='checked'" : "");?> onclick="setNotSet();"/> 
	    <?php echo JText::_('RS1_ADMIN_SCRN_RES_NOT_SET');?>&nbsp;&nbsp;
		<Br />
		<input type="radio" name="rdo_disable_dates_after" id="disable_dates_after_xdays" value="disable_dates_after_xdays"
      	<?php echo ($row->disable_dates_after == "XDays" ? "checked='checked'" : "");?> onclick="setAfterXDays();" />
	    <input type="text" size="2" name="disable_dates_after_days" id="disable_dates_after_days" value="<?php echo $row->disable_dates_after_days?>" /> 
	    <?php echo JText::_('RS1_ADMIN_SCRN_RES_DAYS_FROM_NOW');?>&nbsp;&nbsp;  
        <br />
        <input type="radio" name="rdo_disable_dates_after" id="disable_dates_after_specific" value="disable_dates_after_specific"
        <?php echo (($row->disable_dates_after != "Not Set" && $row->disable_dates_after != "XDays") ? "checked='checked'" : "");?> />
        <?php echo JText::_('RS1_ADMIN_SCRN_RES_SPEC_DATE');?> 
        <input type="text" name="disable_dates_after" id="disable_dates_after"size="10" readonly="readonly"  
        	value="<?php echo $row->disable_dates_after; ?>"  onchange="set_disable_after_radios();"/>
        <a href="#" id="anchor2" onclick="cal.select(document.forms['adminForm'].disable_dates_after,'anchor2','yyyy-MM-dd'); return false;"
					 name="anchor2"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a> </td>
	  <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_RES_DISABLE_AFTER_HELP');?></td>
    </tr>
	<tr class="admin_detail_row1">
	  <td colspan="3"><?php echo JText::_('RS1_ADMIN_SCRN_RES_DISABLE_DATES');?></td>
    </tr>
	<tr  class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_DISPLAY_ORDER');?></td>
      <td><input type="text" size="5" maxsize="2" name="display_order" value="<?php echo $row->display_order; ?>" />
        &nbsp;&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_DISPLAY_ORDER_HELP');?></td>      
    </tr>
    <tr class="admin_detail_row1">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_RES_PUBLISHED');?></td>
        <td colspan="2">
            <select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="resource_admins" id="resource_admins_id" value="<?php echo $admin_users; ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php }

function editTransaction( $option, &$row ) {
?>
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">

  <table border="0" cellpadding="2" cellspacing="0">
    <tr class="admin_detail_row0">
      <td colspan="2"><u><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_INTRO');?></u></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_ID');?></td>
      <td><?php echo $row->txnid; ?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_REQID');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="10" maxsize="10" name="custom" value="<?php echo $row->custom; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_FIRSTNAME');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="100" name="firstname" value="<?php echo stripslashes($row->firstname); ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_LASTNAME');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="100" name="lastname" value="<?php echo stripslashes($row->lastname); ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_EMAIL');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="50" maxsize="100" name="buyer_email" value="<?php echo $row->buyer_email; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_STREET');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="100" name="street" value="<?php echo $row->street; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_CITY');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="50" name="city" value="<?php echo $row->city; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_PROVSTATE');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="40" name="state" value="<?php echo $row->state; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_POSTALZIP');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="10" maxsize="11" name="zipcode" value="<?php echo $row->zipcode; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_PAYDATE');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="30" maxsize="50" name="paymentdate" value="<?php echo $row->paymentdate; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_AMOUNT');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="6" maxsize="6" name="mc_gross" value="<?php echo $row->mc_gross; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_FEE');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="6" maxsize="5" name="mc_fee" value="<?php echo $row->mc_fee; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_TAX');?></td>
      <td colspan="2" align=""><input type="text" readonly="readonly" size="6" maxsize="10" name="tax" value="<?php echo $row->tax; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_PAY_STATUS');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="15" name="paymentstatus" value="<?php echo $row->paymentstatus; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_PENDING');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="20" maxsize="10" name="pendingreason" value="<?php echo $row->pendingreason; ?>" /></td>
    </tr>

    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_CURRENCY');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="5" maxsize="5" name="mc_currency" value="<?php echo $row->mc_currency; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_PP_TXN_DETAIL_REASON');?></td>
      <td colspan="2"><input type="text" readonly="readonly" size="10" maxsize="10" name="reasoncode" value="<?php echo $row->reasoncode; ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_PP_MEMO');?></td>
      <td colspan="2"><textarea rows="2" cols="30" readonly="readonly" ><?php echo stripslashes($row->memo); ?></textarea></td>
    </tr>
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }


function editTimeSlot( $option, &$row ) {

	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	if(JRequest::getVar( 'day_number') == "all"){
		$day_number = $row->day_number;
	} else {
		$day_number = JRequest::getVar( 'day_number');
	}
	$resource = JRequest::getVar( 'resource_id');
	
	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}	
?>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript" src="../components/com_rsappt_pro14/date.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.addDisabledDates(null,formatDate(now,"yyyy-MM-dd")); 
	cal.showYearNavigation();
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<script>
	function setstarttime(){
		document.getElementById("timeslot_starttime").value = document.getElementById("timeslot_starttime_hour").value + ":" + document.getElementById("timeslot_starttime_minute").value + ":00";
	}
	function setendtime(){
		document.getElementById("timeslot_endtime").value = document.getElementById("timeslot_endtime_hour").value + ":" + document.getElementById("timeslot_endtime_minute").value + ":00";
	}
</script>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3"><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_INTRO');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="20%"><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_ID');?></td>
      <td><?php echo $row->id ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_RESOURCE');?></td>
      <td ><select name="resource_id" >
          <option value="0" ><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_GLOBAL');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
          <option value="<?php echo $res_row->id; ?>"  <?php if($resource == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->name); ?></option>
              <?php $k = 1 - $k; 
				} ?>
      </select>
      &nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_RESOURCE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_DAY');?></td>
      <td colspan="3"><select name="day_number">
          <option value="0" <?php if($day_number == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_SUNDAY');?></option>
          <option value="1" <?php if($day_number == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_MONDAY');?></option>
          <option value="2" <?php if($day_number == "2"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_TUESDAY');?></option>
          <option value="3" <?php if($day_number == "3"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_WEDNESDAY');?></option>
          <option value="4" <?php if($day_number == "4"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_THURSDAY');?></option>
          <option value="5" <?php if($day_number == "5"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_FRIDAY');?></option>
          <option value="6" <?php if($day_number == "6"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_SATURDAY');?></option>
        </select></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_START');?> </td>
      <td><select name="timeslot_starttime_hour" id="timeslot_starttime_hour" onchange="setstarttime();" class="sv_ts_request_dropdown" <?php if($row->hoursLimit == '24Hour'){ echo ' disabled ' ;} ?>>
		<?php
		for($x=0; $x<24; $x+=1){
/*			if($x==12){
				echo "<option value=".$x.":00:00"; if($row->timeslot_starttime == $x.":00:00") {echo " selected='selected' ";} echo ">Noon</option>";  
				echo "<option value=".$x.":15:00"; if($row->timeslot_starttime == $x.":15:00") {echo " selected='selected' ";} echo ">".$x.":15 </option>";  
				echo "<option value=".$x.":30:00"; if($row->timeslot_starttime == $x.":30:00") {echo " selected='selected' ";} echo ">".$x.":30 </option>";  
				echo "<option value=".$x.":45:00"; if($row->timeslot_starttime == $x.":45:00") {echo " selected='selected' ";} echo ">".$x.":45 </option>";  
			} else if($x==24){
				echo "<option value=".$x.":00:00"; if($row->timeslot_starttime == $x.":00:00") {echo " selected='selected' ";} echo ">Midnight</option>";  
			} else {
				if($x<10){
					$x = "0".$x;
				}
				echo "<option value=".$x.":00:00"; if($row->timeslot_starttime == $x.":00:00") {echo " selected='selected' ";} echo ">".$x.":00 </option>";  
				echo "<option value=".$x.":15:00"; if($row->timeslot_starttime == $x.":25:00") {echo " selected='selected' ";} echo ">".$x.":15 </option>";  
				echo "<option value=".$x.":30:00"; if($row->timeslot_starttime == $x.":30:00") {echo " selected='selected' ";} echo ">".$x.":30 </option>";  
				echo "<option value=".$x.":45:00"; if($row->timeslot_starttime == $x.":45:00") {echo " selected='selected' ";} echo ">".$x.":45 </option>";  
			}
*/
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->timeslot_starttime,0,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select> : 
		<select name="timeslot_starttime_minute" id="timeslot_starttime_minute" onchange="setstarttime();" class="sv_ts_request_dropdown" <?php if($row->hoursLimit == '24Hour'){ echo ' disabled ' ;} ?>>
		<?php
		for($x=0; $x<59; $x+=5){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->timeslot_starttime,3,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>        
         <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_HINT');?>
        <input type="hidden" name="timeslot_starttime" id="timeslot_starttime" value="<?php echo $row->timeslot_starttime ?>" />      </td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_END');?></td>
      <td colspan="3"><select name="timeslot_endtime_hour" id="timeslot_endtime_hour" onchange="setendtime();" class="sv_ts_request_dropdown" <?php if($row->hoursLimit == '24Hour'){ echo ' disabled ' ;} ?>>
		<?php
		for($x=0; $x<24; $x+=1){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->timeslot_endtime,0,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>  : 
		<select name="timeslot_endtime_minute" id="timeslot_endtime_minute" onchange="setendtime();" class="sv_ts_request_dropdown" <?php if($row->hoursLimit == '24Hour'){ echo ' disabled ' ;} ?>>
		<?php
		for($x=0; $x<59; $x+=5){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->timeslot_endtime,3,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>        
         <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_HINT');?>
        <input type="hidden" name="timeslot_endtime" id="timeslot_endtime" value="<?php echo $row->timeslot_endtime ?>" />      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_DESC');?></td>
      <td valign="top"><input type="text" size="30" maxsize="50" name="timeslot_description" value="<?php echo $row->timeslot_description; ?>" />&nbsp;</td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_DESC_HELP');?></td>
    </tr>
    
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TS_PUBSTART_DATE');?></td>
      <td><input type="text" size="12" maxsize="10" readonly="readonly" name="start_publishing" id="start_publishing" value="<?php echo $row->start_publishing; ?>" />
		        <a href="#" id="anchor3785" onclick="cal.select(document.forms['adminForm'].start_publishing,'anchor3785','yyyy-MM-dd'); return false;"
					 name="anchor3785"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
	  </td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TS_PUBSTART_DATE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TS_PUBEND_DATE');?></td>
      <td><input type="text" size="12" maxsize="10" readonly="readonly" name="end_publishing" id="end_publishing" value="<?php echo $row->end_publishing; ?>" />
		        <a href="#" id="anchor3786" onclick="cal.select(document.forms['adminForm'].end_publishing,'anchor3786','yyyy-MM-dd'); return false;"
					 name="anchor3786"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
	  </td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_TS_PUBEND_DATE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_PUBLISHED');?></td>
        <td>
            <select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3" ><br /><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_NOTES');?></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }

function copyTimeSlot($option) {

	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources WHERE timeslots != 'Global' ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

?>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="4" cellspacing="4">
    <tr>
      <td colspan="2">
      <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_COPY');?></td>
    </tr>
    <tr>
      <td width="128" ><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_COPY_DEST_RESOURCE');?></td>
      <td width="252" ><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_COPY_DEST_DAYS');?></td>
    </tr>
    <tr>
      <td ><select name="dest_resource_id" style="background-color:#FFFFCC">
              <option value="0" ><?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_DETAIL_GLOBAL');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
              <option value="<?php echo $res_row->id; ?>"  <?php if($row->resource_id == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
              <?php $k = 1 - $k; 
				} ?>
      </select>&nbsp;</td>
      <td ><table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr align="center">
            <td><?php echo JText::_('RS1_SUN');?></td>
            <td><?php echo JText::_('RS1_MON');?></td>
            <td><?php echo JText::_('RS1_TUE');?></td>
            <td><?php echo JText::_('RS1_WED');?></td>
            <td><?php echo JText::_('RS1_THU');?></td>
            <td><?php echo JText::_('RS1_FRI');?></td>
            <td><?php echo JText::_('RS1_SAT');?></td>
            <td>&nbsp;</td>
          </tr>
          <tr align="center">
            <td><input type="checkbox" name="chkSunday" id="chkSunday" /></td>
            <td><input type="checkbox" name="chkMonday" id="chkMonday" /></td>
            <td><input type="checkbox" name="chkTuesday" id="chkTuesday" /></td>
            <td><input type="checkbox" name="chkWednesday" id="chkWednesday" /></td>
            <td><input type="checkbox" name="chkThursday" id="chkThursday" /></td>
            <td><input type="checkbox" name="chkFriday" id="chkFriday" /></td>
            <td><input type="checkbox" name="chkSaturday" id="chkSaturday" /></td>
            <td></td>
          </tr>
        </table>
        <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_COPY_NOTE1');?></td>
    </tr>
  </table>
  <?php echo JText::_('RS1_ADMIN_SCRN_TIMESLOT_COPY_NOTE2');?>
    <input type="hidden" name="option" value="<?php echo $option; ?>" />
    <input type="hidden" name="task" value="" />
    <br />
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>    </p>
</form>

<?php }

function copyBookoffs($option) {

	// Get resources for list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources  ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

?>
<script language="javascript">
	
	function submitbutton(pressbutton) {
		var ok = "yes";
		if (pressbutton == 'docopy_bookoff'){
			var selected = getSelected(document.getElementById("dest_resource_id[]"));
			if(selected.length == 0){
				alert("Please select one or more resources.");
				ok = "no";
			}	
			if(ok == "yes"){				
				submitform(pressbutton);
			}
		} else {
			submitform(pressbutton);
		}		
	}

   function getSelected(opt) {
      var selected = new Array();
      var index = 0;
      for (var intLoop=0; intLoop < opt.length; intLoop++) {
         if (opt[intLoop].selected) {
            index = selected.length;
            selected[index] = new Object;
            selected[index].value = opt[intLoop].value;
            selected[index].index = intLoop;
         }
      }
      return selected;
   }

</script>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="4" cellspacing="4">
    <tr>
      <td>
      <?php echo JText::_('RS1_ADMIN_SCRN_BOOKOFF_COPY');?></td>
    </tr>
    <tr>
      <td width="322" ><?php echo JText::_('RS1_ADMIN_SCRN_BOOKOFF_COPY_DEST');?></td>
    </tr>
    <tr>
      <td ><p>
        <select name="dest_resource_id[]" id="dest_resource_id[]" style="background-color:#FFFFCC" size="10" multiple="multiple">
          <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
          <option value="<?php echo $res_row->id; ?>"  <?php if($row->resource_id == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
          <?php $k = 1 - $k; 
				} ?>
        </select>
      &nbsp;</p>
      <?php echo JText::_('RS1_ADMIN_SCRN_BOOKOFF_COPY_SELECT_DEST');?></td>
    </tr>
  </table>
  <p>&nbsp;</p>
  <p>
    <input type="hidden" name="option" value="<?php echo $option; ?>" />
    <input type="hidden" name="task" value="" />
    <br />
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>    </p>
</form>

<?php }


function copyServices($option) {

	// Get resources for list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources  ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

?>
<script language="javascript">
	
	function submitbutton(pressbutton) {
		var ok = "yes";
		if (pressbutton == 'docopy_service'){
			var selected = getSelected(document.getElementById("dest_resource_id[]"));
			if(selected.length == 0){
				alert("Please select one or more resources.");
				ok = "no";
			}	
			if(ok == "yes"){				
				submitform(pressbutton);
			}
		} else {
			submitform(pressbutton);
		}		
	}

   function getSelected(opt) {
      var selected = new Array();
      var index = 0;
      for (var intLoop=0; intLoop < opt.length; intLoop++) {
         if (opt[intLoop].selected) {
            index = selected.length;
            selected[index] = new Object;
            selected[index].value = opt[intLoop].value;
            selected[index].index = intLoop;
         }
      }
      return selected;
   }

</script>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="4" cellspacing="4">
    <tr>
      <td>
      <?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_COPY');?></td>
    </tr>
    <tr>
      <td width="322" ><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_COPY_DEST');?></td>
    </tr>
    <tr>
      <td ><p>
        <select name="dest_resource_id[]" id="dest_resource_id[]" style="background-color:#FFFFCC" size="10" multiple="multiple">
          <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
          <option value="<?php echo $res_row->id; ?>"  <?php if($row->resource_id == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->description); ?></option>
          <?php $k = 1 - $k; 
				} ?>
        </select>
      &nbsp;</p>
      <?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_COPY_SELECT_DEST');?></td>
    </tr>
  </table>
  <p>&nbsp;</p>
  <p>
    <input type="hidden" name="option" value="<?php echo $option; ?>" />
    <input type="hidden" name="task" value="" />
    <br />
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>    </p>
</form>

<?php }

function copyBooking($option, $id) {

	$database = &JFactory::getDBO();
	// get request deatils
		$sql = "SELECT #__sv_apptpro_requests.*, #__sv_apptpro_resources.name as resname, ".
		"DATE_FORMAT(#__sv_apptpro_requests.startdate, '%W, %M %e') as display_startdate, ";
		if($apptpro_config->timeFormat == "24"){
			$sql .=	"DATE_FORMAT(#__sv_apptpro_requests.starttime, '%H:%i') as display_starttime, ".
			"DATE_FORMAT(#__sv_apptpro_requests.endtime, '%H:%i') as display_endtime ";
		} else {
			$sql .=	"DATE_FORMAT(#__sv_apptpro_requests.starttime, '%l:%i%p') as display_starttime, ".
			"DATE_FORMAT(#__sv_apptpro_requests.endtime, '%l:%i%p') as display_endtime ";
		}
		$sql .= "FROM ".
		"   #__sv_apptpro_requests LEFT JOIN #__sv_apptpro_resources  ".
		"   ON #__sv_apptpro_requests.resource = #__sv_apptpro_resources.id LEFT JOIN  ".
		"   #__sv_apptpro_services ON #__sv_apptpro_requests.service = ".
		"   #__sv_apptpro_services.id ".
		"WHERE #__sv_apptpro_requests.id = ".$id[0];


	$database->setQuery($sql);
	$req_detail = NULL;
	$req_detail = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	
	// get config stuff
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}

?>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript" src="../components/com_rsappt_pro14/date.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.addDisabledDates(null,formatDate(now,"yyyy-MM-dd")); 
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<script language="javascript">
	
	function submitbutton(pressbutton) {
		if (pressbutton == 'docopy_booking'){
			if(document.getElementById("dest_date").value == ""){
				alert("Please select a date.");
				return false;
			} else {	
				submitform(pressbutton);
			}
		} else {
			submitform(pressbutton);
		}		
	}

</script>
<script language="JavaScript" src="./components/com_rsappt_pro14/be_scripts.js"></script>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="4" cellspacing="0">
    <tr class="admin_detail_row0">
      <td colspan="2">
      <?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_INTO');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top" width="150px"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_SELECTED');?></td>
      <td>
      <?php echo JText::_($req_detail->resname)."<br>".$req_detail->name."<br>".$req_detail->display_startdate."<br>".$req_detail->display_starttime." - ".$req_detail->display_endtime;?>
      </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_LABEL');?></td>
      <td><select id="copy_repeat" name="copy_repeat" onchange="doChangeRepeat()">
      <option value=""><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_SELECT');?></option>
      <option value="none"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_NONE');?></option>
      <option value="daily"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_DAILY');?></option>
      <option value="weekdays"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_WEEKDAYS');?></option>
      <option value="weekly"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_WEEKLY');?></option>
      <option value="monthly"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_REPEAT_MONTHLY');?></option>
      </select>
	  </td>
    </tr>
    <tr><td></td><td><div id="repeat_details"></div></td></tr>
    <tr><td></td><td><div id="availablilty_results"></div></td></tr>
  </table>
  <p>&nbsp;</p>
  <?php echo JText::_('RS1_ADMIN_SCRN_BOOKING_COPY_SBD_WARNING');?>
  <p>
    <input type="hidden" name="option" value="<?php echo $option; ?>" />
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="request_id" id="request_id" value="<?php echo JText::_($req_detail->id)?>" />
    <input type="hidden" id="src_date" name="src_date" value="<?php echo JText::_($req_detail->startdate)?>" />
    <br />
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>    </p>
</form>

<?php }


function editbookoffs( $option, &$row ) {

	$cur_res = JRequest::getVar( 'resource_id' );
	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}

?>
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript" src="../components/com_rsappt_pro14/date.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.addDisabledDates(null,formatDate(now,"yyyy-MM-dd")); 
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<script language="javascript">
function submitbutton(pressbutton) {
	var ok = "yes";
   	if (pressbutton == 'save_bookoff'){
		if(document.getElementById("resource_id").selectedIndex == 0){
			alert("Please select a resource.");
			ok = "no";
		}
		if(document.getElementById("off_date").value == ""){
			alert("Please select a date.");
			ok = "no";
		}
		if(document.getElementById("off_date2")!=null){
			if(ok == "yes" && document.getElementById("off_date2").value != ""){				
				// need to create a series or bookoffs			
				// limit to max 14 days
				if(Date.parse(document.getElementById("off_date2").value) > Date.parse(document.getElementById("off_date").value).add(14).days()){
					alert("Maximum number of book-off days that can be created at one time is 15");
					ok="no";
				}
				pressbutton = 'create_bookoff_series'
			}
		}
		if(ok == "yes"){
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}

function setbookoffstarttime(){
	document.getElementById("bookoff_starttime").value = document.getElementById("bookoff_starttime_hour").value + ":" + document.getElementById("bookoff_starttime_minute").value + ":00";
}
function setbookoffendtime(){
	document.getElementById("bookoff_endtime").value = document.getElementById("bookoff_endtime_hour").value + ":" + document.getElementById("bookoff_endtime_minute").value + ":00";
}
</script>
<script type="text/javascript" src="../includes/js/overlib_mini.js"></script>        

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >

<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_BOOKOFF_DETAIL_INTRO');?><br /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="20%"><?php echo JText::_('RS1_ADMIN_SCRN_BOOKOFF_DETAIL_ID');?></td>
      <td><?php echo $row->id ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_RESOURCE');?></td>
      <td colspan="3">
      <?php if($row->resource_id == ""){ ?>
	      <select name="resource_id" id="resource_id">
          <option value="0" ><?php echo JText::_('RS1_ADMIN_SCRN_BO_RESOURCE_SEL');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
        	  <option value="<?php echo $res_row->id; ?>"  <?php if($cur_res == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->name); ?></option>
              <?php $k = 1 - $k; 
				} ?>
    	  </select>
      <?php } else { ?>
      			<input type="hidden" name="resource_id" id="resource_id" value=<?php echo $row->resource_id;?> />
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
					$res_row = $res_rows[$i];
					if($row->resource_id == $res_row->id){
        	  			echo stripslashes($res_row->name);
              		}
					$k = 1 - $k; 
				}     		
      		} 
			?>    
      &nbsp; </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_DATE');?></td>
      <td colspan="3"><input type="text" size="12" maxsize="10" readonly="readonly" name="off_date" id="off_date" value="<?php echo $row->off_date; ?>" />
		        <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].off_date,'anchor1','yyyy-MM-dd'); return false;"
					 name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
           <?php if($row->id == ""){ ?>
            &nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_BO_DATE_TO');?>&nbsp;<input type="text" size="12" maxsize="10" readonly="readonly" name="off_date2" id="off_date2" value="" />
		        <a href="#" id="anchor2" onclick="cal.select(document.forms['adminForm'].off_date2,'anchor2','yyyy-MM-dd'); return false;"
					 name="anchor2"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>
            &nbsp;<img src="../includes/js/ThemeOffice/tooltip.png" border="0" 
            onmouseover="return overlib('<?php echo JText::_('RS1_ADMIN_SCRN_BO_DATE_HELP');?>', CAPTION, '<?php echo JText::_('RS1_ADMIN_SCRN_BO_DATE');?>', BELOW, RIGHT);" 
            onmouseout="return nd();" />
            <?php } ?>       </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_FULLDAY');?> </td>
      <td><select name="full_day">
            <option value="Yes" <?php if($row->full_day == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            <option value="No" <?php if($row->full_day == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            </select>      </td>
      <td rowspan="4"><?php echo JText::_('RS1_ADMIN_SCRN_BO_RANGE_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_RANGE_START');?> </td>
      <td><select name="bookoff_starttime_hour" id="bookoff_starttime_hour" onchange="setbookoffstarttime();" class="sv_ts_request_dropdown" >
		<?php
		for($x=0; $x<24; $x+=1){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->bookoff_starttime,0,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select> : 
		<select name="bookoff_starttime_minute" id="bookoff_starttime_minute" onchange="setbookoffstarttime();" class="sv_ts_request_dropdown" >
		<?php
		for($x=0; $x<59; $x+=5){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->bookoff_starttime,3,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>
		<?php echo JText::_('RS1_ADMIN_SCRN_HHMM');?>
        <input type="hidden" name="bookoff_starttime" id="bookoff_starttime" value="<?php echo $row->bookoff_starttime ?>" />      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_RANGE_END');?> </td>
      <td><select name="bookoff_endtime_hour" id="bookoff_endtime_hour" onchange="setbookoffendtime();" class="sv_ts_request_dropdown" >
		<?php
		for($x=0; $x<24; $x+=1){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->bookoff_endtime,0,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select> : 
		<select name="bookoff_endtime_minute" id="bookoff_endtime_minute" onchange="setbookoffendtime();" class="sv_ts_request_dropdown" >
		<?php
		for($x=0; $x<59; $x+=5){
			if($x<10){
				$x = "0".$x;
			}
			echo "<option value=".$x; if(substr($row->bookoff_endtime,3,2) == $x) {echo " selected='selected' ";} echo ">".$x." </option>";  
		}
		?>
        </select>
		<?php echo JText::_('RS1_ADMIN_SCRN_HHMM');?>
        <input type="hidden" name="bookoff_endtime" id="bookoff_endtime" value="<?php echo $row->bookoff_endtime ?>" />      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td>&nbsp;</td>
      <td>&nbsp;</td>

    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_DESC');?> </td>
      <td><input type="text" size="60" maxsize="80" name="description" value="<?php echo stripslashes($row->description); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_BO_DESC_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_BOOKOFF_DETAIL_PUBLISHED');?></td>
        <td>
            <select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3" ><br /></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }

function editCategory( $option, &$row ) {

	// get parent categories
	$database = &JFactory::getDBO(); 
	if($row->id == ""){
		$sql = 'SELECT * FROM #__sv_apptpro_categories WHERE (parent_category IS NULL OR parent_category =\'\') order by ordering';
	} else {
		$sql = 'SELECT * FROM #__sv_apptpro_categories WHERE id != '.$row->id.' AND (parent_category IS NULL OR parent_category =\'\') order by ordering';
	}
	$database->setQuery($sql);
	$parent_cats = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		logIt($database->getErrorMsg()); 
		return false;
	}
	
?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<script language="javascript">
function submitbutton(pressbutton) {
   	if (pressbutton == 'save_category'){
		if(document.getElementById("name").value == ""){
			alert("Name is required");
		} else {
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}
</script>
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_INTRO');?><br />
        </p>      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="25%"><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_ID');?></td>
      <td><?php echo $row->id ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_NAME');?></td>
      <td colspan="3"><input type="text" size="40" maxsize="50" name="name" id="name" value="<?php echo stripslashes($row->name); ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_DESC');?></td>
      <td><input type="text" size="60" maxsize="80" name="description" value="<?php echo stripslashes($row->description); ?>" /></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_PARENTS');?></td>
        <td>
            <select name="parent_category">
          	<option value=""><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_NOPARENT_PROMPT');?></option>
          <?php 
					$k = 0;
					for($i=0; $i < count( $parent_cats ); $i++) {
					$parent_cat = $parent_cats[$i];
					?>
          	<option value="<?php echo $parent_cat->id; ?>" <?php if($parent_cat->id == $row->parent_category ){echo " selected='selected' ";} ?>><?php echo stripslashes($parent_cat->name); ?></option>
          		<?php $k = 1 - $k; 
					} ?>
          	</select>        </td>
        <td><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_PARENTS_HELP');?>&nbsp;</td>
    </tr>
   	<tr  class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_ORDER');?></td>
      <td><input type="text" size="5" maxsize="2" name="ordering" value="<?php echo $row->ordering; ?>" />
        &nbsp;&nbsp;</td>
      <td>&nbsp;</td>
   	</tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_PUBLISHED');?></td>
        <td>
            <select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3" ><br />
       
        <p>&nbsp;</p></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }


function editService( $option, &$row ) {

	$cur_res = JRequest::getVar( 'resource_id' );
	// Get resources for dropdown list
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__sv_apptpro_resources ORDER BY name" );
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

?>
<script language="javascript">
function submitbutton(pressbutton) {
	var ok = "yes";
   	if (pressbutton == 'save_service'){
		if(document.getElementById("resource_id").selectedIndex == 0){
			alert("Please select a Resource.");
			ok = "no";
		}
		if(document.getElementById("name").value == ""){
			alert("Please enter a Service Name");
			ok = "no";
		}
		if(ok == "yes"){
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}
</script>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >

<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_INTRO');?><br /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_ID');?></td>
      <td><?php echo $row->id ?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RESOURCE');?></td>
      <td colspan="2">
      <?php if($row->resource_id == ""){ ?>
	      <select name="resource_id" id="resource_id">
          <option value="0" ><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_SEL_RESOURCE');?></option>
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
				$res_row = $res_rows[$i];
				?>
        	  <option value="<?php echo $res_row->id; ?>"  <?php if($cur_res == $res_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($res_row->name); ?></option>
              <?php $k = 1 - $k; 
				} ?>
    	  </select>
      <?php } else { ?>
      			<input type="hidden" name="resource_id" id="resource_id" value=<?php echo $row->resource_id;?> />
              <?php
				$k = 0;
				for($i=0; $i < count( $res_rows ); $i++) {
					$res_row = $res_rows[$i];
					if($row->resource_id == $res_row->id){
        	  			echo stripslashes($res_row->name);
              		}
					$k = 1 - $k; 
				}     		
      		} 
			?>    
      &nbsp; </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_NAME');?></td>
      <td colspan="2"><input type="text" size="60" maxsize="250" name="name" id="name" value="<?php echo $row->name; ?>" /></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_DESC');?></td>
      <td colspan="2"><input type="text" size="60" maxsize="250" name="description" value="<?php echo stripslashes($row->description); ?>" /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RATE');?></td>
      <td ><input type="text" size="8" maxsize="10" name="service_rate" value="<?php echo $row->service_rate; ?>" />
        &nbsp;&nbsp;&nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RATE_UNIT');?><select name="service_rate_unit">
          <option value="Hour" <?php if($row->service_rate_unit == "Hour"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RATE_HOUR');?></option>
          <option value="Flat" <?php if($row->service_rate_unit == "Flat"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RATE_BOOKING');?></option>
        </select>        </td>
      <td width="60%"><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RATE_HELP');?></td>
    </tr>
	<tr class="admin_detail_row1">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DURATION');?></td>
      <td ><input type="text" size="8" maxsize="10" name="service_duration" value="<?php echo $row->service_duration; ?>" />
        &nbsp;&nbsp;&nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_RATE_UNIT');?> <select name="service_duration_unit">
          <option value="Minute" <?php if($row->service_duration_unit == "Minute"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DURATION_MINUTE');?></option>
          <option value="Hour" <?php if($row->service_duration_unit == "Hour"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DURATION_HOUR');?></option>
      </select>        </td>
      <td width="55%"><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DURATION_HELP');?></td>
    </tr>
    <tr  class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_ORDER');?></td>
      <td colspan="2"><input type="text" size="5" maxsize="2" name="ordering" value="<?php echo $row->ordering; ?>" />
        &nbsp;&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_SERVICE_DETAIL_PUBLISHED');?></td>
        <td colspan="2">
            <select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="2" >
      <p>&nbsp;</p></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }

function editudfs( $option, &$row ) {

	// get cb profile columns
	$database = &JFactory::getDBO();
	$database->setQuery("SELECT * FROM #__comprofiler_fields WHERE type='text' or type='predefined' ORDER BY name" );
	$cb_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		if($database -> getErrorNum() != 1146){
			// ignore 1146 - table not found if component not installed
			echo $database -> stderr();
			return false;
		}
	}

	// get js profile columns
	$database->setQuery("SELECT * FROM #__community_fields WHERE type!='group' ORDER BY name" );
	$js_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		if($database -> getErrorNum() != 1146){
			// ignore 1146 - table not found if component not installed
			echo $database -> stderr();
			return false;
		}
	}

	// get resources 
	$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE published = 1";
	$database->setQuery($sql);
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get resource assignments 
	if (strlen($row->scope) > 0 ){
		$res_assignments = str_replace("||", ",", $row->scope);
		$res_assignments = str_replace("|", "", $res_assignments);
		//echo $admins;
		//exit;
		$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE ".
  			"id IN (".$res_assignments.")";
		$database->setQuery($sql);
		$res_assignment_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}	

?>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<script language="javascript">
function submitbutton(pressbutton) {
	var ok = "yes";
   	if (pressbutton == 'save_bookoff'){
		if(document.getElementById("resource_id").selectedIndex == 0){
			alert("Please select a resource.");
			ok = "no";
		}
		if(document.getElementById("off_date").value == ""){
			alert("Please select a date.");
			ok = "no";
		}
		if(ok == "yes"){
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}


	function doAddResource(){
		var resid = document.getElementById("resources").value;
		var selected_resources = document.getElementById("selected_resources_id").value;
		var x = document.getElementById("selected_resources");
		for (i=0;i<x.length;i++){
			if(x[i].value == resid) {
				alert("Already selected");
				return false;
			}			
		}
	
		var opt = document.createElement("option");
        // Add an Option object to Drop Down/List Box
        document.getElementById("selected_resources").options.add(opt); 
        opt.text = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].text;
        opt.value = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].value;
		selected_resources = selected_resources + "|" + resid + "|";
		document.getElementById("selected_resources_id").value = selected_resources;
	}

	function doRemoveResource(){
		if(document.getElementById("selected_resources").selectedIndex == -1){
			alert("No Resource selected for Removal");
			return false;
		}
		var res_to_go = document.getElementById("selected_resources").options[document.getElementById("selected_resources").selectedIndex].value;
		document.getElementById("selected_resources").remove(document.getElementById("selected_resources").selectedIndex);
		
		var selected_resource = document.getElementById("selected_resources_id").value;

		selected_resource = selected_resource.replace("|" + res_to_go + "|", "");
		document.getElementById("selected_resources_id").value = selected_resource;
	}

</script>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >

<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_INTRO');?><br /></td>
    </tr>
    <tr class="admin_detail_row0">
      <td width="15%"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_ID');?></td>
      <td colspan="2"><?php echo $row->id ?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_SCREEN_LABEL');?></td>
      <td colspan="2"><input type="text" size="30" maxsize="40" name="udf_label" id="udf_label" value="<?php echo stripslashes($row->udf_label); ?>" />&nbsp; </td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TYPE');?></td>
      <td colspan="2"> <select name="udf_type">
              <option value="Textbox" <?php if($row->udf_type == "Textbox"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TEXTBOX');?></option>
              <option value="Checkbox" <?php if($row->udf_type == "Checkbox"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_CHECKBOX');?></option>
              <option value="Radio" <?php if($row->udf_type == "Radio"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_RADIO');?></option>
              <option value="Textarea" <?php if($row->udf_type == "Textarea"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TEXTAREA');?></option>
              <option value="List" <?php if($row->udf_type == "List"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_LIST');?></option>
            </select></td>
    </tr>
	<tr  class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_SIZE');?></td>
      <td colspan="2"><input type="text" size="5" maxsize="2" name="udf_size" value="<?php echo $row->udf_size; ?>" />&nbsp;&nbsp;<span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TYPE_HINT');?></span>
        &nbsp;&nbsp;</td>
    </tr>
	<tr  class="admin_detail_row1">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_ROWS');?></td>
	  <td colspan="2"><input type="text" size="5" maxsize="2" name="udf_rows" value="<?php echo $row->udf_rows; ?>" />&nbsp;&nbsp;<span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TYPE_HINT');?></span>
        &nbsp;&nbsp;</td>
    </tr>
	<tr  class="admin_detail_row1">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_COLS');?></td>
	  <td colspan="2"><input type="text" size="5" maxsize="2" name="udf_cols" value="<?php echo $row->udf_cols; ?>" />&nbsp;&nbsp;<span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TYPE_HINT');?></span>
        &nbsp;&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_RB_OR_LIST');?></td>
      <td colspan="2"><input type="text" size="60" maxsize="255" name="udf_radio_options" id="udf_radio_options" value="<?php echo stripslashes($row->udf_radio_options); ?>" />&nbsp;       
      <span style="font-size:10px;"><br /><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_RB_OR_LIST_HELP');?></span></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_REQ_FIELD');?></td>
      <td colspan="2"> <select name="udf_required">
        	<option value="Yes" <?php if($row->udf_required == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
        	<option value="No" <?php if($row->udf_required == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
	    </select> 
        &nbsp;&nbsp;<span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_REQ_FIELD_HELP');?></span>	</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_HELP_TEXT');?></td>
      <td colspan="2"><input type="text" size="60" maxsize="255" name="udf_help" id="udf_help" value="<?php echo stripslashes($row->udf_help); ?>" />&nbsp; </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_TOOLTIP');?></td>
      <td colspan="2"><input type="text" size="60" maxsize="255" name="udf_tooltip" id="udf_tooltip" value="<?php echo stripslashes($row->udf_tooltip); ?>" />&nbsp; </td>
    </tr>
	<tr class="admin_detail_row0">
	  <td colspan="3" ><?php echo JText::_('RS1_ADMIN_SCRN_UDF_RESOURCES_INTRO');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_UDF_RESOURCES');?></td>
      <td >
      <table width="95%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="33%"><select name="resources" id="resources">
            <?php
			$k = 0;
			for($i=0; $i < count( $res_rows ); $i++) {
			$res_row = $res_rows[$i];
			?>
                <option value="<?php echo $res_row->id; ?>"><?php echo stripslashes($res_row->name); ?></option>
                <?php $k = 1 - $k; 
			} ?>
              </select></td>
            <td width="34%" valign="top" align="center"><input type="button" name="btnAddResource" id="btnAddResource" size="10" value="<?php echo JText::_('RS1_ADMIN_SCRN_UDF_RESOURCES_ADD');?>" onclick="doAddResource()" />
              <br />
              &nbsp;<br />
              <input type="button" name="btnRemoveResource" id="btnRemoveResource" size="10"  onclick="doRemoveResource()" value="<?php echo JText::_('RS1_ADMIN_SCRN_UDF_RESOURCES_REMOVE');?>" /></td>
            <td width="33%">
            <select name="selected_resources" id="selected_resources" size="4" >
             <?php
			$k = 0;
			for($i=0; $i < count( $res_assignment_rows ); $i++) {
			$res_assignment_row = $res_assignment_rows[$i];
			?>
                <option value="<?php echo $res_assignment_row->id; ?>"><?php echo $res_assignment_row->name; ?></option>
                <?php 
				$scope = $scope."|".$res_assignment_row->id."|";
				$k = 1 - $k; 
			} ?>
              </select><br /><?php echo JText::_('RS1_ADMIN_SCRN_EMPTY_ALL');?> </td>
          </tr>
        </table></td>
    <td valign="top" width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_UDF_RESOURCES_HELP');?></td>
    </tr>
	<tr class="admin_detail_row1">
	  <td colspan="3"  style="border-top: solid 1px" ><?php echo JText::_('RS1_ADMIN_SCRN_UDF_CB_HELP');?></td>
    </tr>
	<tr  class="admin_detail_row1">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_CB_FIELD');?></td>
	  <td colspan="2"><select name="cb_mapping" id="cb_mapping" >
      	<option value=""><?php echo JText::_('RS1_ADMIN_SELECT_CB_VALUE');?></option>
          <?php
		$k = 0;
		for($i=0; $i < count( $cb_rows ); $i++) {
		$cb_row = $cb_rows[$i];
		?>
          <option value="<?php echo $cb_row->name; ?>" <?php if($row->cb_mapping == $cb_row->name){echo " selected='selected' ";} ?>><?php echo stripslashes($cb_row->name); ?></option>
          <?php $k = 1 - $k; 
		} ?>
        </select> &nbsp;</td>
    </tr>
	<tr  class="admin_detail_row1">
	  <td style="border-bottom: solid 1px" valign="top"><?php echo JText::_('RS1_ADMIN_READ_ONLY');?></td>
	  <td colspan="2" style="border-bottom: solid 1px"><select name="read_only">
        	<option value="Yes" <?php if($row->read_only == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
        	<option value="No" <?php if($row->read_only == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
	    </select> &nbsp;&nbsp;<span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_READ_ONLY_HELP2');?></span>	
      </td>
    </tr>

	<tr class="admin_detail_row0">
	  <td colspan="3" ><?php echo JText::_('RS1_ADMIN_SCRN_UDF_JS_HELP');?></td>
    </tr>
	<tr  class="admin_detail_row0">
	  <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_JS_FIELD');?></td>
	  <td colspan="2"><select name="js_mapping" id="js_mapping" >
      	<option value=""><?php echo JText::_('RS1_ADMIN_SELECT_JS_VALUE');?></option>
          <?php
		$k = 0;
		for($i=0; $i < count( $js_rows ); $i++) {
		$js_row = $js_rows[$i];
		?>
          <option value="<?php echo $js_row->fieldcode; ?>" <?php if($row->js_mapping == $js_row->fieldcode){echo " selected='selected' ";} ?>><?php echo stripslashes($js_row->name); ?></option>
          <?php $k = 1 - $k; 
		} ?>
        </select> &nbsp;</td>
    </tr>
	<tr  class="admin_detail_row0">
	  <td style="border-bottom: solid 1px" valign="top"><?php echo JText::_('RS1_ADMIN_READ_ONLY');?></td>
	  <td colspan="2" style="border-bottom: solid 1px"><select name="js_read_only">
        	<option value="Yes" <?php if($row->js_read_only == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
        	<option value="No" <?php if($row->js_read_only == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
	    </select> &nbsp;&nbsp;<span style="font-size:10px"><?php echo JText::_('RS1_ADMIN_READ_ONLY_HELP3');?></span>	
      </td>
    </tr>
	
    <tr  class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_ORDER');?></td>
      <td colspan="2"><input type="text" size="5" maxsize="2" name="ordering" value="<?php echo $row->ordering; ?>" />
        &nbsp;&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_PUBLISHED');?></td>
        <td colspan="2">
            <select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
    </tr>
    <tr class="admin_detail_row1">
      <td colspan="3" ><br />
        <?php echo JText::_('RS1_ADMIN_SCRN_UDF_DETAIL_NOTE');?></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="scope" id="selected_resources_id" value="<?php echo $scope; ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }


function sendReminders( $option, &$status ) {

?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >

<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<p><?php echo JText::_('RS1_ADMIN_SCRN_REM');?></p>
<p>  <?php echo $status ?>  </p>
<p><?php echo JText::_('RS1_ADMIN_SCRN_REM_NOTE');?>

<?php if($option == "com_rsappt_pro14"){ ?>
  <p>
	<a href="index.php?option=<?php echo $option ?>&view=Booking Admin"><?php echo JText::_('RS1_ADMIN_SCRN_REM_CONTINUE');?></a>
  </p>
<?php } ?>
<br />
<hr />
  <?php if($apptpro_config->hide_logo == 'No'){ ?>
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
  <?php } ?>
</p>
</form>

<?php }

function sendReminders2( $option, &$status ) {

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	
	$listpage = JRequest::getVar('listpage', '');
	setSessionStuff("front_desk");
		
?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >

<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<p><?php echo JText::_('RS1_ADMIN_SCRN_REM');?> </p>
<hr />
<p>  <?php echo $status ?>  </p>
<p><?php echo JText::_('RS1_ADMIN_SCRN_REM_NOTE');?>

<?php if($option == "com_rsappt_pro14"){?>
<?php 	if($listpage == "front_desk"){?>
  <p>
			<a href="index.php?option=<?php echo $option ?>&view=Front Desk"><?php echo JText::_('RS1_ADMIN_SCRN_REM_CONTINUE');?></a>
  </p>
<?php 	} else if($listpage == "front_desk_mobile"){?>
			<p>
			<a href="index.php?option=<?php echo $option ?>&view=Front Desk Mobile"><?php echo JText::_('RS1_ADMIN_SCRN_REM_CONTINUE');?></a>
			</p>
<?php 	} else {?>
			<p>
			<a href="index.php?option=<?php echo $option ?>&view=Advanced Admin"><?php echo JText::_('RS1_ADMIN_SCRN_REM_CONTINUE');?></a>
		    </p>
<?php 	} ?>
<?php } ?>

<br />
<hr />
  <?php if($apptpro_config->hide_logo == 'No'){ ?>
    <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
  <?php } ?>
</p>
</form>

<?php }


function listCSS( $option, &$row ) {
?>
<style type="text/css">
<!--
.icon-48-editfiles { background-image: url(./components/com_rsappt_pro14/images/log.png); }
-->
}
</style>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
  <script language="javascript">
	function resetCSS(){
		document.getElementById('cssfile').value = document.getElementById('dist_css').value;
	}
	function resetLang(){
		document.getElementById('langfile').value = document.getElementById('dist_ini').value;
	}
  </script>
<?php  
     // instantiate new tab system
	jimport( 'joomla.html.pane' );
	
	$pane =& JPane::getInstance('Tabs');
	echo $pane->startPane('myPane');
	{
	// start tab pane
	//$tabs->startPane("TabPaneOne");
	echo $pane->startPanel(JText::_('RS1_ADMIN_SCRN_EDIT_FILES_CSS_TAB'), 'panel1');
?>

  <table width="80%" border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EDIT_FILES_CSS');?></td>
    </tr>
    <tr>
      <td><textarea rows="20" cols="80" name="cssfile" id="cssfile"><?php $fn = JPATH_SITE."/components/com_rsappt_pro14/sv_apptpro.css";
            print htmlspecialchars(implode("",file($fn)));?> 
		</textarea></td>
    </tr>
    <tr>
      <td><p>
        <input name="Reset" type="button" value="<?php echo JText::_('RS1_ADMIN_SCRN_EDIT_FILES_CSS_RESET');?>" onclick="resetCSS()" />
      </p>
      <p><?php echo JText::_('RS1_ADMIN_SCRN_EDIT_FILES_CSS_NOTE');?></p></td>
    </tr>
  </table>
   <?php    
	echo $pane->endPanel();
	echo $pane->startPanel(JText::_('RS1_ADMIN_SCRN_EDIT_FILES_LANG_TAB'), 'panel1');
	
	?>
  <table width="80%" border="0" cellpadding="2" cellspacing="0">
<!--    <tr>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EDIT_FILES_LANG_REMEMBER_TO_SAVE');?></td>
    </tr>
    <tr>
      <td><select id="langfiles" name="langfiles">
--><?php
	$lang =& JFactory::getLanguage();
	$directory = JPATH_SITE.DS."language".DS;
	$file = scandir($directory);
	//print_r($file);
//	foreach( $file as $this_file ) {
//		if( $this_file != "." && $this_file != ".." ) {
//			if( is_dir("$directory/$this_file") ) {
//				$file2 = scandir("$directory/$this_file");
//				//print_r($file2);
//				foreach( $file2 as $this_file2 ) {
//					if( $this_file2 != "." && $this_file2 != ".." ) {
//						if( !is_dir("$directory/$this_file/$this_file2") ) {
//							if(strpos($this_file2, "com_rsappt_pro" ) >0 ){
//								echo "<option value='".$directory.$this_file.DS.$this_file2."' ";
//								if($lang->getTag() == $this_file){
//									echo " selected ";
//								}
//								echo ">".DS."language".DS.$this_file.DS.$this_file2."</option>\n";
////								$langfiles[$i] = "$this_file".DS."$this_file2";
////								$i++;
//							}
//						}
//					}
//				}
//			}
//		}
//	}
	//print_r($langfiles);
?>      
      </select>
<!--      </td>
    </tr>
--><?php   
	$lang_file_count = 0;
	foreach( $file as $this_file ) {
		if( $this_file != "." && $this_file != ".." ) {
			if( is_dir("$directory/$this_file") ) {
				$file2 = scandir("$directory".DS."$this_file");
				//print_r($file2);
				foreach( $file2 as $this_file2 ) {
					if( $this_file2 != "." && $this_file2 != ".." ) {
						if( !is_dir("$directory/$this_file/$this_file2") ) {
							if(strpos($this_file2, "com_rsappt_pro" ) >0 ){
								$filename = "langfile".$lang_file_count ?>
                            	<tr><td><b><?php echo "$directory".$this_file.DS.$this_file2 ?></b></td></tr>
								<tr>
								  <td><textarea rows="20" cols="80" wrap="off" name="<?php echo $filename?>" id="<?php echo $filename?>"><?php $fn = "$directory/$this_file/$this_file2";
										print implode("",file($fn));?> 
									</textarea><br/><br/>&nbsp;
                                    <input type="hidden" name="save_<?php echo $filename?>" value="<?php echo "$directory".$this_file.DS.$this_file2 ?>"/>
                                  </td>
								</tr>
                             <?php   
							 $lang_file_count++;
							}
						}
					}
				}
			}
		}
	}
 ?>   
<!--    <tr>
      <td><textarea rows="20" cols="80" wrap="off" name="langfile" id="langfile"><?php $fn = JPATH_SITE."/language/en-GB/en-GB.com_rsappt_pro14.ini";
            print htmlspecialchars(implode("",file($fn)));?> 
		</textarea></td>
    </tr>-->
  </table>
  <input type="hidden" name="lang_file_count" id="lang_file_count" value="<?php echo $lang_file_count;?>" />
  <?php    
	echo $pane->endPanel();

	}
	// end tab pane
	echo $pane->endPane();

?>

  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="dist_css" id="dist_css" value="<?php $fn = "../components/com_rsappt_pro14/default.css"; print htmlspecialchars(implode("",file($fn)));?>"/>
  <input type="hidden" name="dist_ini" id="dist_ini" value="<?php $fn = "../components/com_rsappt_pro14/default.ini"; print htmlspecialchars(implode("",file($fn)));?>"/>
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php }

function backupRB( $option ) {
?>
<style type="text/css">
<!--
.icon-48-backup { background-image: url(./components/com_rsappt_pro14/images/backup.png); }
-->
}
</style>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<script language="javascript">
	function doBackup(){
		document.getElementById('task').value="backup";
		document.adminForm.submit();
	}
	function doRestore(){
		document.getElementById('task').value="restore";
		document.adminForm.submit();
	}
	function doRestoreFrom152(){
		document.getElementById('task').value="restore_from_152";
		document.adminForm.submit();
	}
	function doRestoreFromRBPro(){
		document.getElementById('task').value="restore_from_RBPro";
		document.adminForm.submit();
	}
	
</script>
  <table border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td colspan="3"><p><?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INTRO');?><br/><?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INTRO_LANG');?></p>
      <p>&nbsp;</p></td>
    </tr>
  <tr>
    <td align="center" width="30%"><input type="button" name="btnBackup" id="btnBackup" value="<?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_NOW');?>" onclick="doBackup();"/></td>
    <td align="center" width="30%"><input type="button" name="btnRestore" id="btnRestore" value="<?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_RESTORE_NOW');?>" onclick="doRestore();"/></td>
  </tr>
  <tr>
    <td align="center"><p>
      <label><input type="checkbox" name="chkBackupErrorLog" id="chkBackupErrorLog" />
      <?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INCL_ERROR');?></label>
      <br />
      <label><input type="checkbox" name="chkBackupReminderLog" id="chkBackupReminderLog" />
      <?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INCL_REM');?></label>
      <br />
      <label><input type="checkbox" name="chkBackupLangFile" id="chkBackupLangFile" />
      <?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INCL_LANG');?></label>
    </p></td>
    <td align="center"><p>
      <label><input type="checkbox" name="chkRestoreErrorLog" id="chkRestoreErrorLog" /><?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INCL_ERROR_REST');?></label><br />
      <label><input type="checkbox" name="chkRestoreReminderLog" id="chkRestoreReminderLog" /><?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INCL_REM_REST');?></label><br />
      <label><input type="checkbox" name="chkRestoreLangFile" id="chkRestoreLangFile" /><?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_INCL_LANG_REST');?></label>
    </p></td>
  </tr>
  <tr>
    <td colspan="2">
      <hr /><?php echo JText::_('RS1_ADMIN_SCRN_BACKUP_NOTE');?></td>
    
    <td>&nbsp;</td>
  </tr>
</table>
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" id="task" value="" />
  <input type="hidden" name="act" value="backup" />

  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php 
}


function about( $option ) {
?>
<style type="text/css">
<!--
.icon-48-about { background-image: url(./components/com_rsappt_pro14/images/about.png); }
-->
}
</style>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<table border="0">
  <tr>
    <td colspan="2"><h3><?php echo JText::_('RS1_ADMIN_SCRN_ABOUT');?></h3></td>
  </tr>
  <tr>
    <td width="10%">&nbsp;</td>
    <td><p>Appointment Booking Pro is the commercial version of the popular Joomla component Resource Booking system.</p><p>Written and supported by:<br />Soft Ventures, Inc.<br /><a href="http://www.softventures.com">www.SoftVentures.com</a></p>
      <p>&nbsp;</p></td>
  </tr>
  <tr>
    <td colspan="2"><h3><?php echo JText::_('RS1_ADMIN_SCRN_LICENSE');?></h3></td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td><p>GNU/GPL, see http://www.gnu.org/licenses/gpl-2.0.html<p>&nbsp;</p>      </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
</table>

  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" id="task" value="" />
  <input type="hidden" name="act" value="about" />

  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php 
}

function editCoupon( $option, &$row ) {

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}
	$div_cal = "";
	if($apptpro_config->use_div_calendar == "Yes"){
		$div_cal = "'testdiv1'";
	}
	if($row->expiry_date == null){
		$row->expiry_date = date('Y-m-d',strtotime("+1 month"));
	}

	// get resources 
	$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE published = 1";
	$database->setQuery($sql);
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get resource assignments 
	if (strlen($row->scope) > 0 ){
		$res_assignments = str_replace("||", ",", $row->scope);
		$res_assignments = str_replace("|", "", $res_assignments);
		//echo $admins;
		//exit;
		$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE ".
  			"id IN (".$res_assignments.")";
		$database->setQuery($sql);
		$res_assignment_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}	

?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >
<div id="testdiv1" style="VISIBILITY: hidden; POSITION: absolute; BACKGROUND-COLOR: white; layer-background-color: white"> </div>
<link href="../components/com_rsappt_pro14/calStyles.css" rel="stylesheet">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<script language="JavaScript" src="../components/com_rsappt_pro14/CalendarPopup.js"></script>
<script language="JavaScript">
	var now = new Date();
	var cal = new CalendarPopup( <?php echo $div_cal ?>);
	cal.setCssPrefix("TEST");
	cal.setWeekStartDay(<?php echo $apptpro_config->popup_week_start_day ?>);
</script>
<script language="javascript">
function submitbutton(pressbutton) {
   	if (pressbutton == 'save_coupon'){
		if(document.getElementById("description").value == ""){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DESC_REQ');?>");
		} else if(document.getElementById("coupon_code").value == ""){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_COUPON_CODE_REQ');?>");
		} else if(document.getElementById("discount").value == ""){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_COUPON_VALUE_REQ');?>");
		} else if(document.getElementById("expiry_date").value == ""){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_COUPON_EXPIRY_REQ');?>");
		} else {
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}

	function doAddResource(){
		var resid = document.getElementById("resources").value;
		var selected_resources = document.getElementById("selected_resources_id").value;
		var x = document.getElementById("selected_resources");
		for (i=0;i<x.length;i++){
			if(x[i].value == resid) {
				alert("Already selected");
				return false;
			}			
		}
	
		var opt = document.createElement("option");
        // Add an Option object to Drop Down/List Box
        document.getElementById("selected_resources").options.add(opt); 
        opt.text = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].text;
        opt.value = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].value;
		selected_resources = selected_resources + "|" + resid + "|";
		document.getElementById("selected_resources_id").value = selected_resources;
	}

	function doRemoveResource(){
		if(document.getElementById("selected_resources").selectedIndex == -1){
			alert("No Resource selected for Removal");
			return false;
		}
		var res_to_go = document.getElementById("selected_resources").options[document.getElementById("selected_resources").selectedIndex].value;
		document.getElementById("selected_resources").remove(document.getElementById("selected_resources").selectedIndex);
		
		var selected_resource = document.getElementById("selected_resources_id").value;

		selected_resource = selected_resource.replace("|" + res_to_go + "|", "");
		document.getElementById("selected_resources_id").value = selected_resource;
	}


</script>
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DETAIL_INTRO');?><br />
        </p>      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DETAIL_ID');?>:</td>
      <td><?php echo $row->id ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DETAIL_DESC');?>:</td>
      <td><input type="text" size="40" maxsize="80" name="description" id="description" value="<?php echo stripslashes($row->description); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DETAIL_DESC_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DETAIL_CODE');?>:</td>
      <td><input type="text" size="20" maxsize="80" name="coupon_code" id="coupon_code" value="<?php echo stripslashes($row->coupon_code); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DETAIL_CODE_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_DISCOUNT');?>:</td>
      <td><input type="text" size="20" maxsize="80" name="discount" id="discount" value="<?php echo stripslashes($row->discount); ?>" /></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_UNIT');?>:</td>
        <td><select name="discount_unit" id="discount_unit">
            <option value="percent" <?php if($row->discount_unit == "percent"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_PERCENT');?></option>
            <option value="fixed" <?php if($row->discount_unit == "fixed"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_FIXED');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_MAX_USER_USE');?>:</td>
      <td><input type="text" size="2" maxsize="3" name="max_user_use" id="max_user_use" value="<?php echo $row->max_user_use ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_MAX_USER_USE_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_MAX_TOTAL_USE');?>:</td>
      <td><input type="text" size="2" maxsize="3" name="max_total_use" id="max_total_use" value="<?php echo $row->max_total_use ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_MAX_TOTAL_USE_HELP');?>&nbsp;</td>
    </tr>
	<tr class="admin_detail_row0">
	  <td colspan="3" ><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_RESOURCES_INTRO');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_RESOURCES');?></td>
      <td >
      <table width="95%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="33%"><select name="resources" id="resources">
            <?php
			$k = 0;
			for($i=0; $i < count( $res_rows ); $i++) {
			$res_row = $res_rows[$i];
			?>
                <option value="<?php echo $res_row->id; ?>"><?php echo stripslashes($res_row->name); ?></option>
                <?php $k = 1 - $k; 
			} ?>
              </select></td>
            <td width="34%" valign="top" align="center"><input type="button" name="btnAddResource" id="btnAddResource" size="10" value="<?php echo JText::_('RS1_ADMIN_SCRN_COUPON_RESOURCES_ADD');?>" onclick="doAddResource()" />
              <br />
              &nbsp;<br />
              <input type="button" name="btnRemoveResource" id="btnRemoveResource" size="10"  onclick="doRemoveResource()" value="<?php echo JText::_('RS1_ADMIN_SCRN_COUPON_RESOURCES_REMOVE');?>" /></td>
            <td width="33%">
            <select name="selected_resources" id="selected_resources" size="4" >
             <?php
			$k = 0;
			for($i=0; $i < count( $res_assignment_rows ); $i++) {
			$res_assignment_row = $res_assignment_rows[$i];
			?>
                <option value="<?php echo $res_assignment_row->id; ?>"><?php echo $res_assignment_row->name; ?></option>
                <?php 
				$scope = $scope."|".$res_assignment_row->id."|";
				$k = 1 - $k; 
			} ?>
              </select><br /><?php echo JText::_('RS1_ADMIN_SCRN_EMPTY_ALL');?>            </td>
          </tr>
        </table></td>
    <td valign="top" width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_RESOURCES_HELP');?></td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_EXPIRY_DATE');?></td>
      <td><input type="text" size="12" maxsize="10" readonly="readonly" name="expiry_date" id="expiry_date" value="<?php echo date('Y-m-d', strtotime($row->expiry_date)); ?>" />
		        <a href="#" id="anchor1" onclick="cal.select(document.forms['adminForm'].expiry_date,'anchor1','yyyy-MM-dd'); return false;"
					 name="anchor1"><img height="15" hspace="2" src="../components/com_rsappt_pro14/icon_cal.gif" width="16" border="0"></a>	  </td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_COUPON_EXPIRY_DATE_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_CAT_DETAIL_PUBLISHED');?></td>
        <td><select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3" ><br />
       
        <p>&nbsp;</p></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="scope" id="selected_resources_id" value="<?php echo $scope; ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }

function editSeat( $option, &$row ) {

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get resources 
	$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE published = 1";
	$database->setQuery($sql);
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get resource assignments 
	if (strlen($row->scope) > 0 ){
		$res_assignments = str_replace("||", ",", $row->scope);
		$res_assignments = str_replace("|", "", $res_assignments);
		//echo $admins;
		//exit;
		$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE ".
  			"id IN (".$res_assignments.")";
		$database->setQuery($sql);
		$res_assignment_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}	

?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<script language="javascript">
function submitbutton(pressbutton) {
   	if (pressbutton == 'save_seat'){
		if(document.getElementById("seat_type_label").value == ""){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_LABEL_REQ');?>");
		} else {
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}

	function doAddResource(){
		var resid = document.getElementById("resources").value;
		var selected_resources = document.getElementById("selected_resources_id").value;
		var x = document.getElementById("selected_resources");
		for (i=0;i<x.length;i++){
			if(x[i].value == resid) {
				alert("Already selected");
				return false;
			}			
		}
	
		var opt = document.createElement("option");
        // Add an Option object to Drop Down/List Box
        document.getElementById("selected_resources").options.add(opt); 
        opt.text = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].text;
        opt.value = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].value;
		selected_resources = selected_resources + "|" + resid + "|";
		document.getElementById("selected_resources_id").value = selected_resources;
	}

	function doRemoveResource(){
		if(document.getElementById("selected_resources").selectedIndex == -1){
			alert("No Resource selected for Removal");
			return false;
		}
		var res_to_go = document.getElementById("selected_resources").options[document.getElementById("selected_resources").selectedIndex].value;
		document.getElementById("selected_resources").remove(document.getElementById("selected_resources").selectedIndex);
		
		var selected_resource = document.getElementById("selected_resources_id").value;

		selected_resource = selected_resource.replace("|" + res_to_go + "|", "");
		document.getElementById("selected_resources_id").value = selected_resource;
	}

</script>
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_DETAIL_INTRO');?><br /><?php echo JText::_('RS1_ADMIN_SEAT_TYPE_INTRO');?><br />
        </p>      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_ID');?>:</td>
      <td><?php echo $row->id ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_LABEL');?>:</td>
      <td><input type="text" size="20" maxsize="40" name="seat_type_label" id="seat_type_label" value="<?php echo stripslashes($row->seat_type_label); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_LABEL_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_TOOLTIP');?>:</td>
      <td valign="top"><input type="text" size="50" maxsize="255" name="seat_type_tooltip" id="seat_type_tooltip" value="<?php echo stripslashes($row->seat_type_tooltip); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_TOOLTIP_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_COST');?>:</td>
      <td valign="top"><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?>&nbsp;<input type="text" size="5" maxsize="10" name="seat_type_cost" id="seat_type_cost" value="<?php echo stripslashes($row->seat_type_cost); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_COST_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_HELP_TEXT');?>:</td>
      <td valign="top"><input type="text" size="50" maxsize="255" name="seat_type_help" id="seat_type_help" value="<?php echo stripslashes($row->seat_type_help); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_HELP_TEXT_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_GROUP');?>:</td>
      <td valign="top"><select name="seat_group" id="seat_group">
            <option value="No" <?php if($row->seat_group == "No"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="Yes" <?php if($row->seat_group == "Yes"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_GROUP_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_GROUP_MAX_SEATS');?>:</td>
      <td valign="top"><input type="text" size="2" maxsize="3" name="seat_group_max" id="seat_group_max" value="<?php echo stripslashes($row->seat_group_max); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_GROUP_MAX_SEATS_HELP');?>&nbsp;</td>
    </tr>
	<tr class="admin_detail_row0">
	  <td colspan="3" ><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_RESOURCES_INTRO');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_RESOURCES');?></td>
      <td >
      <table width="95%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="33%"><select name="resources" id="resources">
            <?php
			$k = 0;
			for($i=0; $i < count( $res_rows ); $i++) {
			$res_row = $res_rows[$i];
			?>
                <option value="<?php echo $res_row->id; ?>"><?php echo stripslashes($res_row->name); ?></option>
                <?php $k = 1 - $k; 
			} ?>
              </select></td>
            <td width="34%" valign="top" align="center"><input type="button" name="btnAddResource" id="btnAddResource" size="10" value="<?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_RESOURCES_ADD');?>" onclick="doAddResource()" />
              <br />
              &nbsp;<br />
              <input type="button" name="btnRemoveResource" id="btnRemoveResource" size="10"  onclick="doRemoveResource()" value="<?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_RESOURCES_REMOVE');?>" /></td>
            <td width="33%">
            <select name="selected_resources" id="selected_resources" size="4" >
             <?php
			$k = 0;
			for($i=0; $i < count( $res_assignment_rows ); $i++) {
			$res_assignment_row = $res_assignment_rows[$i];
			?>
                <option value="<?php echo $res_assignment_row->id; ?>"><?php echo $res_assignment_row->name; ?></option>
                <?php 
				$scope = $scope."|".$res_assignment_row->id."|";
				$k = 1 - $k; 
			} ?>
              </select><br /><?php echo JText::_('RS1_ADMIN_SCRN_EMPTY_ALL');?>            </td>
          </tr>
        </table></td>
    <td valign="top" width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_RESOURCES_HELP');?></td>
    </tr>
    <tr  class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_DETAIL_ORDER');?></td>
      <td colspan="2"><input type="text" size="5" maxsize="2" name="ordering" value="<?php echo $row->ordering; ?>" />
        &nbsp;&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_SEAT_TYPE_PUBLISHED');?></td>
        <td><select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3" ><br />
       
        <p>&nbsp;</p></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="scope" id="selected_resources_id" value="<?php echo $scope; ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }


function editExtra( $option, &$row ) {

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get resources 
	$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE published = 1";
	$database->setQuery($sql);
	$res_rows = $database -> loadObjectList();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	// get resource assignments 
	if (strlen($row->resource_scope) > 0 ){
		$res_assignments = str_replace("||", ",", $row->resource_scope);
		$res_assignments = str_replace("|", "", $res_assignments);
		//echo $admins;
		//exit;
		$sql = "SELECT id, name FROM #__sv_apptpro_resources WHERE ".
  			"id IN (".$res_assignments.")";
		$database->setQuery($sql);
		$res_assignment_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}	

?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<script language="javascript">
function submitbutton(pressbutton) {
   	if (pressbutton == 'save_extra'){
		if(document.getElementById("extras_label").value == ""){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_EXTRA_LABEL_REQ');?>");
		} else {
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}

	function doAddResource(){
		var resid = document.getElementById("resources").value;
		var selected_resources = document.getElementById("selected_resources_id").value;
		var x = document.getElementById("selected_resources");
		for (i=0;i<x.length;i++){
			if(x[i].value == resid) {
				alert("Already selected");
				return false;
			}			
		}
	
		var opt = document.createElement("option");
        // Add an Option object to Drop Down/List Box
        document.getElementById("selected_resources").options.add(opt); 
        opt.text = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].text;
        opt.value = document.getElementById("resources").options[document.getElementById("resources").selectedIndex].value;
		selected_resources = selected_resources + "|" + resid + "|";
		document.getElementById("selected_resources_id").value = selected_resources;
	}

	function doRemoveResource(){
		if(document.getElementById("selected_resources").selectedIndex == -1){
			alert("No Resource selected for Removal");
			return false;
		}
		var res_to_go = document.getElementById("selected_resources").options[document.getElementById("selected_resources").selectedIndex].value;
		document.getElementById("selected_resources").remove(document.getElementById("selected_resources").selectedIndex);
		
		var selected_resource = document.getElementById("selected_resources_id").value;

		selected_resource = selected_resource.replace("|" + res_to_go + "|", "");
		document.getElementById("selected_resources_id").value = selected_resource;
	}

</script>
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_DETAIL_INTRO');?><br /><?php echo JText::_('RS1_ADMIN_EXTRAS_INTRO');?><br />
        </p>      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_ID');?>:</td>
      <td><?php echo $row->id ?></td>
      <td width="50%">&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_LABEL');?>:</td>
      <td><input type="text" size="20" maxsize="40" name="extras_label" id="extras_label" value="<?php echo stripslashes($row->extras_label); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_LABEL_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_TOOLTIP');?>:</td>
      <td valign="top"><input type="text" size="50" maxsize="255" name="extras_tooltip" id="extras_tooltip" value="<?php echo stripslashes($row->extras_tooltip); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_TOOLTIP_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_COST');?>:</td>
      <td valign="top"><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?>&nbsp;<input type="text" size="5" maxsize="10" name="extras_cost" id="extras_cost" value="<?php echo stripslashes($row->extras_cost); ?>" />
      &nbsp;&nbsp;<?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_COST_PER');?> <select name="cost_unit">
          <option value="Hour" <?php if($row->cost_unit == "Hour"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_COST_HOUR');?></option>
          <option value="Flat" <?php if($row->cost_unit == "Flat"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_COST_BOOKING');?></option>
        </select>        </td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_COST_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_HELP_TEXT');?>:</td>
      <td valign="top"><input type="text" size="50" maxsize="255" name="extras_help" id="extras_help" value="<?php echo stripslashes($row->extras_help); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_HELP_TEXT_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_MAX_QUANTITY');?>:</td>
      <td valign="top"><input type="text" size="2" maxsize="3" name="max_quantity" id="max_quantity" value="<?php echo stripslashes($row->max_quantity); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_MAX_QUANTITY_HELP');?>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td valign="top"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_DEFAULT_QUANTITY');?>:</td>
      <td valign="top"><input type="text" size="2" maxsize="3" name="default_quantity" id="default_quantity" value="<?php echo stripslashes($row->default_quantity); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_DEFAULT_QUANTITY_HELP');?>&nbsp;</td>
    </tr>
	<tr class="admin_detail_row0">
	  <td colspan="3" ><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_RESOURCES_INTRO');?></td>
    </tr>
    <tr class="admin_detail_row0">
      <td ><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_RESOURCES');?>:</td>
      <td >
      <table width="95%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="33%"><select name="resources" id="resources">
            <?php
			$k = 0;
			for($i=0; $i < count( $res_rows ); $i++) {
			$res_row = $res_rows[$i];
			?>
                <option value="<?php echo $res_row->id; ?>"><?php echo stripslashes($res_row->name); ?></option>
                <?php $k = 1 - $k; 
			} ?>
              </select></td>
            <td width="34%" valign="top" align="center"><input type="button" name="btnAddResource" id="btnAddResource" size="10" value="<?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_RESOURCES_ADD');?>" onclick="doAddResource()" />
              <br />
              &nbsp;<br />
              <input type="button" name="btnRemoveResource" id="btnRemoveResource" size="10"  onclick="doRemoveResource()" value="<?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_RESOURCES_REMOVE');?>" /></td>
            <td width="33%">
            <select name="selected_resources" id="selected_resources" size="4" >
             <?php
			$k = 0;
			for($i=0; $i < count( $res_assignment_rows ); $i++) {
			$res_assignment_row = $res_assignment_rows[$i];
			?>
                <option value="<?php echo $res_assignment_row->id; ?>"><?php echo $res_assignment_row->name; ?></option>
                <?php 
				$scope = $scope."|".$res_assignment_row->id."|";
				$k = 1 - $k; 
			} ?>
              </select><br /><?php echo JText::_('RS1_ADMIN_SCRN_EMPTY_ALL');?>            </td>
          </tr>
        </table></td>
    <td valign="top" width="50%"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_RESOURCES_HELP');?></td>
    </tr>
    <tr  class="admin_detail_row1">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_DETAIL_ORDER');?></td>
      <td colspan="2"><input type="text" size="5" maxsize="2" name="ordering" value="<?php echo $row->ordering; ?>" />
        &nbsp;&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
        <td ><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS_PUBLISHED');?></td>
        <td><select name="published">
            <option value="0" <?php if($row->published == "0"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_NO');?></option>
            <option value="1" <?php if($row->published == "1"){echo " selected='selected' ";} ?>><?php echo JText::_('RS1_ADMIN_SCRN_YES');?></option>
            </select>        </td>
        <td>&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td colspan="3" ><br />
       
        <p>&nbsp;</p></td>
    </tr>  
  </table>
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="resource_scope" id="selected_resources_id" value="<?php echo $row->resource_scope; ?>" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }


function editCredit( $option, &$row ) {

	// get config stuff
	$database = &JFactory::getDBO();
	$sql = 'SELECT * FROM #__sv_apptpro_config';
	$database->setQuery($sql);
	$apptpro_config = NULL;
	$apptpro_config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
		return false;
	}

	if($row->id == ""){
		// get users 
		$sql = "SELECT id, name FROM #__users WHERE ".
		" id NOT IN (select user_id from #__sv_apptpro_user_credit)";
		$database->setQuery($sql);
		$users_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	} else {
		// get users 
		$sql = "SELECT id, name FROM #__users WHERE id = ".$row->user_id;
		$database->setQuery($sql);
		$users_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}

	// get activity
	if($row->user_id != ""){
		$sql = "SELECT #__sv_apptpro_user_credit_activity.*, #__users.name as operator, #__sv_apptpro_requests.startdate, ".
			"DATE_FORMAT(#__sv_apptpro_requests.startdate, '%b %e') as display_startdate, ".
			"DATE_FORMAT(#__sv_apptpro_requests.starttime, '%H:%i') as display_starttime, ".
			"#__sv_apptpro_resources.description as resource ".
			"FROM #__sv_apptpro_user_credit_activity ".
			"  INNER JOIN #__users ON #__sv_apptpro_user_credit_activity.operator_id = #__users.id ".
			"  LEFT OUTER JOIN #__sv_apptpro_requests ON #__sv_apptpro_user_credit_activity.request_id = #__sv_apptpro_requests.id ".
			"  LEFT OUTER JOIN #__sv_apptpro_resources ON #__sv_apptpro_requests.resource = #__sv_apptpro_resources.id ".
			"WHERE #__sv_apptpro_user_credit_activity.user_id = ".$row->user_id." ORDER BY stamp desc";
		$database->setQuery($sql);
		$activity_rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
	}
?>

<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm" >
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
<script language="javascript">
function submitbutton(pressbutton) {
   	if (pressbutton == 'save_credit'){
		if(document.getElementById("user_id").value == "-1"){
			alert("<?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_USER_REQ');?>");
		} else {
			submitform(pressbutton);
		}
	} else {
		submitform(pressbutton);
	}		
}
function setReqID(id){
	document.getElementById("xid").value = id;
	submitbutton('edit_direct_from_credit');
	return false;
}
</script>
  <table border="0" cellpadding="2" cellspacing="0">
    <tr>
      <td colspan="3">
        <p><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_DETAIL_INTRO');?><br /><?php echo JText::_('RS1_ADMIN_CREDIT_INTRO');?><br />
        </p>      </td>
    </tr>
    <tr class="admin_detail_row1">
      <td width="15%"><?php echo JText::_('ID');?>:</td>
      <td><?php echo $row->id ?></td>
      <td width="50%">&nbsp;</td>
    </tr>
    <tr class="admin_detail_row0">
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_ID');?>:</td>
      <td align="left"><?php echo $row->user_id ?></td>
      <td width="50%">&nbsp;</td>
    </tr>
    <tr class="admin_detail_row1">
      <td align="left"><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_USER_NAME');?>:</td>
      <?php if($row->id ==""){?>
      <td>
      <select name="user_id" id="user_id">
          <option value="-1"><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_SEL_USER');?></option>
            <?php
			$k = 0;
			for($i=0; $i < count( $users_rows ); $i++) {
			$users_row = $users_rows[$i];
			?>
                <option value="<?php echo $users_row->id; ?>"<?php if( $row->user_id == $users_row->id){echo " selected='selected' ";} ?>><?php echo stripslashes($users_row->name); ?></option>
                <?php $k = 1 - $k; 
			} ?>
        </select>
      </td>
		<td><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_SEL_USER_HELP');?>&nbsp;</td>
       <?php } else { ?>
       	<td colspan="2">
       		<input type="hidden" id="user_id" name="user_id" value="<?php echo $row->user_id; ?>" /><?php echo stripslashes($users_rows[0]->name); ?>
        </td>
       <?php } ?>
    </tr>
    <tr class="admin_detail_row0">
      <td valign="top" align="left"><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_BALANCE');?>:</td>
      <td valign="top"><?php echo JText::_('RS1_INPUT_SCRN_CURRENCY_SYMBOL');?>&nbsp;<input type="text" size="8" maxsize="10" name="balance" id="balance" value="<?php echo stripslashes($row->balance); ?>" /></td>
      <td><?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_BALANCE_HELP');?>&nbsp;</td>
    </tr>
  </table><br /><br />
  <hr />
  <?php echo JText::_('RS1_ADMIN_SCRN_CREDIT_ACTIVITY_INTRO');?><br />
  <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
	<thead>
    <tr>
      <th width="5%" class="title" align="center"><?php echo JText::_('RS1_ADMIN_SCRN_ID_COL_HEAD'); ?></th>
      <th class="title" align="left"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_COMMENT_COL_HEAD'); ?></th>
      <th class="title" align="center"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_BOOKING_COL_HEAD'); ?></th>
      <th class="title" align="center"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_INCREASE_COL_HEAD'); ?></th>
      <th class="title" align="center"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_DECREASE_COL_HEAD'); ?></th>
      <th class="title" align="center"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_BALANCE_COL_HEAD'); ?></th>
      <th width="5%" class="title" align="left"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_OPERATOR_COL_HEAD'); ?></th>
      <th class="title" align="left"><?php echo JText::_('RS1_ADMIN_CREDIT_ACTIVITY_TIMESTAMP_COL_HEAD'); ?></th>
    </tr>
    </thead>
    <?php
	$k = 0;
	for($i=0; $i < count( $activity_rows ); $i++) {
	$activity_row = $activity_rows[$i];
   ?>
    <tr class="<?php echo "row$k"; ?>">
      <td align="center"><?php echo $activity_row->id; ?>&nbsp;</td>
      <td align="left"><?php echo stripslashes($activity_row->comment); ?>&nbsp;</td>
      <?php if($activity_row->request_id != ""){ ?>
<!--      <td align="center">(<?php echo $activity_row->request_id; ?>)&nbsp;-->
      <td align="center">(<a href="#edit_transaction" onclick="setReqID(<?php echo $activity_row->request_id; ?>)"><?php echo $activity_row->request_id; ?>)</a>&nbsp;
	  <?php echo $activity_row->display_startdate."/".$activity_row->display_starttime; ?>&nbsp;- <?php echo stripslashes($activity_row->resource); ?></td>
      <?php } else { ?>
      <td align="center">&nbsp;</td>
      <?php } ?>
      <td align="center"><?php echo $activity_row->increase; ?>&nbsp;</td>
      <td align="center"><?php echo $activity_row->decrease; ?>&nbsp;</td>
      <td align="center"><?php echo $activity_row->balance; ?>&nbsp;</td>
      <td align="center"><?php echo $activity_row->operator; ?>&nbsp;</td>
      <td align="center"><?php echo $activity_row->stamp; ?></td>
      <?php $k = 1 - $k; ?>
    </tr>
    <?php } 
?>
  </table>
  
  <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
  <input type="hidden" name="option" value="<?php echo $option; ?>" />
 <input type="hidden" name="act" value="credit" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="xid" id="xid" value="" />
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>

<?php }


function util_menus( $option ) {
?>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">
<link href="../components/com_rsappt_pro14/sv_apptpro.css" rel="stylesheet">
  <tr>
    <td colspan="2"><h3><?php echo JText::_('RS1_ADMIN_SCRN_UTIL');?></h3></td>
  </tr>
</table>
<table border="1" cellpadding="4" cellspacing="0">
  
  <tr class="admin_detail_row1">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=seats"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_SEATS');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_SEATS_HELP');?></td>
  </tr>
  <tr class="admin_detail_row0">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=extras"><?php echo JText::_('RS1_ADMIN_SCRN_EXTRAS');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_EXTRAS_HELP');?></td>
  </tr>
  <tr class="admin_detail_row1">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=coupons"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_COUPONS');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_COUPONS_HELP');?></td>
  </tr>
  <tr class="admin_detail_row0">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=edit_css"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_EDIT_FILES');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_EDIT_FILES_HELP');?></td>
  </tr>
  <tr class="admin_detail_row1">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=backup"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_BACKUP');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_BACKUP_HELP');?></td>
  </tr>
  <tr class="admin_detail_row0">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=errorlog"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_ERR');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_ERR_HELP');?></td>
  </tr>
  <tr class="admin_detail_row1">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=reminderlog"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_REM');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_REM_HELP');?></td>
  </tr>
  <tr class="admin_detail_row0">
    <td><a href="index.php?option=com_rsappt_pro14&amp;act=about"><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_ABOUT');?></a></td>
    <td><?php echo JText::_('RS1_ADMIN_SCRN_UTIL_ABOUT_HELP');?></td>
  </tr>
</table>

  <input type="hidden" name="option" value="<?php echo $option; ?>" />
  <input type="hidden" name="task" id="task" value="" />
  <input type="hidden" name="act" value="utilities" />

  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>
</form>
<?php 

}

function control_panel(){

?>
<style type="text/css">
<!--
.icon-48-control { background-image: url(./components/com_rsappt_pro14/images/control.jpg); }
-->
}
</style>
<form action="index2.php" method="post" name="adminForm" id="adminForm" class="adminForm">

<table style="border: solid 1px #ECECEC">
	
	<tr>
    <td width="25%" align="right">
        <table width="90%" align="center" border="0" cellspacing="0" >
          <tr>
            <td align="right" style="border: 0px;"><img src="<?php echo "./components/com_rsappt_pro14/images/ABPro_logo100.jpg"?>" /></td>
          </tr>
          <tr style="border:solid 1px #CCCCCC;">
            <td align="right">&nbsp;</td>
          </tr>
          <tr style="border:solid 1px #CCCCCC;">
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=all"><?php echo JText::_('RS1_ADMIN_MENU_APPOINTMENTS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=categories"><?php echo JText::_('RS1_ADMIN_MENU_CATEGORIES');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=resources"><?php echo JText::_('RS1_ADMIN_MENU_RESOURCES');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=services"><?php echo JText::_('RS1_ADMIN_MENU_SERVICES');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=ts_setup"><?php echo JText::_('RS1_ADMIN_MENU_TIMESLOTS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=bookoffs"><?php echo JText::_('RS1_ADMIN_MENU_BOOKOFFS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=udfs"><?php echo JText::_('RS1_ADMIN_MENU_UDFS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=coupons"><?php echo JText::_('RS1_ADMIN_MENU_COUPONS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=configure"><?php echo JText::_('RS1_ADMIN_MENU_CONFIGURE');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=transactions"><?php echo JText::_('RS1_ADMIN_MENU_PAYPAL');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=seats"><?php echo JText::_('RS1_ADMIN_MENU_SEATS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=credit"><?php echo JText::_('RS1_ADMIN_MENU_CREDIT');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=extras"><?php echo JText::_('RS1_ADMIN_MENU_EXTRAS');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=edit_css"><?php echo JText::_('RS1_ADMIN_MENU_EDITFILES');?></a></td>
          </tr>
            <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=backup"><?php echo JText::_('RS1_ADMIN_MENU_BACKUP');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=errorlog"><?php echo JText::_('RS1_ADMIN_MENU_ERRLOG');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=reminderlog"><?php echo JText::_('RS1_ADMIN_MENU_REMLOG');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=activitylog"><?php echo JText::_('RS1_ADMIN_MENU_ACTIVITYLOG');?></a></td>
          </tr>
          <tr>
            <td align="right"><a href="index.php?option=com_rsappt_pro14&amp;act=about"><?php echo JText::_('RS1_ADMIN_MENU_ABOUT');?></a></td>
          </tr>
          <tr>
            <td align="right">&nbsp;</td>
          </tr>
      </table>	</td>
    <td valign="top" align="center">
        <table width="90%" border="0" cellspacing="0" cellpadding="5" >
          <tr>
            <td valign="bottom" width="100" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=all"><img src="<?php echo "./components/com_rsappt_pro14/images/bookings.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=all"><?php echo JText::_('RS1_ADMIN_MENU_APPOINTMENTS');?></a></td>
            <td valign="bottom" width="100" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=categories"><img src="<?php echo "./components/com_rsappt_pro14/images/pad.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=categories"><?php echo JText::_('RS1_ADMIN_MENU_CATEGORIES');?></a></td>
            <td valign="bottom" width="100" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=resources"><img src="<?php echo "./components/com_rsappt_pro14/images/resources.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=resources"><?php echo JText::_('RS1_ADMIN_MENU_RESOURCES');?></a></td>
            <td valign="bottom" width="100" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=services"><img src="<?php echo "./components/com_rsappt_pro14/images/pad.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=services"><?php echo JText::_('RS1_ADMIN_MENU_SERVICES');?></a></td>
            <td valign="bottom" width="100" class="icon" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=ts_setup"><img src="<?php echo "./components/com_rsappt_pro14/images/timeslots.jpg"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=ts_setup"><?php echo JText::_('RS1_ADMIN_MENU_TIMESLOTS');?></a></td>
          </tr>
          <tr>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=bookoffs"><img src="<?php echo "./components/com_rsappt_pro14/images/bookoffs.jpg"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=bookoffs"><?php echo JText::_('RS1_ADMIN_MENU_BOOKOFFS');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=udfs"><img src="<?php echo "./components/com_rsappt_pro14/images/udf.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=udfs"><?php echo JText::_('RS1_ADMIN_MENU_UDFS');?></a></td> 
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=coupons"><img src="<?php echo "./components/com_rsappt_pro14/images/coupon.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=coupons"><?php echo JText::_('RS1_ADMIN_MENU_COUPONS');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=configure"><img src="<?php echo "./components/com_rsappt_pro14/images/configure.jpg"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=configure"><?php echo JText::_('RS1_ADMIN_MENU_CONFIGURE');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=transactions"><img src="<?php echo "./components/com_rsappt_pro14/images/pay.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=transactions"><?php echo JText::_('RS1_ADMIN_MENU_PAYPAL');?></a></td>
          </tr>
          <tr>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=seats"><img src="<?php echo "./components/com_rsappt_pro14/images/seats.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=seats"><?php echo JText::_('RS1_ADMIN_MENU_SEATS');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center">&nbsp;</td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=credit"><img src="<?php echo "./components/com_rsappt_pro14/images/vault.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=credit"><?php echo JText::_('RS1_ADMIN_MENU_CREDIT');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center">&nbsp;</td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=extras"><img src="<?php echo "./components/com_rsappt_pro14/images/extras.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=extras"><?php echo JText::_('RS1_ADMIN_MENU_EXTRAS');?></a></td>
          </tr>
          <tr>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=edit_css"><img src="<?php echo "./components/com_rsappt_pro14/images/log.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=edit_css"><?php echo JText::_('RS1_ADMIN_MENU_EDITFILES');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=backup"><img src="<?php echo "./components/com_rsappt_pro14/images/backup.png"?>" /></a><br />
              <a href="index.php?option=com_rsappt_pro14&amp;act=backup"><?php echo JText::_('RS1_ADMIN_MENU_BACKUP');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=errorlog"><img src="<?php echo "./components/com_rsappt_pro14/images/log.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=errorlog"><?php echo JText::_('RS1_ADMIN_MENU_ERRLOG');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=reminderlog"><img src="<?php echo "./components/com_rsappt_pro14/images/log.png"?>" /></a><br /><a href="index.php?option=com_rsappt_pro14&amp;act=reminderlog"><?php echo JText::_('RS1_ADMIN_MENU_REMLOG');?></a></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=activitylog"><img src="<?php echo "./components/com_rsappt_pro14/images/log.png"?>" /></a><br />
            <a href="index.php?option=com_rsappt_pro14&amp;act=activitylog"><?php echo JText::_('RS1_ADMIN_MENU_ACTIVITYLOG');?></a></td>
          </tr>
          <tr>
            <td valign="middle" style="border: solid 1px #ECECEC" align="center" colspan="4"><?php echo JText::_('RS1_ADMIN_CONTROL_FOOTER');?></td>
            <td valign="bottom" style="border: solid 1px #ECECEC" align="center"><a href="index.php?option=com_rsappt_pro14&amp;act=about"><img src="<?php echo "./components/com_rsappt_pro14/images/about.png"?>" /></a><br />
            <a href="index.php?option=com_rsappt_pro14&amp;act=about"><?php echo JText::_('RS1_ADMIN_MENU_ABOUT');?></a></td>
          </tr>
        </table>	  
        <br /></td>
    </tr>
</table>
<hr>
  <br />
  <span style="font-size:10px"> Appointment Booking Pro Ver. 1.4.6 - Copyright 2008-20<?php echo date("y");?> - <a href='http://www.softventures.com' target="_blank">Soft Ventures, Inc.</a></span>

<?php 
}

}
?>
